;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
DELAYTEMP2	EQU	113
SysCalcTempA	EQU	117
SysCalcTempB	EQU	121
SysCalcTempX	EQU	112
SysWaitTempMS	EQU	114
SysWaitTempMS_H	EQU	115
I	EQU	32
PATTERN	EQU	33

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;A program to make chaser lights on the five red LEDs,
;stepping every 1/10th of a second. Connect GP0
;through GP2, and GP4 and GP5 to LED1 through
;LED5, respectively.
;----- Setup
;----- Constants
;#define LEDs GPIO				;GP3 is input only, so ignored
;----- Variables
;dim pattern, i as byte
;----- Program
;dir LEDs out	         	;make most pins outputs
	banksel	TRISIO
	clrf	TRISIO
;do
SysDoLoop_S1
;pattern = 1						;start with the first LED
	movlw	1
	banksel	PATTERN
	movwf	PATTERN
;LEDs = pattern        ;turn it on
	movwf	GPIO
;wait 100 ms         	;pause a bit
	movlw	100
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;for i = 1 to 4      	;step across the next four LEDs
	clrf	I
SysForLoop1
	incf	I,F
;pattern = 2*pattern	;shift left to next bit
	movlw	2
	movwf	SysCalcTempA
	movf	PATTERN,W
	movwf	SysCalcTempB
	call	SysMultSub
	movf	SysCalcTempX,W
	movwf	PATTERN
;if pattern = 8 then	;skip GP3 which is input only
	movlw	8
	subwf	PATTERN,W
	btfss	STATUS, Z
	goto	ENDIF1
;pattern = 16
	movlw	16
	movwf	PATTERN
;end if
ENDIF1
;LEDs = pattern			;update the LEDs
	movf	PATTERN,W
	movwf	GPIO
;wait 100 ms       	;pause to enjoy
	movlw	100
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;next i
	movlw	4
	subwf	I,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
;loop                  	;repeat in perpetuity
	goto	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	4
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	165
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

SYSMULTSUB
;dim SysCalcTempA as byte
;dim SysCalcTempB as byte
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
MUL8LOOP
;movf SysCalcTempA, W
	movf	SYSCALCTEMPA, W
;btfsc SysCalcTempB, 0
	btfsc	SYSCALCTEMPB, 0
;addwf SysCalcTempX, F
	addwf	SYSCALCTEMPX, F
;bcf STATUS, C
	bcf	STATUS, C
;rrf SysCalcTempB, F
	rrf	SYSCALCTEMPB, F
;bcf STATUS, C
	bcf	STATUS, C
;rlf SysCalcTempA, F
	rlf	SYSCALCTEMPA, F
;movf SysCalcTempB, F
	movf	SYSCALCTEMPB, F
;btfss STATUS, Z
	btfss	STATUS, Z
;goto MUL8LOOP
	goto	MUL8LOOP
	return

;********************************************************************************


 END
