;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
DELAYTEMP2	EQU	113
SYSCALCTEMPX	EQU	112
SysCalcTempA	EQU	117
SysCalcTempB	EQU	121
SysWaitTempMS	EQU	114
SysWaitTempMS_H	EQU	115
SysWaitTempS	EQU	116
I	EQU	32
LSN	EQU	33
MSN	EQU	34
SysTemp1	EQU	35

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;A program to count in binary on the five red LEDs.
;Connect GP0 through GP2, and GP4 and GP5
;to LED1 through LED5, respectively.
;----- Setup
;----- Constants
;#define LEDs GPIO      	;GP3 is input only, so ignored
;----- Variables
;dim i, msn, lsn as byte	;most and least significant nibbles
;;----- Program
;dir LEDs out				  	;make most pins outputs
	banksel	TRISIO
	clrf	TRISIO
;do
SysDoLoop_S1
;for i = 0 to 31    		;count from 0 to 31
	movlw	255
	banksel	I
	movwf	I
SysForLoop1
	incf	I,F
;msn = 2*i & 0xF0		;squeeze out GP3
	movlw	2
	movwf	SysCalcTempA
	movf	I,W
	movwf	SysCalcTempB
	call	SysMultSub
	movlw	240
	andwf	SYSCALCTEMPX,W
	movwf	MSN
;lsn = i & 0x07			;least significant nibble
	movlw	7
	andwf	I,W
	movwf	LSN
;lsn = lsn | msn			;factor in msn
	iorwf	MSN,W
	movwf	LSN
;LEDs = lsn       		;send to LEDs
	movwf	GPIO
;wait 1 s          	;wait a second
	movlw	1
	movwf	SysWaitTempS
	call	Delay_S
;next i
	movlw	31
	subwf	I,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
;loop                  	;repeat in perpetuity
	goto	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	4
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	165
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

Delay_S
DS_START
	movlw	232
	movwf	SysWaitTempMS
	movlw	3
	movwf	SysWaitTempMS_H
	call	Delay_MS
	decfsz	SysWaitTempS, F
	goto	DS_START
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

SYSMULTSUB
;dim SysCalcTempA as byte
;dim SysCalcTempB as byte
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
MUL8LOOP
;movf SysCalcTempA, W
	movf	SYSCALCTEMPA, W
;btfsc SysCalcTempB, 0
	btfsc	SYSCALCTEMPB, 0
;addwf SysCalcTempX, F
	addwf	SYSCALCTEMPX, F
;bcf STATUS, C
	bcf	STATUS, C
;rrf SysCalcTempB, F
	rrf	SYSCALCTEMPB, F
;bcf STATUS, C
	bcf	STATUS, C
;rlf SysCalcTempA, F
	rlf	SYSCALCTEMPA, F
;movf SysCalcTempB, F
	movf	SYSCALCTEMPB, F
;btfss STATUS, Z
	btfss	STATUS, Z
;goto MUL8LOOP
	goto	MUL8LOOP
	return

;********************************************************************************


 END
