;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
DELAYTEMP2	EQU	113
SYSCALCTEMPX	EQU	112
SYSCALCTEMPX_H	EQU	113
SysCalcTempA	EQU	117
SysCalcTempA_H	EQU	118
SysCalcTempB	EQU	121
SysCalcTempB_H	EQU	122
SysWaitTempMS	EQU	114
SysWaitTempMS_H	EQU	115
LSN	EQU	32
MSN	EQU	33
RANDOM	EQU	34
RANDOMSEED	EQU	35
RANDOMSEED_H	EQU	36
RANDOMTEMP	EQU	38
RANDOMTEMP_H	EQU	39
SysRepeatTemp1	EQU	40
SysTemp1	EQU	41
SysTemp1_H	EQU	42
SysTemp2	EQU	43
SysTemp2_H	EQU	44
TEMP	EQU	45

;********************************************************************************

;Alias variables
TIMER0	EQU	TMR0

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS
	call	INITRANDOM

;Start of the main program
;A program to display random lights on the five red LEDs.
;Connect GP0 through GP2, and GP4 and GP5
;to LED1 through LED5, respectively.
;----- Setup
;----- Constants
;#define LEDs GPIO      	;GP3 is input only, so ignored
;----- Variables
;dim temp, msn, lsn as byte
;;----- Program
;dir LEDs out				  	;make most pins outputs
	banksel	TRISIO
	clrf	TRISIO
;randomize								;seed the random number generator
	banksel	TIMER0
	movf	TIMER0,W
	movwf	RANDOMTEMP
	clrf	RANDOMTEMP_H
	call	RANDOMIZE
;do
SysDoLoop_S1
;temp = random					;get a random byte
	call	FN_RANDOM
	movf	RANDOM,W
	movwf	TEMP
;msn = 2*temp & 0xF0		;squeeze out GP3
	movlw	2
	movwf	SysCalcTempA
	movf	TEMP,W
	movwf	SysCalcTempB
	call	SysMultSub
	movlw	240
	andwf	SYSCALCTEMPX,W
	movwf	MSN
;lsn = temp & 0x07			;least significant nibble
	movlw	7
	andwf	TEMP,W
	movwf	LSN
;lsn = lsn | msn				;factor in msn
	iorwf	MSN,W
	movwf	LSN
;LEDs = temp
	movf	TEMP,W
	movwf	GPIO
;wait 200 mS        		;wait a bit
	movlw	200
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;loop                  	;repeat in perpetuity
	goto	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	4
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	165
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

INITRANDOM
;Dim RandomSeed As Word
;RandomSeed = RandStart
	movlw	11
	movwf	RANDOMSEED
	movlw	224
	movwf	RANDOMSEED_H
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

FN_RANDOM
;Repeat 7
	movlw	7
	movwf	SysRepeatTemp1
SysRepeatLoop1
;Dim RandomTemp As Word
;Dim RandomSeed As Word
;RandomTemp = RandomSeed
	movf	RANDOMSEED,W
	movwf	RANDOMTEMP
	movf	RANDOMSEED_H,W
	movwf	RANDOMTEMP_H
;Rotate RandomTemp Left Simple
	rlf	RANDOMTEMP_H,W
	rlf	RANDOMTEMP,F
	rlf	RANDOMTEMP_H,F
;RandomSeed = RandomTemp XOR (Not (RandomSeed And 1) + 1 And 0xB400)
	movlw	1
	andwf	RANDOMSEED,W
	movwf	SysTemp1
	clrf	SysTemp1_H
	comf	SysTemp1,W
	movwf	SysTemp2
	comf	SysTemp1_H,W
	movwf	SysTemp2_H
	movlw	1
	addwf	SysTemp2,W
	movwf	SysTemp1
	movf	SysTemp2_H,W
	btfsc	STATUS,C
	addlw	1
	movwf	SysTemp1_H
	clrf	SysTemp2
	movlw	180
	andwf	SysTemp1_H,W
	movwf	SysTemp2_H
	movf	RANDOMTEMP,W
	xorwf	SysTemp2,W
	movwf	RANDOMSEED
	movf	RANDOMTEMP_H,W
	xorwf	SysTemp2_H,W
	movwf	RANDOMSEED_H
;Random = Random Xor RandomSeed_H
	movf	RANDOM,W
	xorwf	RANDOMSEED_H,W
	movwf	RANDOM
;End Repeat
	decfsz	SysRepeatTemp1,F
	goto	SysRepeatLoop1
SysRepeatLoopEnd1
	return

;********************************************************************************

RANDOMIZE
;Dim RandomSeed As Word
;RandomSeed += RandomTemp
	movf	RANDOMTEMP,W
	addwf	RANDOMSEED,F
	movf	RANDOMTEMP_H,W
	btfsc	STATUS,C
	addlw	1
	addwf	RANDOMSEED_H,F
;If RandomSeed = 0 Then RandomSeed = 1
	movf	RANDOMSEED,W
	movwf	SysCalcTempA
	movf	RANDOMSEED_H,W
	movwf	SysCalcTempA_H
	clrf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysCompEqual16
	btfss	SysCalcTempX,0
	goto	ENDIF1
	movlw	1
	movwf	RANDOMSEED
	clrf	RANDOMSEED_H
ENDIF1
	return

;********************************************************************************

SYSCOMPEQUAL16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA, W
	movf	SYSCALCTEMPA, W
;subwf SysCalcTempB, W
	subwf	SYSCALCTEMPB, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;movf SysCalcTempA_H, W
	movf	SYSCALCTEMPA_H, W
;subwf SysCalcTempB_H, W
	subwf	SYSCALCTEMPB_H, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSMULTSUB
;dim SysCalcTempA as byte
;dim SysCalcTempB as byte
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
MUL8LOOP
;movf SysCalcTempA, W
	movf	SYSCALCTEMPA, W
;btfsc SysCalcTempB, 0
	btfsc	SYSCALCTEMPB, 0
;addwf SysCalcTempX, F
	addwf	SYSCALCTEMPX, F
;bcf STATUS, C
	bcf	STATUS, C
;rrf SysCalcTempB, F
	rrf	SYSCALCTEMPB, F
;bcf STATUS, C
	bcf	STATUS, C
;rlf SysCalcTempA, F
	rlf	SYSCALCTEMPA, F
;movf SysCalcTempB, F
	movf	SYSCALCTEMPB, F
;btfss STATUS, Z
	btfss	STATUS, Z
;goto MUL8LOOP
	goto	MUL8LOOP
	return

;********************************************************************************


 END
