;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
DELAYTEMP2	EQU	113
SysWaitTempMS	EQU	114
SysWaitTempMS_H	EQU	115
DOPWM	EQU	32
PWMCHANNEL	EQU	33
PWMDUR	EQU	34
SOFTPWMCYCLES	EQU	35
SOFTPWMDUTY	EQU	36
WIDTH	EQU	37

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;A program to fade a single LED on and off using software PWM.
;Connect GP0 to LED1.
;----- Settings
;----- Constants
;#define PWM_Out1 GPIO.0   ;PWM output on pin 7
;----- Variables
;dim width as byte
;----- Program
;dir PWM_Out1 out         	;make this an output
	banksel	TRISIO
	bcf	TRISIO,0
;do
SysDoLoop_S1
;for width = 0 to 255   	;this spans 0% to 100%
	movlw	255
	banksel	WIDTH
	movwf	WIDTH
SysForLoop1
	incf	WIDTH,F
;PWMOut(1, width, 1)  	;channel 1, duty cycle, cycles
	movlw	1
	movwf	PWMCHANNEL
	movf	WIDTH,W
	movwf	SOFTPWMDUTY
	movlw	1
	movwf	SOFTPWMCYCLES
	call	PWMOUT
;wait 1 mS
	movlw	1
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;next
	movlw	255
	subwf	WIDTH,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
;for width = 254 to 0   	;this spans 100% to 0%
	movlw	255
	movwf	WIDTH
SysForLoop2
	decf	WIDTH,F
;PWMOut(1, width, 1)  	;channel 1, duty cycle, cycles
	movlw	1
	movwf	PWMCHANNEL
	movf	WIDTH,W
	movwf	SOFTPWMDUTY
	movlw	1
	movwf	SOFTPWMCYCLES
	call	PWMOUT
;wait 1 mS
	movlw	1
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;next
	movf	WIDTH,W
	sublw	0
	btfss	STATUS, C
	goto	SysForLoop2
SysForLoopEnd2
;wait 500 mS           	;show full off for a while	
	movlw	244
	movwf	SysWaitTempMS
	movlw	1
	movwf	SysWaitTempMS_H
	call	Delay_MS
;loop                     	;repeat in perpetuity
	goto	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	4
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	165
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

PWMOUT
;For PWMDur = 1 to SoftPWMCycles
	clrf	PWMDUR
	movlw	1
	subwf	SOFTPWMCYCLES,W
	btfss	STATUS, C
	goto	SysForLoopEnd3
SysForLoop3
	incf	PWMDUR,F
;For DOPWM = 1 to 255
	clrf	DOPWM
SysForLoop4
	incf	DOPWM,F
;if SoftPWMDuty > DOPWM then
	movf	SOFTPWMDUTY,W
	subwf	DOPWM,W
	btfsc	STATUS, C
	goto	ELSE4_1
;if PWMChannel = 1 then set PWM_Out1 ON
	decf	PWMCHANNEL,W
	btfsc	STATUS, Z
	bsf	GPIO,0
;Else
	goto	ENDIF4
ELSE4_1
;if PWMChannel = 1 then set PWM_Out1 OFF
	decf	PWMCHANNEL,W
	btfsc	STATUS, Z
	bcf	GPIO,0
;end if
ENDIF4
;next
	movlw	255
	subwf	DOPWM,W
	btfss	STATUS, C
	goto	SysForLoop4
SysForLoopEnd4
;next
	movf	SOFTPWMCYCLES,W
	subwf	PWMDUR,W
	btfss	STATUS, C
	goto	SysForLoop3
SysForLoopEnd3
	return

;********************************************************************************


 END
