;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
DELAYTEMP2	EQU	113
SysCalcTempA	EQU	117
SysCalcTempB	EQU	121
SysCalcTempX	EQU	112
SysDivLoop	EQU	116
SysWaitTempMS	EQU	114
SysWaitTempMS_H	EQU	115
CURRENT	EQU	32
PREV	EQU	33

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;A program to toggle red or green under pushbutton control.
;Connect GP0 to red element, GP1 to green element.
;Connect GP2 and GP3 to Button 1 and 2, respectively.
;----- Settings
;----- Constants
;#define red GP0       			;red LED element on GP0
;#define green GP1     			;green LED element on GP1
;#define button1 GP2					;red switch
;#define button2 GP3					;green switch
;----- Variables
;dim prev, current as byte		
;----- Program
;dir GPIO 0b11111100    			;two inputs and two outputs
	movlw	252
	banksel	TRISIO
	movwf	TRISIO
;prev = 0b01									;begin with red
	movlw	1
	banksel	PREV
	movwf	PREV
;GPIO = prev
	movwf	GPIO
;do
SysDoLoop_S1
;current = GPIO/4					;read entire port, shift  right
	movf	GPIO,W
	movwf	SysCalcTempA
	movlw	4
	movwf	SysCalcTempB
	call	SysDivSub
	movf	SysCalcTempA,W
	movwf	CURRENT
;current = !current				;buttons use negative logic
	comf	CURRENT,F
;current = current & 0b00000011	;strip off garbage
	movlw	3
	andwf	CURRENT,F
;if current <> 0 then			;a button is pressed
	movf	CURRENT,F
	btfsc	STATUS, Z
	goto	ENDIF1
;if current <> prev then	;only activate when different
	movf	PREV,W
	subwf	CURRENT,W
	btfsc	STATUS, Z
	goto	ENDIF2
;GPIO = current				;update the LEDs
	movf	CURRENT,W
	movwf	GPIO
;prev = current				;a new previous value
	movf	CURRENT,W
	movwf	PREV
;pause 50							;debounce
;Wait Time ms
	movlw	50
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;do										;wait until no button pressed
SysDoLoop_S2
;loop until GPIO >= 0b1100
	movlw	12
	subwf	GPIO,W
	btfss	STATUS, C
	goto	SysDoLoop_S2
SysDoLoop_E2
;pause 50							;debounce some more
;Wait Time ms
	movlw	50
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;end if
ENDIF2
;end if	
ENDIF1
;loop                    		;repeat in perpetuity
	goto	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	4
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	165
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

SYSDIVSUB
;dim SysCalcTempA as byte
;dim SysCalcTempB as byte
;dim SysCalcTempX as byte
;SysCalcTempX = 0
	clrf	SYSCALCTEMPX
;SysDivLoop = 8
	movlw	8
	movwf	SYSDIVLOOP
SYSDIV8START
;bcf STATUS, C
	bcf	STATUS, C
;rlf SysCalcTempA, F
	rlf	SYSCALCTEMPA, F
;rlf SysCalcTempX, F
	rlf	SYSCALCTEMPX, F
;movf SysCalcTempB, W
	movf	SYSCALCTEMPB, W
;subwf SysCalcTempX, F
	subwf	SYSCALCTEMPX, F
;bsf SysCalcTempA, 0
	bsf	SYSCALCTEMPA, 0
;btfsc STATUS, C
	btfsc	STATUS, C
;goto Div8NotNeg
	goto	DIV8NOTNEG
;bcf SysCalcTempA, 0
	bcf	SYSCALCTEMPA, 0
;movf SysCalcTempB, W
	movf	SYSCALCTEMPB, W
;addwf SysCalcTempX, F
	addwf	SYSCALCTEMPX, F
DIV8NOTNEG
;decfsz SysDivLoop, F
	decfsz	SYSDIVLOOP, F
;goto SysDiv8Start
	goto	SYSDIV8START
	return

;********************************************************************************


 END
