;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DUTY	EQU	32
I	EQU	33
J	EQU	34

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;A program to fade from green to yellow to red and back again.
;Connect GP0 to red element and GP1 to green element.
;We'll create a complementary PWM here.
;----- Settings
;----- Constants
;#define red			GP0						;red element on pin 7
;#define green		GP1      			;green element on pin 6
;#define cycles	5							;# of cycles of each step
;----- Variables
;dim i, j, duty as byte
;----- Program
;dir GPIO 0b11111100      			;two outputs
	movlw	252
	banksel	TRISIO
	movwf	TRISIO
;do
SysDoLoop_S1
;for duty = 1 to 100					;from full green to full red
	banksel	DUTY
	clrf	DUTY
SysForLoop1
	incf	DUTY,F
;for i = 1 to cycles				;how many cycles at this width
	clrf	I
SysForLoop2
	incf	I,F
;compPWM(duty)						;create the outputs
	call	COMPPWM
;next i
	movlw	5
	subwf	I,W
	btfss	STATUS, C
	goto	SysForLoop2
SysForLoopEnd2
;next duty	
	movlw	100
	subwf	DUTY,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
;for duty = 99 to 0					;now go in reverse
	movlw	100
	movwf	DUTY
SysForLoop3
	decf	DUTY,F
;for i = 1 to cycles				
	clrf	I
SysForLoop4
	incf	I,F
;compPWM(duty)						
	call	COMPPWM
;next i
	movlw	5
	subwf	I,W
	btfss	STATUS, C
	goto	SysForLoop4
SysForLoopEnd4
;next duty		
	movf	DUTY,W
	sublw	0
	btfss	STATUS, C
	goto	SysForLoop3
SysForLoopEnd3
;loop                    			;repeat in perpetuity
	goto	SysDoLoop_S1
SysDoLoop_E1
;----- Subroutine
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

COMPPWM
;for j = 0 to 99							
	movlw	255
	movwf	J
SysForLoop5
	incf	J,F
;if j < duty then					;on portion
	movf	DUTY,W
	subwf	J,W
	btfsc	STATUS, C
	goto	ELSE5_1
;set red on							;main signal
	bsf	GPIO,GP0
;set green off						;and its complement
	bcf	GPIO,GP1
;else
	goto	ENDIF5
ELSE5_1
;set green on						;off portion
	bsf	GPIO,GP1
;set red off
	bcf	GPIO,GP0
;end if	
ENDIF5
;next j
	movlw	99
	subwf	J,W
	btfss	STATUS, C
	goto	SysForLoop5
SysForLoopEnd5
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************


 END
