;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
SysWaitTemp10US	EQU	117
ADREADPORT	EQU	32
ADTEMP	EQU	33
DUTY	EQU	34
J	EQU	35
READAD	EQU	36

;********************************************************************************

;Alias variables
ALLANSEL	EQU	ANSEL

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;A program to change LED color under pot control.
;Connect GP0 to red element, GP1 to green element and
;AN2/GP2 to potentiometer.
;----- Settings
;----- Constants
;#define red			GP0						;red element on pin 7
;#define green		GP1      			;green element on pin 6
;#define pot			AN2
;----- Variables
;dim j, duty as byte
;----- Program
;dir GPIO 0b11111100      			;two outputs, 1 input
	movlw	252
	banksel	TRISIO
	movwf	TRISIO
;do
SysDoLoop_S1
;duty = readAD(pot)					;get pot reading
	movlw	2
	banksel	ADREADPORT
	movwf	ADREADPORT
	call	FN_READAD
	movf	READAD,W
	movwf	DUTY
;compPWM(duty)								;create the outputs
	call	COMPPWM
;loop                    			;repeat in perpetuity
	goto	SysDoLoop_S1
SysDoLoop_E1
;----- Subroutine
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

COMPPWM
;for j = 0 to 254							
	movlw	255
	movwf	J
SysForLoop1
	incf	J,F
;if j < duty then					;on portion
	movf	DUTY,W
	subwf	J,W
	btfsc	STATUS, C
	goto	ELSE1_1
;set red on							;main signal
	bsf	GPIO,GP0
;set green off						;and its complement
	bcf	GPIO,GP1
;else
	goto	ENDIF1
ELSE1_1
;set green on						;off portion
	bsf	GPIO,GP1
;set red off
	bcf	GPIO,GP0
;end if	
ENDIF1
;next j
	movlw	254
	subwf	J,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
	return

;********************************************************************************

Delay_10US
D10US_START
	movlw	5
	movwf	DELAYTEMP
DelayUS0
	decfsz	DELAYTEMP,F
	goto	DelayUS0
	nop
	decfsz	SysWaitTemp10US, F
	goto	D10US_START
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

FN_READAD
;Set up for 8 bit
;Perform conversion
;LLReadAD
;Dim AllANSEL As Byte Alias ANSEL
;AllANSEL = 0
	banksel	ALLANSEL
	clrf	ALLANSEL
;ADTemp = ADReadPort + 1
	banksel	ADREADPORT
	incf	ADREADPORT,W
	movwf	ADTEMP
;Set C On
	bsf	STATUS,C
;Do
SysDoLoop_S2
;Rotate AllANSEL Left
	banksel	ALLANSEL
	rlf	ALLANSEL,F
;decfsz ADTemp,F
	banksel	ADTEMP
	decfsz	ADTEMP,F
;Loop
	goto	SysDoLoop_S2
SysDoLoop_E2
;SET ADCS1 OFF
	banksel	ANSEL
	bcf	ANSEL,ADCS1
;SET ADCS0 ON
	bsf	ANSEL,ADCS0
;SET ADCON0.CHS0 OFF
	banksel	ADCON0
	bcf	ADCON0,CHS0
;SET ADCON0.CHS1 OFF
	bcf	ADCON0,CHS1
;IF ADReadPort.0 On Then Set ADCON0.CHS0 On
	btfsc	ADREADPORT,0
	bsf	ADCON0,CHS0
;IF ADReadPort.1 On Then Set ADCON0.CHS1 On
	btfsc	ADREADPORT,1
	bsf	ADCON0,CHS1
;SET ADCON0.ADON ON
	bsf	ADCON0,ADON
;Wait AD_Delay
	movlw	2
	movwf	SysWaitTemp10US
	call	Delay_10US
;SET ADCON0.GO_DONE ON
	bsf	ADCON0,GO_DONE
;Wait While ADCON0.GO_DONE ON
SysWaitLoop1
	btfsc	ADCON0,GO_DONE
	goto	SysWaitLoop1
;SET ADCON0.ADON OFF
	bcf	ADCON0,ADON
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;Write output
;ReadAD = ADRESH
	banksel	ADRESH
	movf	ADRESH,W
	movwf	READAD
	return

;********************************************************************************


 END
