;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
SYSCALCTEMPA	EQU	117
SysCalcTempB	EQU	121
SysCalcTempX	EQU	112
SysDivLoop	EQU	116
DUTY	EQU	32
I	EQU	33
J	EQU	34
SysTemp1	EQU	35

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;A program to change LED color in 16 discrete steps
;by means of the rotary decoder switch. Connect GP0 to
;red element, GP1 to green element, and GP2 through GP5
;to decoder switch pins 1 through 4, respectively.
;----- Settings
;----- Constants
;#define red			GP0						;red element on pin 7
;#define green		GP1      			;green element on pin 6
;----- Variables
;dim i, j, duty as byte
;----- Program
;dir GPIO 0b11111100      			;two outputs, 4 inputs
	movlw	252
	banksel	TRISIO
	movwf	TRISIO
;do
SysDoLoop_S1
;duty = GPIO/4 & 0b00001111	;read the decoder
	banksel	GPIO
	movf	GPIO,W
	movwf	SysCalcTempA
	movlw	4
	movwf	SysCalcTempB
	call	SysDivSub
	movlw	15
	andwf	SYSCALCTEMPA,W
	movwf	DUTY
;compPWM(duty)								;create the outputs
	call	COMPPWM
;loop                    			;repeat in perpetuity
	goto	SysDoLoop_S1
SysDoLoop_E1
;----- Subroutine
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

COMPPWM
;for i = 1 to 16
	clrf	I
SysForLoop1
	incf	I,F
;for j = 0 to 14							
	movlw	255
	movwf	J
SysForLoop2
	incf	J,F
;if j < duty then				;on portion
	movf	DUTY,W
	subwf	J,W
	btfsc	STATUS, C
	goto	ELSE1_1
;set red on						;main signal
	bsf	GPIO,GP0
;set green off					;and its complement
	bcf	GPIO,GP1
;else
	goto	ENDIF1
ELSE1_1
;set green on					;off portion
	bsf	GPIO,GP1
;set red off
	bcf	GPIO,GP0
;end if	
ENDIF1
;next j
	movlw	14
	subwf	J,W
	btfss	STATUS, C
	goto	SysForLoop2
SysForLoopEnd2
;next i	
	movlw	16
	subwf	I,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

SYSDIVSUB
;dim SysCalcTempA as byte
;dim SysCalcTempB as byte
;dim SysCalcTempX as byte
;SysCalcTempX = 0
	clrf	SYSCALCTEMPX
;SysDivLoop = 8
	movlw	8
	movwf	SYSDIVLOOP
SYSDIV8START
;bcf STATUS, C
	bcf	STATUS, C
;rlf SysCalcTempA, F
	rlf	SYSCALCTEMPA, F
;rlf SysCalcTempX, F
	rlf	SYSCALCTEMPX, F
;movf SysCalcTempB, W
	movf	SYSCALCTEMPB, W
;subwf SysCalcTempX, F
	subwf	SYSCALCTEMPX, F
;bsf SysCalcTempA, 0
	bsf	SYSCALCTEMPA, 0
;btfsc STATUS, C
	btfsc	STATUS, C
;goto Div8NotNeg
	goto	DIV8NOTNEG
;bcf SysCalcTempA, 0
	bcf	SYSCALCTEMPA, 0
;movf SysCalcTempB, W
	movf	SYSCALCTEMPB, W
;addwf SysCalcTempX, F
	addwf	SYSCALCTEMPX, F
DIV8NOTNEG
;decfsz SysDivLoop, F
	decfsz	SYSDIVLOOP, F
;goto SysDiv8Start
	goto	SYSDIV8START
	return

;********************************************************************************


 END
