;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
DELAYTEMP2	EQU	113
SYSCALCTEMPA	EQU	117
SysCalcTempB	EQU	121
SysCalcTempX	EQU	112
SysDivLoop	EQU	116
SysSTATUS	EQU	127
SysW	EQU	126
SysWaitTempMS	EQU	114
SysWaitTempMS_H	EQU	115
CURRENT	EQU	32
PREV	EQU	33
STATE	EQU	34
SavePCLATH	EQU	35
SaveSysTemp1	EQU	36
SysIntOffCount	EQU	37
SysTemp1	EQU	38
TMR0PRES	EQU	39
TMR0SOURCE	EQU	40

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
Interrupt

;********************************************************************************

;Save Context
	movwf	SysW
	swapf	STATUS,W
	movwf	SysSTATUS
	incf	SysIntOffCount,F
	banksel	STATUS
;Store system variables
	movf	SysTemp1,W
	movwf	SaveSysTemp1
	movf	PCLATH,W
	movwf	SavePCLATH
	clrf	PCLATH
;On Interrupt handlers
	btfss	INTCON,T0IE
	goto	NotT0IF
	btfss	INTCON,T0IF
	goto	NotT0IF
	call	YELLOW
	bcf	INTCON,T0IF
	goto	INTERRUPTDONE
NotT0IF
;User Interrupt routine
INTERRUPTDONE
;Restore Context
;Restore system variables
	movf	SaveSysTemp1,W
	movwf	SysTemp1
	movf	SavePCLATH,W
	movwf	PCLATH
	clrf	SysIntOffCount
	swapf	SysSTATUS,W
	movwf	STATUS
	swapf	SysW,F
	swapf	SysW,W
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	33
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS
;Enable interrupts
	bsf	INTCON,GIE
	bsf	INTCON,PEIE
	clrf	SysIntOffCount

;Start of the main program
;A program to put three colors under control of the center-off
;toggle switch. Connect GP0 to red element and GP1 to green
;element. Connect GP2 and GP3 to toggle legs 2 and 1,
;respectively. This uses Timer0 and interrupts.
;----- Settings
;----- Constants
;#define red 	GP0								;red element on pin 7
;#define green GP1      					;green element on pin 6
;#define prescaler PS0_1/2				;divide-by-2 prescaler
;----- Variables
;dim state as byte								;state of red/green for mix
;dim current, prev as byte				;switch readings
;----- Program
;InitTimer0 Osc, prescaler				;set up Timer0
	movlw	1
	movwf	TMR0SOURCE
	clrf	TMR0PRES
	call	INITTIMER0
;on interrupt Timer0Overflow call yellow	;set up interrupts
	bsf	INTCON,T0IE
;dir GPIO 0b00001100      				;2 inputs and 2 outputs
	movlw	12
	banksel	TRISIO
	movwf	TRISIO
;state = 0b01										;initial state for yellow
	movlw	1
	banksel	STATE
	movwf	STATE
;prev = 0b00											;an impossible condition at start
	clrf	PREV
;do
SysDoLoop_S1
;current = GPIO/4 & 0b00000011	;get switch position
	movf	GPIO,W
	movwf	SysCalcTempA
	movlw	4
	movwf	SysCalcTempB
	call	SysDivSub
	movlw	3
	andwf	SYSCALCTEMPA,W
	movwf	CURRENT
;if current <> prev then				;act only if changed
	movf	PREV,W
	subwf	CURRENT,W
	btfsc	STATUS, Z
	goto	ENDIF1
;select case current
;case 0b10:								;toggle up
SysSelect1Case1
	movlw	2
	subwf	CURRENT,W
	btfss	STATUS, Z
	goto	SysSelect1Case2
;intOff									;turn off interrupts
	bcf	INTCON,GIE
	incf	SysIntOffCount,F
;set red on
	bsf	GPIO,GP0
;set green off
	bcf	GPIO,GP1
;case 0b01:								;toggle down
	goto	SysSelectEnd1
SysSelect1Case2
	decf	CURRENT,W
	btfss	STATUS, Z
	goto	SysSelect1Case3
;intOff									;turn off interrupts
	bcf	INTCON,GIE
	incf	SysIntOffCount,F
;set green on
	bsf	GPIO,GP1
;set red off
	bcf	GPIO,GP0
;case 0b11:								;toggle center
	goto	SysSelectEnd1
SysSelect1Case3
	movlw	3
	subwf	CURRENT,W
	btfss	STATUS, Z
	goto	SysSelect1Case4
;intOn										;turn on interrupts
	movf	SysIntOffCount,F
	btfss	STATUS,Z
	decf	SysIntOffCount,F
	btfsc	STATUS,Z
	bsf	INTCON,GIE
;end select	
SysSelect1Case4
SysSelectEnd1
;prev = current							;new previous value
	movf	CURRENT,W
	movwf	PREV
;pause 50										;debounce a bit
;Wait Time ms
	movlw	50
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;end if	
ENDIF1
;loop                    				;repeat in perpetuity
	goto	SysDoLoop_S1
SysDoLoop_E1
;----- Interrupt Subroutine
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	4
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	165
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

INITTIMER0
;SInitTimer0
	goto	SINITTIMER0

;********************************************************************************

SINITTIMER0
;OPTION_REG = OPTION_REG AND 192
	movlw	192
	banksel	OPTION_REG
	andwf	OPTION_REG,F
;SET OPTION_REG.PSA OFF
	bcf	OPTION_REG,PSA
;if TMR0Source = Osc THEN SET OPTION_REG.T0SE OFF
	banksel	TMR0SOURCE
	decf	TMR0SOURCE,W
	btfss	STATUS, Z
	goto	ENDIF2
	banksel	OPTION_REG
	bcf	OPTION_REG,T0SE
ENDIF2
;if TMR0Source = Ext THEN SET OPTION_REG.T0SE ON
	movlw	2
	banksel	TMR0SOURCE
	subwf	TMR0SOURCE,W
	btfss	STATUS, Z
	goto	ENDIF3
	banksel	OPTION_REG
	bsf	OPTION_REG,T0SE
ENDIF3
;clrwdt
	clrwdt
;OPTION_REG = OPTION_REG OR TMR0Pres
	banksel	OPTION_REG
	movf	OPTION_REG,W
	banksel	TMR0PRES
	iorwf	TMR0PRES,W
	banksel	OPTION_REG
	movwf	OPTION_REG
	banksel	STATUS
	return

;********************************************************************************

SYSDIVSUB
;dim SysCalcTempA as byte
;dim SysCalcTempB as byte
;dim SysCalcTempX as byte
;SysCalcTempX = 0
	clrf	SYSCALCTEMPX
;SysDivLoop = 8
	movlw	8
	movwf	SYSDIVLOOP
SYSDIV8START
;bcf STATUS, C
	bcf	STATUS, C
;rlf SysCalcTempA, F
	rlf	SYSCALCTEMPA, F
;rlf SysCalcTempX, F
	rlf	SYSCALCTEMPX, F
;movf SysCalcTempB, W
	movf	SYSCALCTEMPB, W
;subwf SysCalcTempX, F
	subwf	SYSCALCTEMPX, F
;bsf SysCalcTempA, 0
	bsf	SYSCALCTEMPA, 0
;btfsc STATUS, C
	btfsc	STATUS, C
;goto Div8NotNeg
	goto	DIV8NOTNEG
;bcf SysCalcTempA, 0
	bcf	SYSCALCTEMPA, 0
;movf SysCalcTempB, W
	movf	SYSCALCTEMPB, W
;addwf SysCalcTempX, F
	addwf	SYSCALCTEMPX, F
DIV8NOTNEG
;decfsz SysDivLoop, F
	decfsz	SYSDIVLOOP, F
;goto SysDiv8Start
	goto	SYSDIV8START
	return

;********************************************************************************

YELLOW
;state = !state & 0b11					;toggle the LED legs
	comf	STATE,W
	movwf	SysTemp1
	movlw	3
	andwf	SysTemp1,W
	movwf	STATE
;GPIO = state
	movwf	GPIO
	return

;********************************************************************************


 END
