;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
SYSDIVMULTA	EQU	119
SYSDIVMULTA_H	EQU	120
SYSDIVMULTB	EQU	123
SYSDIVMULTB_H	EQU	124
SYSDIVMULTX	EQU	114
SYSDIVMULTX_H	EQU	115
SysCalcTempA	EQU	117
SysCalcTempA_H	EQU	118
SysCalcTempB	EQU	121
SysCalcTempB_H	EQU	122
SysCalcTempX	EQU	112
SysCalcTempX_H	EQU	113
SysDivLoop	EQU	116
SysWaitTemp10US	EQU	117
ADREADPORT	EQU	32
ADTEMP	EQU	33
CCPCONCACHE	EQU	34
PR2_TEMP	EQU	35
PR2_TEMP_H	EQU	36
PWMCHANNEL	EQU	38
PWMDUTY	EQU	39
PWMFREQ	EQU	40
READAD	EQU	41
SysTemp1	EQU	42
SysTemp1_H	EQU	43
SysTemp2	EQU	44
SysTemp2_H	EQU	45
T2_PR	EQU	46
WIDTH	EQU	47

;********************************************************************************

;Alias variables
ALLANSEL	EQU	ANSEL

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS
	call	INITPWM

;Start of the main program
;A program to control the lamp with the pot using hardware PWM.
;Connect GP2 to the motor/lamp pin of J6. Select
;the lamp option on header J4. Connect GP0 to the pot.
;----- Settings
;----- Constants
;#define pot GPIO.0					;potentiometer on pin 7
;#define lamp GPIO.2       	;lamp is on pin 5
;#define carrier 5						;carrier frequency is 5 kHz
;----- Variables
;dim width as byte
;----- Program
;dir pot in									;make an input
	banksel	TRISIO
	bsf	TRISIO,0
;dir lamp out             		;make an output
	bcf	TRISIO,2
;do
SysDoLoop_S1
;width = readAD(AN0)
	banksel	ADREADPORT
	clrf	ADREADPORT
	call	FN_READAD
	movf	READAD,W
	movwf	WIDTH
;hpwm 1, carrier, width		;set the pulse width
	movlw	1
	movwf	PWMCHANNEL
	movlw	5
	movwf	PWMFREQ
	movf	WIDTH,W
	movwf	PWMDUTY
	call	HPWM
;loop                    		;repeat in perpetuity
	goto	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_10US
D10US_START
	movlw	5
	movwf	DELAYTEMP
DelayUS0
	decfsz	DELAYTEMP,F
	goto	DelayUS0
	nop
	decfsz	SysWaitTemp10US, F
	goto	D10US_START
	return

;********************************************************************************

HPWM
;dim PR2_Temp as word
;T2_PR = 1
	movlw	1
	movwf	T2_PR
;PR2_Temp = PWMOsc1/PWMFreq
	movlw	208
	movwf	SysCalcTempA
	movlw	7
	movwf	SysCalcTempA_H
	movf	PWMFREQ,W
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	PR2_TEMP
	movf	SysCalcTempA_H,W
	movwf	PR2_TEMP_H
;IF PR2_Temp_H > 0 then
	sublw	0
	btfsc	STATUS, C
	goto	ENDIF3
;T2_PR = 4
	movlw	4
	movwf	T2_PR
;set STATUS.C off
	bcf	STATUS,C
;rotate PR2_Temp right
	rrf	PR2_TEMP_H,F
	rrf	PR2_TEMP,F
;set STATUS.C off
	bcf	STATUS,C
;rotate PR2_Temp right
	rrf	PR2_TEMP_H,F
	rrf	PR2_TEMP,F
;end if
ENDIF3
;IF PR2_Temp_H > 0 then
	movf	PR2_TEMP_H,W
	sublw	0
	btfsc	STATUS, C
	goto	ENDIF4
;T2_PR = 16
	movlw	16
	movwf	T2_PR
;set STATUS.C off
	bcf	STATUS,C
;rotate PR2_Temp right
	rrf	PR2_TEMP_H,F
	rrf	PR2_TEMP,F
;set STATUS.C off
	bcf	STATUS,C
;rotate PR2_Temp right
	rrf	PR2_TEMP_H,F
	rrf	PR2_TEMP,F
;end if
ENDIF4
;PR2 = PR2_Temp
	movf	PR2_TEMP,W
	banksel	PR2
	movwf	PR2
;SET T2CON.T2CKPS0 OFF
	banksel	T2CON
	bcf	T2CON,T2CKPS0
;SET T2CON.T2CKPS1 OFF
	bcf	T2CON,T2CKPS1
;if T2_PR = 4 then SET T2CON.T2CKPS0 ON
	movlw	4
	subwf	T2_PR,W
	btfsc	STATUS, Z
	bsf	T2CON,T2CKPS0
;if T2_PR = 16 then SET T2CON.T2CKPS1 ON
	movlw	16
	subwf	T2_PR,W
	btfsc	STATUS, Z
	bsf	T2CON,T2CKPS1
;SET T2CON.TMR2ON ON
	bsf	T2CON,TMR2ON
;CCPR1L = ([word]PWMDuty * PR2) / 255
	movf	PWMDUTY,W
	movwf	SysCalcTempA
	clrf	SysCalcTempA_H
	banksel	PR2
	movf	PR2,W
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	banksel	STATUS
	call	SysMultSub16
	movf	SysCalcTempX,W
	movwf	SysTemp1
	movf	SysCalcTempX_H,W
	movwf	SysTemp1_H
	movf	SysTemp1,W
	movwf	SysCalcTempA
	movf	SysTemp1_H,W
	movwf	SysCalcTempA_H
	movlw	255
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	CCPR1L
;SET CCP1CON.CCP1M3 ON
	bsf	CCP1CON,CCP1M3
;SET CCP1CON.CCP1M2 ON
	bsf	CCP1CON,CCP1M2
;SET CCP1CON.CCP1M1 OFF
	bcf	CCP1CON,CCP1M1
;SET CCP1CON.CCP1M0 OFF
	bcf	CCP1CON,CCP1M0
	return

;********************************************************************************

INITPWM
;PR2 = PR2Temp
	movlw	52
	banksel	PR2
	movwf	PR2
;SET T2CON.T2CKPS0 OFF
	banksel	T2CON
	bcf	T2CON,T2CKPS0
;SET T2CON.T2CKPS1 OFF
	bcf	T2CON,T2CKPS1
;CCPR1L = DutyCycleH
	movlw	26
	movwf	CCPR1L
;SET CCPCONCache.DC1B1 ON
	bsf	CCPCONCACHE,DC1B1
;SET CCPCONCache.DC1B0 OFF
	bcf	CCPCONCACHE,DC1B0
;SET CCPCONCache.CCP1M3 ON
	bsf	CCPCONCACHE,CCP1M3
;SET CCPCONCache.CCP1M2 ON
	bsf	CCPCONCACHE,CCP1M2
;SET CCPCONCache.CCP1M1 OFF
	bcf	CCPCONCACHE,CCP1M1
;SET CCPCONCache.CCP1M0 OFF
	bcf	CCPCONCACHE,CCP1M0
;SET T2CON.TMR2ON ON
	bsf	T2CON,TMR2ON
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

FN_READAD
;Set up for 8 bit
;Perform conversion
;LLReadAD
;Dim AllANSEL As Byte Alias ANSEL
;AllANSEL = 0
	banksel	ALLANSEL
	clrf	ALLANSEL
;ADTemp = ADReadPort + 1
	banksel	ADREADPORT
	incf	ADREADPORT,W
	movwf	ADTEMP
;Set C On
	bsf	STATUS,C
;Do
SysDoLoop_S2
;Rotate AllANSEL Left
	banksel	ALLANSEL
	rlf	ALLANSEL,F
;decfsz ADTemp,F
	banksel	ADTEMP
	decfsz	ADTEMP,F
;Loop
	goto	SysDoLoop_S2
SysDoLoop_E2
;SET ADCS1 OFF
	banksel	ANSEL
	bcf	ANSEL,ADCS1
;SET ADCS0 ON
	bsf	ANSEL,ADCS0
;SET ADCON0.CHS0 OFF
	banksel	ADCON0
	bcf	ADCON0,CHS0
;SET ADCON0.CHS1 OFF
	bcf	ADCON0,CHS1
;IF ADReadPort.0 On Then Set ADCON0.CHS0 On
	btfsc	ADREADPORT,0
	bsf	ADCON0,CHS0
;IF ADReadPort.1 On Then Set ADCON0.CHS1 On
	btfsc	ADREADPORT,1
	bsf	ADCON0,CHS1
;SET ADCON0.ADON ON
	bsf	ADCON0,ADON
;Wait AD_Delay
	movlw	2
	movwf	SysWaitTemp10US
	call	Delay_10US
;SET ADCON0.GO_DONE ON
	bsf	ADCON0,GO_DONE
;Wait While ADCON0.GO_DONE ON
SysWaitLoop1
	btfsc	ADCON0,GO_DONE
	goto	SysWaitLoop1
;SET ADCON0.ADON OFF
	bcf	ADCON0,ADON
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;Write output
;ReadAD = ADRESH
	banksel	ADRESH
	movf	ADRESH,W
	movwf	READAD
	return

;********************************************************************************

SYSCOMPEQUAL16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA, W
	movf	SYSCALCTEMPA, W
;subwf SysCalcTempB, W
	subwf	SYSCALCTEMPB, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;movf SysCalcTempA_H, W
	movf	SYSCALCTEMPA_H, W
;subwf SysCalcTempB_H, W
	subwf	SYSCALCTEMPB_H, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSCOMPLESSTHAN16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA_H,W
	movf	SYSCALCTEMPA_H,W
;subwf SysCalcTempB_H,W
	subwf	SYSCALCTEMPB_H,W
;btfss STATUS,C
	btfss	STATUS,C
;return
	return
;movf SysCalcTempB_H,W
	movf	SYSCALCTEMPB_H,W
;subwf SysCalcTempA_H,W
	subwf	SYSCALCTEMPA_H,W
;btfss STATUS,C
	btfss	STATUS,C
;goto SCLT16True
	goto	SCLT16TRUE
;movf SysCalcTempB,W
	movf	SYSCALCTEMPB,W
;subwf SysCalcTempA,W
	subwf	SYSCALCTEMPA,W
;btfsc STATUS,C
	btfsc	STATUS,C
;return
	return
SCLT16TRUE
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSDIVSUB16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as word
;dim SysDivMultA as word
;dim SysDivMultB as word
;dim SysDivMultX as word
;SysDivMultA = SysCalcTempA
	movf	SYSCALCTEMPA,W
	movwf	SYSDIVMULTA
	movf	SYSCALCTEMPA_H,W
	movwf	SYSDIVMULTA_H
;SysDivMultB = SysCalcTempB
	movf	SYSCALCTEMPB,W
	movwf	SYSDIVMULTB
	movf	SYSCALCTEMPB_H,W
	movwf	SYSDIVMULTB_H
;SysDivMultX = 0
	clrf	SYSDIVMULTX
	clrf	SYSDIVMULTX_H
;if SysDivMultB = 0 then
	movf	SYSDIVMULTB,W
	movwf	SysCalcTempA
	movf	SYSDIVMULTB_H,W
	movwf	SysCalcTempA_H
	clrf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysCompEqual16
	btfss	SysCalcTempX,0
	goto	ENDIF9
;SysCalcTempA = 0
	clrf	SYSCALCTEMPA
	clrf	SYSCALCTEMPA_H
;exit sub
	return
;end if
ENDIF9
;SysDivLoop = 16
	movlw	16
	movwf	SYSDIVLOOP
SYSDIV16START
;set C off
	bcf	STATUS,C
;Rotate SysDivMultA Left
	rlf	SYSDIVMULTA,F
	rlf	SYSDIVMULTA_H,F
;Rotate SysDivMultX Left
	rlf	SYSDIVMULTX,F
	rlf	SYSDIVMULTX_H,F
;SysDivMultX = SysDivMultX - SysDivMultB
	movf	SYSDIVMULTB,W
	subwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfss	STATUS,C
	addlw	1
	subwf	SYSDIVMULTX_H,F
;Set SysDivMultA.0 On
	bsf	SYSDIVMULTA,0
;If C Off Then
	btfsc	STATUS,C
	goto	ENDIF10
;Set SysDivMultA.0 Off
	bcf	SYSDIVMULTA,0
;SysDivMultX = SysDivMultX + SysDivMultB
	movf	SYSDIVMULTB,W
	addwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfsc	STATUS,C
	addlw	1
	addwf	SYSDIVMULTX_H,F
;End If
ENDIF10
;decfsz SysDivLoop, F
	decfsz	SYSDIVLOOP, F
;goto SysDiv16Start
	goto	SYSDIV16START
;SysCalcTempA = SysDivMultA
	movf	SYSDIVMULTA,W
	movwf	SYSCALCTEMPA
	movf	SYSDIVMULTA_H,W
	movwf	SYSCALCTEMPA_H
;SysCalcTempX = SysDivMultX
	movf	SYSDIVMULTX,W
	movwf	SYSCALCTEMPX
	movf	SYSDIVMULTX_H,W
	movwf	SYSCALCTEMPX_H
	return

;********************************************************************************

SYSMULTSUB16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as word
;dim SysDivMultA as word
;dim SysDivMultB as word
;dim SysDivMultX as word
;SysDivMultA = SysCalcTempA
	movf	SYSCALCTEMPA,W
	movwf	SYSDIVMULTA
	movf	SYSCALCTEMPA_H,W
	movwf	SYSDIVMULTA_H
;SysDivMultB = SysCalcTempB
	movf	SYSCALCTEMPB,W
	movwf	SYSDIVMULTB
	movf	SYSCALCTEMPB_H,W
	movwf	SYSDIVMULTB_H
;SysDivMultX = 0
	clrf	SYSDIVMULTX
	clrf	SYSDIVMULTX_H
MUL16LOOP
;IF SysDivMultB.0 ON then SysDivMultX += SysDivMultA
	btfss	SYSDIVMULTB,0
	goto	ENDIF7
	movf	SYSDIVMULTA,W
	addwf	SYSDIVMULTX,F
	movf	SYSDIVMULTA_H,W
	btfsc	STATUS,C
	addlw	1
	addwf	SYSDIVMULTX_H,F
ENDIF7
;set STATUS.C OFF
	bcf	STATUS,C
;rotate SysDivMultB right
	rrf	SYSDIVMULTB_H,F
	rrf	SYSDIVMULTB,F
;set STATUS.C off
	bcf	STATUS,C
;rotate SysDivMultA left
	rlf	SYSDIVMULTA,F
	rlf	SYSDIVMULTA_H,F
;if SysDivMultB > 0 then goto MUL16LOOP
	movf	SYSDIVMULTB,W
	movwf	SysCalcTempB
	movf	SYSDIVMULTB_H,W
	movwf	SysCalcTempB_H
	clrf	SysCalcTempA
	clrf	SysCalcTempA_H
	call	SysCompLessThan16
	btfsc	SysCalcTempX,0
	goto	MUL16LOOP
;SysCalcTempX = SysDivMultX
	movf	SYSDIVMULTX,W
	movwf	SYSCALCTEMPX
	movf	SYSDIVMULTX_H,W
	movwf	SYSCALCTEMPX_H
	return

;********************************************************************************


 END
