;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
I	EQU	32
SysTemp1	EQU	33
TEMP	EQU	34

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;A program to drive a four-bit DAC, creating a staircase waveform.
;Connect GP0, GP1, GP2, GP4 to DAC0 through DAC3, respectively.
;Monitor DAC output on an oscilloscope.
;----- Settings
;----- Variables
;dim i, temp as byte
;----- Program
;dir GPIO 0b11101000						;GP0, GP1, GP2 and GP4 are outputs
	movlw	232
	banksel	TRISIO
	movwf	TRISIO
;do
SysDoLoop_S1
;i++													;ramp from 0 to 255
	banksel	I
	incf	I,F
;temp = (i * 2) & 0b00010000	;compact the bits
	bcf	STATUS,C
	rlf	I,W
	movwf	SysTemp1
	movlw	16
	andwf	SysTemp1,W
	movwf	TEMP
;temp = (i & 0b00000111) | temp
	movlw	7
	andwf	I,W
	movwf	SysTemp1
	iorwf	TEMP,F
;GPIO = temp  								;apply to DAC, creating a staircase wave
	movf	TEMP,W
	movwf	GPIO
;loop       										;and repeat in perpetuity
	goto	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************


 END
