;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
DELAYTEMP2	EQU	113
SYSDIVMULTA	EQU	119
SYSDIVMULTA_H	EQU	120
SYSDIVMULTB	EQU	123
SYSDIVMULTB_H	EQU	124
SYSDIVMULTX	EQU	114
SYSDIVMULTX_H	EQU	115
SysCalcTempA	EQU	117
SysCalcTempA_H	EQU	118
SysCalcTempB	EQU	121
SysCalcTempB_H	EQU	122
SysCalcTempX	EQU	112
SysCalcTempX_H	EQU	113
SysDivLoop	EQU	116
SysWaitTemp10US	EQU	117
SysWaitTempMS	EQU	114
SysWaitTempMS_H	EQU	115
SysWaitTempS	EQU	116
COUNT	EQU	32
COUNT_H	EQU	33
DataPointer	EQU	34
I	EQU	35
J	EQU	36
PERIOD	EQU	37
SysRepeatTemp1	EQU	38
SysRepeatTemp1_H	EQU	39
SysTemp1	EQU	40
SysTemp1_H	EQU	41
TEMPO	EQU	42

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;Do sound effects on a piezo connected to GP0.
;Alternatively, you could connect GP0 to the line
;output and drive an external speaker or amplifier and then
;use the volume control to tame things as required.
;----- Settings
;----- Constants
;#define SOUNDOUT GPIO.0				;piezo on pin 7
;----- Variables
;dim tempo, i, j, period as byte
;dim count as word				
;----- Program
;dir SOUNDOUT out												;set as output
	banksel	TRISIO
	bcf	TRISIO,0
;do
SysDoLoop_S1
;for tempo = 1 to 8										;1 is slowest, 8 is fastest
	banksel	TEMPO
	clrf	TEMPO
SysForLoop1
	incf	TEMPO,F
;for i = 1 to 8                  		;8 notes in scale
	clrf	I
SysForLoop2
	incf	I,F
;readTable note, i, period     		;fetch a note from table
	movf	I,W
	movwf	DataPointer
	call	NOTE
	movwf	PERIOD
;count = [word] 50000/period/tempo	;cast and compute duration
	movlw	80
	movwf	SysCalcTempA
	movlw	195
	movwf	SysCalcTempA_H
	movf	PERIOD,W
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	SysTemp1
	movf	SysCalcTempA_H,W
	movwf	SysTemp1_H
	movf	SysTemp1,W
	movwf	SysCalcTempA
	movf	SysTemp1_H,W
	movwf	SysCalcTempA_H
	movf	TEMPO,W
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	COUNT
	movf	SysCalcTempA_H,W
	movwf	COUNT_H
;repeat count											;fill out the duration
	movf	COUNT,W
	movwf	SysRepeatTemp1
	movlw	1
	addwf	COUNT_H,W
	movwf	SysRepeatTemp1_H
	movf	SysRepeatTemp1,W
	movwf	SysCalcTempA
	movf	SysRepeatTemp1_H,W
	movwf	SysCalcTempA_H
	movlw	1
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysCompLessThan16
	btfsc	SysCalcTempX,0
	goto	SysRepeatLoopEnd1
SysRepeatLoop1
;pulseOut SOUNDOUT, period 10us	;turn on half cycle
;Set Pin On
	bsf	GPIO,0
;Wait Time
	movf	PERIOD,W
	movwf	SysWaitTemp10US
	call	Delay_10US
;Set Pin Off
	bcf	GPIO,0
;wait period 10us								;turn off half cycle
	movf	PERIOD,W
	movwf	SysWaitTemp10US
	call	Delay_10US
;end repeat
	decfsz	SysRepeatTemp1,F
	goto	SysRepeatLoop1
	decfsz	SysRepeatTemp1_H,F
	goto	SysRepeatLoop1
SysRepeatLoopEnd1
;next i															;do next note
	movlw	8
	subwf	I,W
	btfss	STATUS, C
	goto	SysForLoop2
SysForLoopEnd2
;next tempo														;now play twice as fast
	movlw	8
	subwf	TEMPO,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
;wait 1 S															;pause a bit
	movlw	1
	movwf	SysWaitTempS
	call	Delay_S
;for tempo = 1 to 8										;now do it all backwards
	clrf	TEMPO
SysForLoop3
	incf	TEMPO,F
;for i = 8 to 1 step -1           		
	movlw	9
	movwf	I
SysForLoop4
	decf	I,F
;readTable note, i, period     		
	movf	I,W
	movwf	DataPointer
	call	NOTE
	movwf	PERIOD
;count = [word] 50000/period/tempo	
	movlw	80
	movwf	SysCalcTempA
	movlw	195
	movwf	SysCalcTempA_H
	movf	PERIOD,W
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	SysTemp1
	movf	SysCalcTempA_H,W
	movwf	SysTemp1_H
	movf	SysTemp1,W
	movwf	SysCalcTempA
	movf	SysTemp1_H,W
	movwf	SysCalcTempA_H
	movf	TEMPO,W
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	COUNT
	movf	SysCalcTempA_H,W
	movwf	COUNT_H
;repeat count											
	movf	COUNT,W
	movwf	SysRepeatTemp1
	movlw	1
	addwf	COUNT_H,W
	movwf	SysRepeatTemp1_H
	movf	SysRepeatTemp1,W
	movwf	SysCalcTempA
	movf	SysRepeatTemp1_H,W
	movwf	SysCalcTempA_H
	movlw	1
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysCompLessThan16
	btfsc	SysCalcTempX,0
	goto	SysRepeatLoopEnd2
SysRepeatLoop2
;pulseOut SOUNDOUT, period 10us	
;Set Pin On
	bsf	GPIO,0
;Wait Time
	movf	PERIOD,W
	movwf	SysWaitTemp10US
	call	Delay_10US
;Set Pin Off
	bcf	GPIO,0
;wait period 10us								
	movf	PERIOD,W
	movwf	SysWaitTemp10US
	call	Delay_10US
;end repeat
	decfsz	SysRepeatTemp1,F
	goto	SysRepeatLoop2
	decfsz	SysRepeatTemp1_H,F
	goto	SysRepeatLoop2
SysRepeatLoopEnd2
;next i															
	movf	I,W
	sublw	1
	btfss	STATUS, C
	goto	SysForLoop4
SysForLoopEnd4
;next tempo		
	movlw	8
	subwf	TEMPO,W
	btfss	STATUS, C
	goto	SysForLoop3
SysForLoopEnd3
;wait 1 S			
	movlw	1
	movwf	SysWaitTempS
	call	Delay_S
;for i = 1 to 8											
	clrf	I
SysForLoop5
	incf	I,F
;for period = 88 to 44 step -1   		;sweep up     		
	movlw	89
	movwf	PERIOD
SysForLoop6
	decf	PERIOD,F
;repeat 20											
	movlw	20
	movwf	SysRepeatTemp1
SysRepeatLoop3
;pulseOut SOUNDOUT, period 10us	
;Set Pin On
	bsf	GPIO,0
;Wait Time
	movf	PERIOD,W
	movwf	SysWaitTemp10US
	call	Delay_10US
;Set Pin Off
	bcf	GPIO,0
;wait period 10us								
	movf	PERIOD,W
	movwf	SysWaitTemp10US
	call	Delay_10US
;end repeat
	decfsz	SysRepeatTemp1,F
	goto	SysRepeatLoop3
SysRepeatLoopEnd3
;next period		
	movf	PERIOD,W
	sublw	44
	btfss	STATUS, C
	goto	SysForLoop6
SysForLoopEnd6
;for period = 44 to 88          			;sweep down
	movlw	43
	movwf	PERIOD
SysForLoop7
	incf	PERIOD,F
;repeat 20											
	movlw	20
	movwf	SysRepeatTemp1
SysRepeatLoop4
;pulseOut SOUNDOUT, period 10us	
;Set Pin On
	bsf	GPIO,0
;Wait Time
	movf	PERIOD,W
	movwf	SysWaitTemp10US
	call	Delay_10US
;Set Pin Off
	bcf	GPIO,0
;wait period 10us								
	movf	PERIOD,W
	movwf	SysWaitTemp10US
	call	Delay_10US
;end repeat
	decfsz	SysRepeatTemp1,F
	goto	SysRepeatLoop4
SysRepeatLoopEnd4
;next period					
	movlw	88
	subwf	PERIOD,W
	btfss	STATUS, C
	goto	SysForLoop7
SysForLoopEnd7
;next i			
	movlw	8
	subwf	I,W
	btfss	STATUS, C
	goto	SysForLoop5
SysForLoopEnd5
;wait 1 S	
	movlw	1
	movwf	SysWaitTempS
	call	Delay_S
;for j = 1 to 5
	clrf	J
SysForLoop8
	incf	J,F
;for i = 1 to 20
	clrf	I
SysForLoop9
	incf	I,F
;repeat 20											
	movlw	20
	movwf	SysRepeatTemp1
SysRepeatLoop5
;pulseOut SOUNDOUT, 88 10us			;alternate rapidly
;Set Pin On
	bsf	GPIO,0
;Wait Time
	movlw	88
	movwf	SysWaitTemp10US
	call	Delay_10US
;Set Pin Off
	bcf	GPIO,0
;wait 88 10us										;between two tones
	movlw	88
	movwf	SysWaitTemp10US
	call	Delay_10US
;end repeat
	decfsz	SysRepeatTemp1,F
	goto	SysRepeatLoop5
SysRepeatLoopEnd5
;repeat 20											
	movlw	20
	movwf	SysRepeatTemp1
SysRepeatLoop6
;pulseOut SOUNDOUT, 44 10us	
;Set Pin On
	bsf	GPIO,0
;Wait Time
	movlw	44
	movwf	SysWaitTemp10US
	call	Delay_10US
;Set Pin Off
	bcf	GPIO,0
;wait 44 10us								
	movlw	44
	movwf	SysWaitTemp10US
	call	Delay_10US
;end repeat     			
	decfsz	SysRepeatTemp1,F
	goto	SysRepeatLoop6
SysRepeatLoopEnd6
;next i
	movlw	20
	subwf	I,W
	btfss	STATUS, C
	goto	SysForLoop9
SysForLoopEnd9
;wait 4 S
	movlw	4
	movwf	SysWaitTempS
	call	Delay_S
;next j		
	movlw	5
	subwf	J,W
	btfss	STATUS, C
	goto	SysForLoop8
SysForLoopEnd8
;loop																		;repeat in perpetuity
	goto	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_10US
D10US_START
	movlw	5
	movwf	DELAYTEMP
DelayUS0
	decfsz	DELAYTEMP,F
	goto	DelayUS0
	nop
	decfsz	SysWaitTemp10US, F
	goto	D10US_START
	return

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	4
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	165
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

Delay_S
DS_START
	movlw	232
	movwf	SysWaitTempMS
	movlw	3
	movwf	SysWaitTempMS_H
	call	Delay_MS
	decfsz	SysWaitTempS, F
	goto	DS_START
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

NOTE
	movlw	9
	subwf	DataPointer, W
	btfsc	STATUS, C
	retlw	0
	movf	DataPointer, W
	addlw	1
	bcf	STATUS, C
	addlw	low TableNOTE
	movwf	DataPointer
	movlw	high TableNOTE
	btfsc	STATUS, C
	addlw	1
	movwf	PCLATH
	movf	DataPointer, W
TableNOTE
	movwf	PCL
	retlw	8
	retlw	191
	retlw	170
	retlw	152
	retlw	143
	retlw	128
	retlw	114
	retlw	101
	retlw	96

;********************************************************************************

SYSCOMPEQUAL16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA, W
	movf	SYSCALCTEMPA, W
;subwf SysCalcTempB, W
	subwf	SYSCALCTEMPB, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;movf SysCalcTempA_H, W
	movf	SYSCALCTEMPA_H, W
;subwf SysCalcTempB_H, W
	subwf	SYSCALCTEMPB_H, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSCOMPLESSTHAN16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA_H,W
	movf	SYSCALCTEMPA_H,W
;subwf SysCalcTempB_H,W
	subwf	SYSCALCTEMPB_H,W
;btfss STATUS,C
	btfss	STATUS,C
;return
	return
;movf SysCalcTempB_H,W
	movf	SYSCALCTEMPB_H,W
;subwf SysCalcTempA_H,W
	subwf	SYSCALCTEMPA_H,W
;btfss STATUS,C
	btfss	STATUS,C
;goto SCLT16True
	goto	SCLT16TRUE
;movf SysCalcTempB,W
	movf	SYSCALCTEMPB,W
;subwf SysCalcTempA,W
	subwf	SYSCALCTEMPA,W
;btfsc STATUS,C
	btfsc	STATUS,C
;return
	return
SCLT16TRUE
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSDIVSUB16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as word
;dim SysDivMultA as word
;dim SysDivMultB as word
;dim SysDivMultX as word
;SysDivMultA = SysCalcTempA
	movf	SYSCALCTEMPA,W
	movwf	SYSDIVMULTA
	movf	SYSCALCTEMPA_H,W
	movwf	SYSDIVMULTA_H
;SysDivMultB = SysCalcTempB
	movf	SYSCALCTEMPB,W
	movwf	SYSDIVMULTB
	movf	SYSCALCTEMPB_H,W
	movwf	SYSDIVMULTB_H
;SysDivMultX = 0
	clrf	SYSDIVMULTX
	clrf	SYSDIVMULTX_H
;if SysDivMultB = 0 then
	movf	SYSDIVMULTB,W
	movwf	SysCalcTempA
	movf	SYSDIVMULTB_H,W
	movwf	SysCalcTempA_H
	clrf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysCompEqual16
	btfss	SysCalcTempX,0
	goto	ENDIF10
;SysCalcTempA = 0
	clrf	SYSCALCTEMPA
	clrf	SYSCALCTEMPA_H
;exit sub
	return
;end if
ENDIF10
;SysDivLoop = 16
	movlw	16
	movwf	SYSDIVLOOP
SYSDIV16START
;set C off
	bcf	STATUS,C
;Rotate SysDivMultA Left
	rlf	SYSDIVMULTA,F
	rlf	SYSDIVMULTA_H,F
;Rotate SysDivMultX Left
	rlf	SYSDIVMULTX,F
	rlf	SYSDIVMULTX_H,F
;SysDivMultX = SysDivMultX - SysDivMultB
	movf	SYSDIVMULTB,W
	subwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfss	STATUS,C
	addlw	1
	subwf	SYSDIVMULTX_H,F
;Set SysDivMultA.0 On
	bsf	SYSDIVMULTA,0
;If C Off Then
	btfsc	STATUS,C
	goto	ENDIF11
;Set SysDivMultA.0 Off
	bcf	SYSDIVMULTA,0
;SysDivMultX = SysDivMultX + SysDivMultB
	movf	SYSDIVMULTB,W
	addwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfsc	STATUS,C
	addlw	1
	addwf	SYSDIVMULTX_H,F
;End If
ENDIF11
;decfsz SysDivLoop, F
	decfsz	SYSDIVLOOP, F
;goto SysDiv16Start
	goto	SYSDIV16START
;SysCalcTempA = SysDivMultA
	movf	SYSDIVMULTA,W
	movwf	SYSCALCTEMPA
	movf	SYSDIVMULTA_H,W
	movwf	SYSCALCTEMPA_H
;SysCalcTempX = SysDivMultX
	movf	SYSDIVMULTX,W
	movwf	SYSCALCTEMPX
	movf	SYSDIVMULTX_H,W
	movwf	SYSCALCTEMPX_H
	return

;********************************************************************************


 END
