;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
DELAYTEMP2	EQU	113
SYSSTRINGLENGTH	EQU	118
SysCalcTempA	EQU	117
SysCalcTempB	EQU	121
SysCalcTempX	EQU	112
SysDivLoop	EQU	116
SysStringA	EQU	119
SysStringA_H	EQU	120
SysStringB	EQU	114
SysStringB_H	EQU	115
SysWaitTempMS	EQU	114
SysWaitTempMS_H	EQU	115
SysWaitTempUS	EQU	117
SysWaitTempUS_H	EQU	118
SYSSTRINGPARAM1	EQU	169
CURRENT	EQU	32
OUTVALUETEMP	EQU	33
PREV	EQU	34
PRINTLEN	EQU	35
SERBIT	EQU	36
SERDELAYLOOP	EQU	37
SERPRINTVAL	EQU	38
SERTEMP	EQU	39
SER_BYTE	EQU	40
SER_DATA	EQU	41
SER_DATA_A	EQU	42
SER_INVERT	EQU	43
SER_INVERT_A	EQU	44
SER_PARITY	EQU	45
SER_PARITY_A	EQU	46
SER_RATE	EQU	47
SER_RATE_A	EQU	48
SER_SELECT	EQU	49
SER_SELECT_OLD	EQU	50
SER_START	EQU	51
SER_START_A	EQU	52
SER_STOP	EQU	53
SER_STOP_A	EQU	54
SYSPRINTTEMP	EQU	55
StringPointer	EQU	56
SysPRINTDATAHandler	EQU	57
SysPRINTDATAHandler_H	EQU	58
SysTemp1	EQU	59
SysTemp2	EQU	60
TEMP	EQU	61
TEMPPARITY	EQU	62

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;Send position of rotary decoder to a PC via serial
;communication. Connect GP0 through GP3 to the
;rotary decoder, GP4 to Rx and GP5 to Tx. Connect
;a PC to the DB-9. Use a USB-to-COM adapter if needed.
;Test the unit with any terminal program.
;----- Settings
;----- Constants
;#define S0 GPIO.0						;rotary switch on pin 7
;#define S1 GPIO.1						;pin 6
;#define S2 GPIO.2						;pin 5
;#define S3 GPIO.3						;pin 4
;#define SerInPort		GPIO.4	;Rx input on pin 3
;#define SerOutPort	GPIO.5	;Tx output on pin 2
;#define SendAHigh Set SerOutPort  on  ;output logic levels
;#define SendALow  Set SerOutPort  off
;#define RecAHigh  SerInPort       on  ;input logic levels
;#define RecALow   SerInPort       off
;#define cr 13                         ;carriage return
;#define lf 10                         ;line feed
;----- Variables
;dim temp, current, prev as byte
;----- Program
;dir GPIO in           						;most pins are inputs
	movlw	255
	banksel	TRISIO
	movwf	TRISIO
;dir SerOutPort out								;except Tx
	bcf	TRISIO,5
;InitSer 1, r4800, 1+WaitForStart, 8, 1, none, invert
	movlw	1
	banksel	SER_SELECT
	movwf	SER_SELECT
	movlw	4
	movwf	SER_RATE
	movlw	129
	movwf	SER_START
	movlw	8
	movwf	SER_DATA
	movlw	1
	movwf	SER_STOP
	clrf	SER_PARITY
	movlw	1
	movwf	SER_INVERT
	call	INITSER
;do
SysDoLoop_S1
;do
SysDoLoop_S2
;temp = GPIO & 0b00001111			;read switch
	movlw	15
	andwf	GPIO,W
	movwf	TEMP
;wait 50 mS										;debounce
	movlw	50
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;current = GPIO & 0b00001111		;read again
	movlw	15
	andwf	GPIO,W
	movwf	CURRENT
;loop while temp <> current			;wait for stable position
	subwf	TEMP,W
	btfss	STATUS, Z
	goto	SysDoLoop_S2
SysDoLoop_E2
;if current <> prev then					;only print new value
	movf	PREV,W
	subwf	CURRENT,W
	btfsc	STATUS, Z
	goto	ENDIF1
;SerPrint 1, "Position "   		;echo to terminal
	movlw	1
	movwf	SER_SELECT
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable1
	movwf	SysStringA
	movlw	high StringTable1
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysPRINTDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysPRINTDATAHandler_H
	call	SERPRINT13
;SerPrint 1, current
	movlw	1
	movwf	SER_SELECT
	movf	CURRENT,W
	movwf	SERPRINTVAL
	call	SERPRINT14
;SerSend 1, cr
	movlw	1
	movwf	SER_SELECT
	movlw	13
	movwf	SER_BYTE
	call	SERSEND
;SerSend 1, lf
	movlw	1
	movwf	SER_SELECT
	movlw	10
	movwf	SER_BYTE
	call	SERSEND
;prev = current								;now becomes previous
	movf	CURRENT,W
	movwf	PREV
;end if	
ENDIF1
;loop            									;repeat in perpetuity
	goto	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	4
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	165
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

INITSER
;Ser_Select_Old = Ser_Select
	movf	SER_SELECT,W
	movwf	SER_SELECT_OLD
;if Ser_Select = 1 THEN
	decf	SER_SELECT,W
	btfss	STATUS, Z
	goto	ENDIF2
;Ser_Rate_A = Ser_Rate
	movf	SER_RATE,W
	movwf	SER_RATE_A
;Ser_Start_A = Ser_Start
	movf	SER_START,W
	movwf	SER_START_A
;Ser_Data_A = Ser_Data
	movf	SER_DATA,W
	movwf	SER_DATA_A
;Ser_Stop_A = Ser_Stop
	movf	SER_STOP,W
	movwf	SER_STOP_A
;Ser_Parity_A = Ser_Parity
	movf	SER_PARITY,W
	movwf	SER_PARITY_A
;Ser_Invert_A = Ser_Invert
	movf	SER_INVERT,W
	movwf	SER_INVERT_A
;END IF
ENDIF2
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

SERBITDELAY
;if Ser_Rate = 1 then Wait SerFullDelay19200 us: exit sub	'19200 (52 us)
	decf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF35
	movlw	19
	movwf	DELAYTEMP
DelayUS1
	decfsz	DELAYTEMP,F
	goto	DelayUS1
	return
ENDIF35
;if Ser_Rate = 2 then Wait SerFullDelay9600 us: exit sub 	'9600 (104 us)
	movlw	2
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF36
	movlw	52
	movwf	DELAYTEMP
DelayUS2
	decfsz	DELAYTEMP,F
	goto	DelayUS2
	nop
	return
ENDIF36
;if Ser_Rate = 4 then Wait SerFullDelay4800 us: exit sub 	'4800 (208 us)
	movlw	4
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF37
	movlw	122
	movwf	DELAYTEMP
DelayUS3
	decfsz	DELAYTEMP,F
	goto	DelayUS3
	return
ENDIF37
;if Ser_Rate = 8 then Wait SerFullDelay2400 us: exit sub 	'2400 (417 us)
	movlw	8
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF38
	movlw	1
	movwf	DELAYTEMP2
DelayUSO4
	clrf	DELAYTEMP
DelayUS4
	decfsz	DELAYTEMP,F
	goto	DelayUS4
	decfsz	DELAYTEMP2,F
	goto	DelayUSO4
	movlw	4
	movwf	DELAYTEMP
DelayUS5
	decfsz	DELAYTEMP,F
	goto	DelayUS5
	return
ENDIF38
;if Ser_Rate = 16 then Wait SerFullDelay1200 us: exit sub 	'1200 (833 us)
	movlw	16
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF39
	movlw	2
	movwf	DELAYTEMP2
DelayUSO6
	clrf	DELAYTEMP
DelayUS6
	decfsz	DELAYTEMP,F
	goto	DelayUS6
	decfsz	DELAYTEMP2,F
	goto	DelayUSO6
	movlw	24
	movwf	DELAYTEMP
DelayUS7
	decfsz	DELAYTEMP,F
	goto	DelayUS7
	return
ENDIF39
;if Ser_Rate = 32 then Wait SerFullDelay600 us: exit sub 	'600 (1666 us)
	movlw	32
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF40
	movlw	4
	movwf	DELAYTEMP2
DelayUSO8
	clrf	DELAYTEMP
DelayUS8
	decfsz	DELAYTEMP,F
	goto	DelayUS8
	decfsz	DELAYTEMP2,F
	goto	DelayUSO8
	movlw	65
	movwf	DELAYTEMP
DelayUS9
	decfsz	DELAYTEMP,F
	goto	DelayUS9
	nop
	return
ENDIF40
;if Ser_Rate = 64 then Wait SerFullDelay300 us: exit sub '300 (3333 us)
	movlw	64
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF41
	movlw	8
	movwf	DELAYTEMP2
DelayUSO10
	clrf	DELAYTEMP
DelayUS10
	decfsz	DELAYTEMP,F
	goto	DelayUS10
	decfsz	DELAYTEMP2,F
	goto	DelayUSO10
	movlw	149
	movwf	DELAYTEMP
DelayUS11
	decfsz	DELAYTEMP,F
	goto	DelayUS11
	return
ENDIF41
;for SerDelayLoop = 1 to Ser_Rate
	clrf	SERDELAYLOOP
	movlw	1
	subwf	SER_RATE,W
	btfss	STATUS, C
	goto	SysForLoopEnd5
SysForLoop5
	incf	SERDELAYLOOP,F
;Wait 42 us
	movlw	28
	movwf	DELAYTEMP
DelayUS12
	decfsz	DELAYTEMP,F
	goto	DelayUS12
;next
	movf	SER_RATE,W
	subwf	SERDELAYLOOP,W
	btfss	STATUS, C
	goto	SysForLoop5
SysForLoopEnd5
	return

;********************************************************************************

SERCFGLOAD
;Ser_Select_Old = Ser_Select
	movf	SER_SELECT,W
	movwf	SER_SELECT_OLD
;if Ser_Select = 1 THEN
	decf	SER_SELECT,W
	btfss	STATUS, Z
	goto	ENDIF34
;Ser_Rate = Ser_Rate_A
	movf	SER_RATE_A,W
	movwf	SER_RATE
;Ser_Start = Ser_Start_A
	movf	SER_START_A,W
	movwf	SER_START
;Ser_Data = Ser_Data_A
	movf	SER_DATA_A,W
	movwf	SER_DATA
;Ser_Stop = Ser_Stop_A
	movf	SER_STOP_A,W
	movwf	SER_STOP
;Ser_Parity = Ser_Parity_A
	movf	SER_PARITY_A,W
	movwf	SER_PARITY
;Ser_Invert = Ser_Invert_A
	movf	SER_INVERT_A,W
	movwf	SER_INVERT
;end if
ENDIF34
	return

;********************************************************************************

;Overloaded signature: BYTE:STRING:
SERPRINT13
;PrintLen = PrintData(0)
	movf	SysPRINTDATAHandler,W
	movwf	FSR
	bcf	STATUS, IRP
	btfsc	SysPRINTDATAHandler_H,0
	bsf	STATUS, IRP
	movf	INDF,W
	movwf	PRINTLEN
;if PrintLen = 0 then Goto SerPrintStrEnd
	movf	PRINTLEN,F
	btfsc	STATUS, Z
	goto	SERPRINTSTREND
;for SysPrintTemp = 1 to PrintLen
	clrf	SYSPRINTTEMP
	movlw	1
	subwf	PRINTLEN,W
	btfss	STATUS, C
	goto	SysForLoopEnd4
SysForLoop4
	incf	SYSPRINTTEMP,F
;SerSend(Ser_Select, PrintData(SysPrintTemp))
	movf	SYSPRINTTEMP,W
	addwf	SysPRINTDATAHandler,W
	movwf	FSR
	bcf	STATUS, IRP
	btfsc	SysPRINTDATAHandler_H,0
	bsf	STATUS, IRP
	movf	INDF,W
	movwf	SER_BYTE
	call	SERSEND
;next
	movf	PRINTLEN,W
	subwf	SYSPRINTTEMP,W
	btfss	STATUS, C
	goto	SysForLoop4
SysForLoopEnd4
SERPRINTSTREND
	return

;********************************************************************************

;Overloaded signature: BYTE:BYTE:
SERPRINT14
;OutValueTemp = 0
	clrf	OUTVALUETEMP
;IF SerPrintVal >= 100 Then
	movlw	100
	subwf	SERPRINTVAL,W
	btfss	STATUS, C
	goto	ENDIF32
;OutValueTemp = SerPrintVal / 100
	movf	SERPRINTVAL,W
	movwf	SysCalcTempA
	movlw	100
	movwf	SysCalcTempB
	call	SysDivSub
	movf	SysCalcTempA,W
	movwf	OUTVALUETEMP
;SerPrintVal = SysCalcTempX
	movf	SYSCALCTEMPX,W
	movwf	SERPRINTVAL
;SerSend(Ser_Select, OutValueTemp + 48)
	movlw	48
	addwf	OUTVALUETEMP,W
	movwf	SER_BYTE
	call	SERSEND
;End If
ENDIF32
;If OutValueTemp > 0 Or SerPrintVal >= 10 Then
	movf	OUTVALUETEMP,W
	movwf	SysCalcTempB
	clrf	SysCalcTempA
	call	SysCompLessThan
	movf	SysCalcTempX,W
	movwf	SysTemp1
	movf	SERPRINTVAL,W
	movwf	SysCalcTempA
	movlw	10
	movwf	SysCalcTempB
	call	SysCompLessThan
	comf	SysCalcTempX,F
	movf	SysTemp1,W
	iorwf	SysCalcTempX,W
	movwf	SysTemp2
	btfss	SysTemp2,0
	goto	ENDIF33
;OutValueTemp = SerPrintVal / 10
	movf	SERPRINTVAL,W
	movwf	SysCalcTempA
	movlw	10
	movwf	SysCalcTempB
	call	SysDivSub
	movf	SysCalcTempA,W
	movwf	OUTVALUETEMP
;SerPrintVal = SysCalcTempX
	movf	SYSCALCTEMPX,W
	movwf	SERPRINTVAL
;SerSend(Ser_Select, OutValueTemp + 48)
	movlw	48
	addwf	OUTVALUETEMP,W
	movwf	SER_BYTE
	call	SERSEND
;End If
ENDIF33
;SerSend(Ser_Select, SerPrintVal + 48)
	movlw	48
	addwf	SERPRINTVAL,W
	movwf	SER_BYTE
	goto	SERSEND

;********************************************************************************

SERSEND
;if Ser_Select <> Ser_Select_Old then SerCfgLoad(Ser_Select)
	movf	SER_SELECT_OLD,W
	subwf	SER_SELECT,W
	btfss	STATUS, Z
	call	SERCFGLOAD
;SerTemp = Ser_Start and (not WaitForStart)
	movlw	127
	andwf	SER_START,W
	movwf	SERTEMP
;for SerBit = 1 to SerTemp
	clrf	SERBIT
	movlw	1
	subwf	SERTEMP,W
	btfss	STATUS, C
	goto	SysForLoopEnd1
SysForLoop1
	incf	SERBIT,F
;SerTxHigh
;if Ser_Select = 1 THEN SendAHigh
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bsf	GPIO,5
;SerBitDelay
	call	SERBITDELAY
;next
	movf	SERTEMP,W
	subwf	SERBIT,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
;TempParity = SerTemp
	movf	SERTEMP,W
	movwf	TEMPPARITY
;for SerBit = 1 to Ser_Data
	clrf	SERBIT
	movlw	1
	subwf	SER_DATA,W
	btfss	STATUS, C
	goto	SysForLoopEnd2
SysForLoop2
	incf	SERBIT,F
;if Ser_Invert = normal then
	movf	SER_INVERT,F
	btfss	STATUS, Z
	goto	ENDIF8
;if Ser_Byte.0 ON then SerTxHigh: TempParity = TempParity + 1
	btfss	SER_BYTE,0
	goto	ENDIF15
;if Ser_Select = 1 THEN SendAHigh
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bsf	GPIO,5
;SerBitDelay
	call	SERBITDELAY
	incf	TEMPPARITY,F
ENDIF15
;if Ser_Byte.0 OFF then SerTxLow
	btfsc	SER_BYTE,0
	goto	ENDIF16
;if Ser_Select = 1 THEN SendALow
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bcf	GPIO,5
;SerBitDelay
	call	SERBITDELAY
ENDIF16
;end if
ENDIF8
;if Ser_Invert = invert then
	decf	SER_INVERT,W
	btfss	STATUS, Z
	goto	ENDIF9
;if Ser_Byte.0 ON then SerTxLow: TempParity = TempParity + 1
	btfss	SER_BYTE,0
	goto	ENDIF17
;if Ser_Select = 1 THEN SendALow
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bcf	GPIO,5
;SerBitDelay
	call	SERBITDELAY
	incf	TEMPPARITY,F
ENDIF17
;if Ser_Byte.0 OFF then SerTxHigh
	btfsc	SER_BYTE,0
	goto	ENDIF18
;if Ser_Select = 1 THEN SendAHigh
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bsf	GPIO,5
;SerBitDelay
	call	SERBITDELAY
ENDIF18
;end if
ENDIF9
;rotate Ser_Byte right
	rrf	SER_BYTE,F
;next
	movf	SER_DATA,W
	subwf	SERBIT,W
	btfss	STATUS, C
	goto	SysForLoop2
SysForLoopEnd2
;if Ser_Parity <> 0 THEN
	movf	SER_PARITY,F
	btfsc	STATUS, Z
	goto	ENDIF11
;if Ser_Parity = odd then TempParity = TempParity + 1
	decf	SER_PARITY,W
	btfsc	STATUS, Z
	incf	TEMPPARITY,F
;if Ser_Invert = invert then TempParity = TempParity + 1
	decf	SER_INVERT,W
	btfsc	STATUS, Z
	incf	TEMPPARITY,F
;if TempParity.0 = ON then SerTxLow
	btfss	TEMPPARITY,0
	goto	ENDIF21
;if Ser_Select = 1 THEN SendALow
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bcf	GPIO,5
;SerBitDelay
	call	SERBITDELAY
ENDIF21
;if TempParity.0 = OFF then SerTxHigh
	btfsc	TEMPPARITY,0
	goto	ENDIF22
;if Ser_Select = 1 THEN SendAHigh
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bsf	GPIO,5
;SerBitDelay
	call	SERBITDELAY
ENDIF22
;end if
ENDIF11
;for SerBit = 1 to Ser_Stop
	clrf	SERBIT
	movlw	1
	subwf	SER_STOP,W
	btfss	STATUS, C
	goto	SysForLoopEnd3
SysForLoop3
	incf	SERBIT,F
;SerTxLow
;if Ser_Select = 1 THEN SendALow
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bcf	GPIO,5
;SerBitDelay
	call	SERBITDELAY
;next
	movf	SER_STOP,W
	subwf	SERBIT,W
	btfss	STATUS, C
	goto	SysForLoop3
SysForLoopEnd3
;SerBitDelay
	goto	SERBITDELAY

;********************************************************************************

SYSCOMPLESSTHAN
;Dim SysCalcTempA, SysCalcTempB, SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;bsf STATUS, C
	bsf	STATUS, C
;movf SysCalcTempB, W
	movf	SYSCALCTEMPB, W
;subwf SysCalcTempA, W
	subwf	SYSCALCTEMPA, W
;btfss STATUS, C
	btfss	STATUS, C
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSDIVSUB
;dim SysCalcTempA as byte
;dim SysCalcTempB as byte
;dim SysCalcTempX as byte
;SysCalcTempX = 0
	clrf	SYSCALCTEMPX
;SysDivLoop = 8
	movlw	8
	movwf	SYSDIVLOOP
SYSDIV8START
;bcf STATUS, C
	bcf	STATUS, C
;rlf SysCalcTempA, F
	rlf	SYSCALCTEMPA, F
;rlf SysCalcTempX, F
	rlf	SYSCALCTEMPX, F
;movf SysCalcTempB, W
	movf	SYSCALCTEMPB, W
;subwf SysCalcTempX, F
	subwf	SYSCALCTEMPX, F
;bsf SysCalcTempA, 0
	bsf	SYSCALCTEMPA, 0
;btfsc STATUS, C
	btfsc	STATUS, C
;goto Div8NotNeg
	goto	DIV8NOTNEG
;bcf SysCalcTempA, 0
	bcf	SYSCALCTEMPA, 0
;movf SysCalcTempB, W
	movf	SYSCALCTEMPB, W
;addwf SysCalcTempX, F
	addwf	SYSCALCTEMPX, F
DIV8NOTNEG
;decfsz SysDivLoop, F
	decfsz	SYSDIVLOOP, F
;goto SysDiv8Start
	goto	SYSDIV8START
	return

;********************************************************************************

SYSREADSTRING
;Dim SysCalcTempA As Byte
;Dim SysStringLength As Byte
;movf SysStringB, W
	movf	SYSSTRINGB, W
;movwf FSR
	movwf	FSR
;bcf STATUS, IRP
	bcf	STATUS, IRP
;btfsc SysStringB_H, 0
	btfsc	SYSSTRINGB_H, 0
;bsf STATUS, IRP
	bsf	STATUS, IRP
;call SysStringTables
	call	SYSSTRINGTABLES
;movwf SysCalcTempA
	movwf	SYSCALCTEMPA
;movwf INDF
	movwf	INDF
;addwf SysStringB, F
	addwf	SYSSTRINGB, F
;goto SysStringReadCheck
	goto	SYSSTRINGREADCHECK
SYSREADSTRINGPART
;movf SysStringB, W
	movf	SYSSTRINGB, W
;movwf FSR
	movwf	FSR
;decf FSR,F
;bcf STATUS, IRP
	bcf	STATUS, IRP
;btfsc SysStringB_H, 0
	btfsc	SYSSTRINGB_H, 0
;bsf STATUS, IRP
	bsf	STATUS, IRP
;call SysStringTables
	call	SYSSTRINGTABLES
;movwf SysCalcTempA
	movwf	SYSCALCTEMPA
;addwf SysStringLength,F
	addwf	SYSSTRINGLENGTH,F
;addwf SysStringB,F
	addwf	SYSSTRINGB,F
SYSSTRINGREADCHECK
;movf SysCalcTempA,F
	movf	SYSCALCTEMPA,F
;btfsc STATUS,Z
	btfsc	STATUS,Z
;return
	return
SYSSTRINGREAD
;call SysStringTables
	call	SYSSTRINGTABLES
;incf FSR, F
	incf	FSR, F
;movwf INDF
	movwf	INDF
;decfsz SysCalcTempA, F
	decfsz	SYSCALCTEMPA, F
;goto SysStringRead
	goto	SYSSTRINGREAD
	return

;********************************************************************************

SysStringTables
	movf	SysStringA_H,W
	movwf	PCLATH
	movf	SysStringA,W
	incf	SysStringA,F
	btfsc	STATUS,Z
	incf	SysStringA_H,F
	movwf	PCL

StringTable1
	retlw	9
	retlw	80	;P
	retlw	111	;o
	retlw	115	;s
	retlw	105	;i
	retlw	116	;t
	retlw	105	;i
	retlw	111	;o
	retlw	110	;n
	retlw	32	; 


;********************************************************************************


 END
