;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
DELAYTEMP2	EQU	113
SYSDIVMULTA	EQU	119
SYSDIVMULTA_H	EQU	120
SYSDIVMULTB	EQU	123
SYSDIVMULTB_H	EQU	124
SYSDIVMULTX	EQU	114
SYSDIVMULTX_H	EQU	115
SYSSTRINGLENGTH	EQU	118
SysCalcTempA	EQU	117
SysCalcTempA_H	EQU	118
SysCalcTempB	EQU	121
SysCalcTempB_H	EQU	122
SysCalcTempX	EQU	112
SysCalcTempX_H	EQU	113
SysDivLoop	EQU	116
SysStringA	EQU	119
SysStringA_H	EQU	120
SysStringB	EQU	114
SysStringB_H	EQU	115
SysWaitTemp10US	EQU	117
SysWaitTempMS	EQU	114
SysWaitTempMS_H	EQU	115
SysWaitTempS	EQU	116
SysWaitTempUS	EQU	117
SysWaitTempUS_H	EQU	118
SYSSTRINGPARAM1	EQU	169
ADREADPORT	EQU	32
ADTEMP	EQU	33
OUTVALUETEMP	EQU	34
PREV	EQU	35
PREV_H	EQU	36
PRINTLEN	EQU	37
READAD10	EQU	38
READAD10_H	EQU	39
SERBIT	EQU	41
SERDELAYLOOP	EQU	42
SERPRINTVAL	EQU	43
SERPRINTVAL_H	EQU	44
SERTEMP	EQU	45
SER_BYTE	EQU	46
SER_DATA	EQU	47
SER_DATA_A	EQU	48
SER_INVERT	EQU	49
SER_INVERT_A	EQU	50
SER_PARITY	EQU	51
SER_PARITY_A	EQU	52
SER_RATE	EQU	53
SER_RATE_A	EQU	54
SER_SELECT	EQU	55
SER_SELECT_OLD	EQU	56
SER_START	EQU	57
SER_START_A	EQU	58
SER_STOP	EQU	59
SER_STOP_A	EQU	60
SYSPRINTTEMP	EQU	61
StringPointer	EQU	62
SysPRINTDATAHandler	EQU	63
SysPRINTDATAHandler_H	EQU	64
SysTemp1	EQU	65
SysTemp1_H	EQU	66
TEMP1	EQU	67
TEMP1_H	EQU	68
TEMP2	EQU	69
TEMP2_H	EQU	70
TEMPPARITY	EQU	71

;********************************************************************************

;Alias variables
ALLANSEL	EQU	ANSEL

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;This project sends the current temperature to a PC whenever
;it changes. Connect AN0/GP0 to the sensor, GP1 to Rx and GP2
;to Tx. Communication is via RS-232. If your PC fails to
;have a COM port, use a cheap USB-to-COM converter (available
;from Amazon and other places). Use any terminal program to
;log the results.
;----- Settings
;----- Constants
;#define sensor			GPIO.0						;temperature on pin 7
;#define SerInPort		GPIO.1            ;Rx input on pin 6
;#define SerOutPort	GPIO.2            ;Tx output on pin 5
;#define SendAHigh Set SerOutPort  on  ;output logic levels
;#define SendALow  Set SerOutPort  off
;#define RecAHigh  SerInPort       on  ;input logic levels
;#define RecALow   SerInPort       off
;#define cr 13                         ;carriage return
;#define lf 10                         ;line feed
;----- Variables
;dim temp1, temp2, prev as word		
;----- Program
;dir sensor in										;set temp sensor for input
	banksel	TRISIO
	bsf	TRISIO,0
;dir serInPort in								;Rx for input
	bsf	TRISIO,1
;dir serOutPort out							;Tx for output
	bcf	TRISIO,2
;InitSer 1, r4800, 1+WaitForStart, 8, 1, none, invert
	movlw	1
	banksel	SER_SELECT
	movwf	SER_SELECT
	movlw	4
	movwf	SER_RATE
	movlw	129
	movwf	SER_START
	movlw	8
	movwf	SER_DATA
	movlw	1
	movwf	SER_STOP
	clrf	SER_PARITY
	movlw	1
	movwf	SER_INVERT
	call	INITSER
;do
SysDoLoop_S1
;temp2 = readAD10(AN0)					;get reading, 10 bit accuracy
	clrf	ADREADPORT
	call	FN_READAD10
	movf	READAD10,W
	movwf	TEMP2
	movf	READAD10_H,W
	movwf	TEMP2_H
;temp1 = 125 * temp2						;now alter the scale
	movlw	125
	movwf	SysCalcTempA
	clrf	SysCalcTempA_H
	movf	TEMP2,W
	movwf	SysCalcTempB
	movf	TEMP2_H,W
	movwf	SysCalcTempB_H
	call	SysMultSub16
	movf	SysCalcTempX,W
	movwf	TEMP1
	movf	SysCalcTempX_H,W
	movwf	TEMP1_H
;temp2 = temp1 / 256						;quotient stored in temp2
	movf	TEMP1,W
	movwf	SysCalcTempA
	movf	TEMP1_H,W
	movwf	SysCalcTempA_H
	clrf	SysCalcTempB
	movlw	1
	movwf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	TEMP2
	movf	SysCalcTempA_H,W
	movwf	TEMP2_H
;temp1 = temp1 % 256						;remainder stored in temp1
	movf	TEMP1,W
	movwf	SysCalcTempA
	movf	TEMP1_H,W
	movwf	SysCalcTempA_H
	clrf	SysCalcTempB
	movlw	1
	movwf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempX,W
	movwf	TEMP1
	movf	SysCalcTempX_H,W
	movwf	TEMP1_H
;if temp1 > 127 then       		;is remainder past the midpoint?
	movf	TEMP1,W
	movwf	SysCalcTempB
	movf	TEMP1_H,W
	movwf	SysCalcTempB_H
	movlw	127
	movwf	SysCalcTempA
	clrf	SysCalcTempA_H
	call	SysCompLessThan16
	btfss	SysCalcTempX,0
	goto	ENDIF1
;temp2 ++                		;if so, bump to the next degree
	movlw	1
	addwf	TEMP2,F
	movf	TEMP2_H,W
	btfsc	STATUS,C
	addlw	1
	movwf	TEMP2_H
;end if
ENDIF1
;if temp2 <> prev then					;only update if different
	movf	TEMP2,W
	movwf	SysCalcTempA
	movf	TEMP2_H,W
	movwf	SysCalcTempA_H
	movf	PREV,W
	movwf	SysCalcTempB
	movf	PREV_H,W
	movwf	SysCalcTempB_H
	call	SysCompEqual16
	comf	SysCalcTempX,F
	btfss	SysCalcTempX,0
	goto	ENDIF2
;SerPrint 1, "Temperature: "	;echo to terminal
	movlw	1
	movwf	SER_SELECT
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable1
	movwf	SysStringA
	movlw	high StringTable1
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysPRINTDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysPRINTDATAHandler_H
	call	SERPRINT13
;SerPrint 1, temp2
	movlw	1
	movwf	SER_SELECT
	movf	TEMP2,W
	movwf	SERPRINTVAL
	movf	TEMP2_H,W
	movwf	SERPRINTVAL_H
	call	SERPRINT15
;SerSend 1, cr
	movlw	1
	movwf	SER_SELECT
	movlw	13
	movwf	SER_BYTE
	call	SERSEND
;SerSend 1, lf
	movlw	1
	movwf	SER_SELECT
	movlw	10
	movwf	SER_BYTE
	call	SERSEND
;prev = temp2								;this is the new previous
	movf	TEMP2,W
	movwf	PREV
	movf	TEMP2_H,W
	movwf	PREV_H
;end if	
ENDIF2
;wait 1 S											;wait a bit
	movlw	1
	movwf	SysWaitTempS
	call	Delay_S
;loop
	goto	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_10US
D10US_START
	movlw	5
	movwf	DELAYTEMP
DelayUS0
	decfsz	DELAYTEMP,F
	goto	DelayUS0
	nop
	decfsz	SysWaitTemp10US, F
	goto	D10US_START
	return

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	4
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	165
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

Delay_S
DS_START
	movlw	232
	movwf	SysWaitTempMS
	movlw	3
	movwf	SysWaitTempMS_H
	call	Delay_MS
	decfsz	SysWaitTempS, F
	goto	DS_START
	return

;********************************************************************************

INITSER
;Ser_Select_Old = Ser_Select
	movf	SER_SELECT,W
	movwf	SER_SELECT_OLD
;if Ser_Select = 1 THEN
	decf	SER_SELECT,W
	btfss	STATUS, Z
	goto	ENDIF5
;Ser_Rate_A = Ser_Rate
	movf	SER_RATE,W
	movwf	SER_RATE_A
;Ser_Start_A = Ser_Start
	movf	SER_START,W
	movwf	SER_START_A
;Ser_Data_A = Ser_Data
	movf	SER_DATA,W
	movwf	SER_DATA_A
;Ser_Stop_A = Ser_Stop
	movf	SER_STOP,W
	movwf	SER_STOP_A
;Ser_Parity_A = Ser_Parity
	movf	SER_PARITY,W
	movwf	SER_PARITY_A
;Ser_Invert_A = Ser_Invert
	movf	SER_INVERT,W
	movwf	SER_INVERT_A
;END IF
ENDIF5
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

FN_READAD10
;SET ADFM ON
	bsf	ADCON0,ADFM
;Do conversion
;LLReadAD
;Dim AllANSEL As Byte Alias ANSEL
;AllANSEL = 0
	banksel	ALLANSEL
	clrf	ALLANSEL
;ADTemp = ADReadPort + 1
	banksel	ADREADPORT
	incf	ADREADPORT,W
	movwf	ADTEMP
;Set C On
	bsf	STATUS,C
;Do
SysDoLoop_S2
;Rotate AllANSEL Left
	banksel	ALLANSEL
	rlf	ALLANSEL,F
;decfsz ADTemp,F
	banksel	ADTEMP
	decfsz	ADTEMP,F
;Loop
	goto	SysDoLoop_S2
SysDoLoop_E2
;SET ADCS1 OFF
	banksel	ANSEL
	bcf	ANSEL,ADCS1
;SET ADCS0 ON
	bsf	ANSEL,ADCS0
;SET ADCON0.CHS0 OFF
	banksel	ADCON0
	bcf	ADCON0,CHS0
;SET ADCON0.CHS1 OFF
	bcf	ADCON0,CHS1
;IF ADReadPort.0 On Then Set ADCON0.CHS0 On
	btfsc	ADREADPORT,0
	bsf	ADCON0,CHS0
;IF ADReadPort.1 On Then Set ADCON0.CHS1 On
	btfsc	ADREADPORT,1
	bsf	ADCON0,CHS1
;SET ADCON0.ADON ON
	bsf	ADCON0,ADON
;Wait AD_Delay
	movlw	2
	movwf	SysWaitTemp10US
	call	Delay_10US
;SET ADCON0.GO_DONE ON
	bsf	ADCON0,GO_DONE
;Wait While ADCON0.GO_DONE ON
SysWaitLoop1
	btfsc	ADCON0,GO_DONE
	goto	SysWaitLoop1
;SET ADCON0.ADON OFF
	bcf	ADCON0,ADON
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;ReadAD10 = ADRESL
	movf	ADRESL,W
	banksel	READAD10
	movwf	READAD10
	clrf	READAD10_H
;ReadAD10_H = ADRESH
	movf	ADRESH,W
	movwf	READAD10_H
;SET ADFM OFF
	bcf	ADCON0,ADFM
	return

;********************************************************************************

SERBITDELAY
;if Ser_Rate = 1 then Wait SerFullDelay19200 us: exit sub	'19200 (52 us)
	decf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF40
	movlw	19
	movwf	DELAYTEMP
DelayUS1
	decfsz	DELAYTEMP,F
	goto	DelayUS1
	return
ENDIF40
;if Ser_Rate = 2 then Wait SerFullDelay9600 us: exit sub 	'9600 (104 us)
	movlw	2
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF41
	movlw	52
	movwf	DELAYTEMP
DelayUS2
	decfsz	DELAYTEMP,F
	goto	DelayUS2
	nop
	return
ENDIF41
;if Ser_Rate = 4 then Wait SerFullDelay4800 us: exit sub 	'4800 (208 us)
	movlw	4
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF42
	movlw	122
	movwf	DELAYTEMP
DelayUS3
	decfsz	DELAYTEMP,F
	goto	DelayUS3
	return
ENDIF42
;if Ser_Rate = 8 then Wait SerFullDelay2400 us: exit sub 	'2400 (417 us)
	movlw	8
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF43
	movlw	1
	movwf	DELAYTEMP2
DelayUSO4
	clrf	DELAYTEMP
DelayUS4
	decfsz	DELAYTEMP,F
	goto	DelayUS4
	decfsz	DELAYTEMP2,F
	goto	DelayUSO4
	movlw	4
	movwf	DELAYTEMP
DelayUS5
	decfsz	DELAYTEMP,F
	goto	DelayUS5
	return
ENDIF43
;if Ser_Rate = 16 then Wait SerFullDelay1200 us: exit sub 	'1200 (833 us)
	movlw	16
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF44
	movlw	2
	movwf	DELAYTEMP2
DelayUSO6
	clrf	DELAYTEMP
DelayUS6
	decfsz	DELAYTEMP,F
	goto	DelayUS6
	decfsz	DELAYTEMP2,F
	goto	DelayUSO6
	movlw	24
	movwf	DELAYTEMP
DelayUS7
	decfsz	DELAYTEMP,F
	goto	DelayUS7
	return
ENDIF44
;if Ser_Rate = 32 then Wait SerFullDelay600 us: exit sub 	'600 (1666 us)
	movlw	32
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF45
	movlw	4
	movwf	DELAYTEMP2
DelayUSO8
	clrf	DELAYTEMP
DelayUS8
	decfsz	DELAYTEMP,F
	goto	DelayUS8
	decfsz	DELAYTEMP2,F
	goto	DelayUSO8
	movlw	65
	movwf	DELAYTEMP
DelayUS9
	decfsz	DELAYTEMP,F
	goto	DelayUS9
	nop
	return
ENDIF45
;if Ser_Rate = 64 then Wait SerFullDelay300 us: exit sub '300 (3333 us)
	movlw	64
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF46
	movlw	8
	movwf	DELAYTEMP2
DelayUSO10
	clrf	DELAYTEMP
DelayUS10
	decfsz	DELAYTEMP,F
	goto	DelayUS10
	decfsz	DELAYTEMP2,F
	goto	DelayUSO10
	movlw	149
	movwf	DELAYTEMP
DelayUS11
	decfsz	DELAYTEMP,F
	goto	DelayUS11
	return
ENDIF46
;for SerDelayLoop = 1 to Ser_Rate
	clrf	SERDELAYLOOP
	movlw	1
	subwf	SER_RATE,W
	btfss	STATUS, C
	goto	SysForLoopEnd5
SysForLoop5
	incf	SERDELAYLOOP,F
;Wait 42 us
	movlw	28
	movwf	DELAYTEMP
DelayUS12
	decfsz	DELAYTEMP,F
	goto	DelayUS12
;next
	movf	SER_RATE,W
	subwf	SERDELAYLOOP,W
	btfss	STATUS, C
	goto	SysForLoop5
SysForLoopEnd5
	return

;********************************************************************************

SERCFGLOAD
;Ser_Select_Old = Ser_Select
	movf	SER_SELECT,W
	movwf	SER_SELECT_OLD
;if Ser_Select = 1 THEN
	decf	SER_SELECT,W
	btfss	STATUS, Z
	goto	ENDIF39
;Ser_Rate = Ser_Rate_A
	movf	SER_RATE_A,W
	movwf	SER_RATE
;Ser_Start = Ser_Start_A
	movf	SER_START_A,W
	movwf	SER_START
;Ser_Data = Ser_Data_A
	movf	SER_DATA_A,W
	movwf	SER_DATA
;Ser_Stop = Ser_Stop_A
	movf	SER_STOP_A,W
	movwf	SER_STOP
;Ser_Parity = Ser_Parity_A
	movf	SER_PARITY_A,W
	movwf	SER_PARITY
;Ser_Invert = Ser_Invert_A
	movf	SER_INVERT_A,W
	movwf	SER_INVERT
;end if
ENDIF39
	return

;********************************************************************************

;Overloaded signature: BYTE:STRING:
SERPRINT13
;PrintLen = PrintData(0)
	movf	SysPRINTDATAHandler,W
	movwf	FSR
	bcf	STATUS, IRP
	btfsc	SysPRINTDATAHandler_H,0
	bsf	STATUS, IRP
	movf	INDF,W
	movwf	PRINTLEN
;if PrintLen = 0 then Goto SerPrintStrEnd
	movf	PRINTLEN,F
	btfsc	STATUS, Z
	goto	SERPRINTSTREND
;for SysPrintTemp = 1 to PrintLen
	clrf	SYSPRINTTEMP
	movlw	1
	subwf	PRINTLEN,W
	btfss	STATUS, C
	goto	SysForLoopEnd4
SysForLoop4
	incf	SYSPRINTTEMP,F
;SerSend(Ser_Select, PrintData(SysPrintTemp))
	movf	SYSPRINTTEMP,W
	addwf	SysPRINTDATAHandler,W
	movwf	FSR
	bcf	STATUS, IRP
	btfsc	SysPRINTDATAHandler_H,0
	bsf	STATUS, IRP
	movf	INDF,W
	movwf	SER_BYTE
	call	SERSEND
;next
	movf	PRINTLEN,W
	subwf	SYSPRINTTEMP,W
	btfss	STATUS, C
	goto	SysForLoop4
SysForLoopEnd4
SERPRINTSTREND
	return

;********************************************************************************

;Overloaded signature: BYTE:WORD:
SERPRINT15
;Dim SysCalcTempX As Word
;OutValueTemp = 0
	clrf	OUTVALUETEMP
;If SerPrintVal >= 10000 then
	movf	SERPRINTVAL,W
	movwf	SysCalcTempA
	movf	SERPRINTVAL_H,W
	movwf	SysCalcTempA_H
	movlw	16
	movwf	SysCalcTempB
	movlw	39
	movwf	SysCalcTempB_H
	call	SysCompLessThan16
	comf	SysCalcTempX,F
	btfss	SysCalcTempX,0
	goto	ENDIF35
;OutValueTemp = SerPrintVal / 10000 [word]
	movf	SERPRINTVAL,W
	movwf	SysCalcTempA
	movf	SERPRINTVAL_H,W
	movwf	SysCalcTempA_H
	movlw	16
	movwf	SysCalcTempB
	movlw	39
	movwf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	OUTVALUETEMP
;SerPrintVal = SysCalcTempX
	movf	SYSCALCTEMPX,W
	movwf	SERPRINTVAL
	movf	SYSCALCTEMPX_H,W
	movwf	SERPRINTVAL_H
;SerSend(Ser_Select, OutValueTemp + 48)
	movlw	48
	addwf	OUTVALUETEMP,W
	movwf	SER_BYTE
	call	SERSEND
;Goto SerPrintWord1000
	goto	SERPRINTWORD1000
;End If
ENDIF35
;If SerPrintVal >= 1000 then
	movf	SERPRINTVAL,W
	movwf	SysCalcTempA
	movf	SERPRINTVAL_H,W
	movwf	SysCalcTempA_H
	movlw	232
	movwf	SysCalcTempB
	movlw	3
	movwf	SysCalcTempB_H
	call	SysCompLessThan16
	comf	SysCalcTempX,F
	btfss	SysCalcTempX,0
	goto	ENDIF36
SERPRINTWORD1000
;OutValueTemp = SerPrintVal / 1000 [word]
	movf	SERPRINTVAL,W
	movwf	SysCalcTempA
	movf	SERPRINTVAL_H,W
	movwf	SysCalcTempA_H
	movlw	232
	movwf	SysCalcTempB
	movlw	3
	movwf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	OUTVALUETEMP
;SerPrintVal = SysCalcTempX
	movf	SYSCALCTEMPX,W
	movwf	SERPRINTVAL
	movf	SYSCALCTEMPX_H,W
	movwf	SERPRINTVAL_H
;SerSend(Ser_Select, OutValueTemp + 48)
	movlw	48
	addwf	OUTVALUETEMP,W
	movwf	SER_BYTE
	call	SERSEND
;Goto SerPrintWord100
	goto	SERPRINTWORD100
;End If
ENDIF36
;If SerPrintVal >= 100 then
	movf	SERPRINTVAL,W
	movwf	SysCalcTempA
	movf	SERPRINTVAL_H,W
	movwf	SysCalcTempA_H
	movlw	100
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysCompLessThan16
	comf	SysCalcTempX,F
	btfss	SysCalcTempX,0
	goto	ENDIF37
SERPRINTWORD100
;OutValueTemp = SerPrintVal / 100 [word]
	movf	SERPRINTVAL,W
	movwf	SysCalcTempA
	movf	SERPRINTVAL_H,W
	movwf	SysCalcTempA_H
	movlw	100
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	OUTVALUETEMP
;SerPrintVal = SysCalcTempX
	movf	SYSCALCTEMPX,W
	movwf	SERPRINTVAL
	movf	SYSCALCTEMPX_H,W
	movwf	SERPRINTVAL_H
;SerSend(Ser_Select, OutValueTemp + 48)
	movlw	48
	addwf	OUTVALUETEMP,W
	movwf	SER_BYTE
	call	SERSEND
	goto	SERPRINTWORD10
;End If
ENDIF37
;If SerPrintVal >= 10 then
	movf	SERPRINTVAL,W
	movwf	SysCalcTempA
	movf	SERPRINTVAL_H,W
	movwf	SysCalcTempA_H
	movlw	10
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysCompLessThan16
	comf	SysCalcTempX,F
	btfss	SysCalcTempX,0
	goto	ENDIF38
SERPRINTWORD10
;OutValueTemp = SerPrintVal / 10 [word]
	movf	SERPRINTVAL,W
	movwf	SysCalcTempA
	movf	SERPRINTVAL_H,W
	movwf	SysCalcTempA_H
	movlw	10
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	OUTVALUETEMP
;SerPrintVal = SysCalcTempX
	movf	SYSCALCTEMPX,W
	movwf	SERPRINTVAL
	movf	SYSCALCTEMPX_H,W
	movwf	SERPRINTVAL_H
;SerSend(Ser_Select, OutValueTemp + 48)
	movlw	48
	addwf	OUTVALUETEMP,W
	movwf	SER_BYTE
	call	SERSEND
;End If
ENDIF38
;SerSend(Ser_Select, SerPrintVal + 48)
	movlw	48
	addwf	SERPRINTVAL,W
	movwf	SER_BYTE
	goto	SERSEND

;********************************************************************************

SERSEND
;if Ser_Select <> Ser_Select_Old then SerCfgLoad(Ser_Select)
	movf	SER_SELECT_OLD,W
	subwf	SER_SELECT,W
	btfss	STATUS, Z
	call	SERCFGLOAD
;SerTemp = Ser_Start and (not WaitForStart)
	movlw	127
	andwf	SER_START,W
	movwf	SERTEMP
;for SerBit = 1 to SerTemp
	clrf	SERBIT
	movlw	1
	subwf	SERTEMP,W
	btfss	STATUS, C
	goto	SysForLoopEnd1
SysForLoop1
	incf	SERBIT,F
;SerTxHigh
;if Ser_Select = 1 THEN SendAHigh
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bsf	GPIO,2
;SerBitDelay
	call	SERBITDELAY
;next
	movf	SERTEMP,W
	subwf	SERBIT,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
;TempParity = SerTemp
	movf	SERTEMP,W
	movwf	TEMPPARITY
;for SerBit = 1 to Ser_Data
	clrf	SERBIT
	movlw	1
	subwf	SER_DATA,W
	btfss	STATUS, C
	goto	SysForLoopEnd2
SysForLoop2
	incf	SERBIT,F
;if Ser_Invert = normal then
	movf	SER_INVERT,F
	btfss	STATUS, Z
	goto	ENDIF11
;if Ser_Byte.0 ON then SerTxHigh: TempParity = TempParity + 1
	btfss	SER_BYTE,0
	goto	ENDIF18
;if Ser_Select = 1 THEN SendAHigh
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bsf	GPIO,2
;SerBitDelay
	call	SERBITDELAY
	incf	TEMPPARITY,F
ENDIF18
;if Ser_Byte.0 OFF then SerTxLow
	btfsc	SER_BYTE,0
	goto	ENDIF19
;if Ser_Select = 1 THEN SendALow
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bcf	GPIO,2
;SerBitDelay
	call	SERBITDELAY
ENDIF19
;end if
ENDIF11
;if Ser_Invert = invert then
	decf	SER_INVERT,W
	btfss	STATUS, Z
	goto	ENDIF12
;if Ser_Byte.0 ON then SerTxLow: TempParity = TempParity + 1
	btfss	SER_BYTE,0
	goto	ENDIF20
;if Ser_Select = 1 THEN SendALow
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bcf	GPIO,2
;SerBitDelay
	call	SERBITDELAY
	incf	TEMPPARITY,F
ENDIF20
;if Ser_Byte.0 OFF then SerTxHigh
	btfsc	SER_BYTE,0
	goto	ENDIF21
;if Ser_Select = 1 THEN SendAHigh
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bsf	GPIO,2
;SerBitDelay
	call	SERBITDELAY
ENDIF21
;end if
ENDIF12
;rotate Ser_Byte right
	rrf	SER_BYTE,F
;next
	movf	SER_DATA,W
	subwf	SERBIT,W
	btfss	STATUS, C
	goto	SysForLoop2
SysForLoopEnd2
;if Ser_Parity <> 0 THEN
	movf	SER_PARITY,F
	btfsc	STATUS, Z
	goto	ENDIF14
;if Ser_Parity = odd then TempParity = TempParity + 1
	decf	SER_PARITY,W
	btfsc	STATUS, Z
	incf	TEMPPARITY,F
;if Ser_Invert = invert then TempParity = TempParity + 1
	decf	SER_INVERT,W
	btfsc	STATUS, Z
	incf	TEMPPARITY,F
;if TempParity.0 = ON then SerTxLow
	btfss	TEMPPARITY,0
	goto	ENDIF24
;if Ser_Select = 1 THEN SendALow
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bcf	GPIO,2
;SerBitDelay
	call	SERBITDELAY
ENDIF24
;if TempParity.0 = OFF then SerTxHigh
	btfsc	TEMPPARITY,0
	goto	ENDIF25
;if Ser_Select = 1 THEN SendAHigh
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bsf	GPIO,2
;SerBitDelay
	call	SERBITDELAY
ENDIF25
;end if
ENDIF14
;for SerBit = 1 to Ser_Stop
	clrf	SERBIT
	movlw	1
	subwf	SER_STOP,W
	btfss	STATUS, C
	goto	SysForLoopEnd3
SysForLoop3
	incf	SERBIT,F
;SerTxLow
;if Ser_Select = 1 THEN SendALow
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bcf	GPIO,2
;SerBitDelay
	call	SERBITDELAY
;next
	movf	SER_STOP,W
	subwf	SERBIT,W
	btfss	STATUS, C
	goto	SysForLoop3
SysForLoopEnd3
;SerBitDelay
	goto	SERBITDELAY

;********************************************************************************

SYSCOMPEQUAL16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA, W
	movf	SYSCALCTEMPA, W
;subwf SysCalcTempB, W
	subwf	SYSCALCTEMPB, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;movf SysCalcTempA_H, W
	movf	SYSCALCTEMPA_H, W
;subwf SysCalcTempB_H, W
	subwf	SYSCALCTEMPB_H, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSCOMPLESSTHAN16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA_H,W
	movf	SYSCALCTEMPA_H,W
;subwf SysCalcTempB_H,W
	subwf	SYSCALCTEMPB_H,W
;btfss STATUS,C
	btfss	STATUS,C
;return
	return
;movf SysCalcTempB_H,W
	movf	SYSCALCTEMPB_H,W
;subwf SysCalcTempA_H,W
	subwf	SYSCALCTEMPA_H,W
;btfss STATUS,C
	btfss	STATUS,C
;goto SCLT16True
	goto	SCLT16TRUE
;movf SysCalcTempB,W
	movf	SYSCALCTEMPB,W
;subwf SysCalcTempA,W
	subwf	SYSCALCTEMPA,W
;btfsc STATUS,C
	btfsc	STATUS,C
;return
	return
SCLT16TRUE
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSDIVSUB16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as word
;dim SysDivMultA as word
;dim SysDivMultB as word
;dim SysDivMultX as word
;SysDivMultA = SysCalcTempA
	movf	SYSCALCTEMPA,W
	movwf	SYSDIVMULTA
	movf	SYSCALCTEMPA_H,W
	movwf	SYSDIVMULTA_H
;SysDivMultB = SysCalcTempB
	movf	SYSCALCTEMPB,W
	movwf	SYSDIVMULTB
	movf	SYSCALCTEMPB_H,W
	movwf	SYSDIVMULTB_H
;SysDivMultX = 0
	clrf	SYSDIVMULTX
	clrf	SYSDIVMULTX_H
;if SysDivMultB = 0 then
	movf	SYSDIVMULTB,W
	movwf	SysCalcTempA
	movf	SYSDIVMULTB_H,W
	movwf	SysCalcTempA_H
	clrf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysCompEqual16
	btfss	SysCalcTempX,0
	goto	ENDIF51
;SysCalcTempA = 0
	clrf	SYSCALCTEMPA
	clrf	SYSCALCTEMPA_H
;exit sub
	return
;end if
ENDIF51
;SysDivLoop = 16
	movlw	16
	movwf	SYSDIVLOOP
SYSDIV16START
;set C off
	bcf	STATUS,C
;Rotate SysDivMultA Left
	rlf	SYSDIVMULTA,F
	rlf	SYSDIVMULTA_H,F
;Rotate SysDivMultX Left
	rlf	SYSDIVMULTX,F
	rlf	SYSDIVMULTX_H,F
;SysDivMultX = SysDivMultX - SysDivMultB
	movf	SYSDIVMULTB,W
	subwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfss	STATUS,C
	addlw	1
	subwf	SYSDIVMULTX_H,F
;Set SysDivMultA.0 On
	bsf	SYSDIVMULTA,0
;If C Off Then
	btfsc	STATUS,C
	goto	ENDIF52
;Set SysDivMultA.0 Off
	bcf	SYSDIVMULTA,0
;SysDivMultX = SysDivMultX + SysDivMultB
	movf	SYSDIVMULTB,W
	addwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfsc	STATUS,C
	addlw	1
	addwf	SYSDIVMULTX_H,F
;End If
ENDIF52
;decfsz SysDivLoop, F
	decfsz	SYSDIVLOOP, F
;goto SysDiv16Start
	goto	SYSDIV16START
;SysCalcTempA = SysDivMultA
	movf	SYSDIVMULTA,W
	movwf	SYSCALCTEMPA
	movf	SYSDIVMULTA_H,W
	movwf	SYSCALCTEMPA_H
;SysCalcTempX = SysDivMultX
	movf	SYSDIVMULTX,W
	movwf	SYSCALCTEMPX
	movf	SYSDIVMULTX_H,W
	movwf	SYSCALCTEMPX_H
	return

;********************************************************************************

SYSMULTSUB16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as word
;dim SysDivMultA as word
;dim SysDivMultB as word
;dim SysDivMultX as word
;SysDivMultA = SysCalcTempA
	movf	SYSCALCTEMPA,W
	movwf	SYSDIVMULTA
	movf	SYSCALCTEMPA_H,W
	movwf	SYSDIVMULTA_H
;SysDivMultB = SysCalcTempB
	movf	SYSCALCTEMPB,W
	movwf	SYSDIVMULTB
	movf	SYSCALCTEMPB_H,W
	movwf	SYSDIVMULTB_H
;SysDivMultX = 0
	clrf	SYSDIVMULTX
	clrf	SYSDIVMULTX_H
MUL16LOOP
;IF SysDivMultB.0 ON then SysDivMultX += SysDivMultA
	btfss	SYSDIVMULTB,0
	goto	ENDIF49
	movf	SYSDIVMULTA,W
	addwf	SYSDIVMULTX,F
	movf	SYSDIVMULTA_H,W
	btfsc	STATUS,C
	addlw	1
	addwf	SYSDIVMULTX_H,F
ENDIF49
;set STATUS.C OFF
	bcf	STATUS,C
;rotate SysDivMultB right
	rrf	SYSDIVMULTB_H,F
	rrf	SYSDIVMULTB,F
;set STATUS.C off
	bcf	STATUS,C
;rotate SysDivMultA left
	rlf	SYSDIVMULTA,F
	rlf	SYSDIVMULTA_H,F
;if SysDivMultB > 0 then goto MUL16LOOP
	movf	SYSDIVMULTB,W
	movwf	SysCalcTempB
	movf	SYSDIVMULTB_H,W
	movwf	SysCalcTempB_H
	clrf	SysCalcTempA
	clrf	SysCalcTempA_H
	call	SysCompLessThan16
	btfsc	SysCalcTempX,0
	goto	MUL16LOOP
;SysCalcTempX = SysDivMultX
	movf	SYSDIVMULTX,W
	movwf	SYSCALCTEMPX
	movf	SYSDIVMULTX_H,W
	movwf	SYSCALCTEMPX_H
	return

;********************************************************************************

SYSREADSTRING
;Dim SysCalcTempA As Byte
;Dim SysStringLength As Byte
;movf SysStringB, W
	movf	SYSSTRINGB, W
;movwf FSR
	movwf	FSR
;bcf STATUS, IRP
	bcf	STATUS, IRP
;btfsc SysStringB_H, 0
	btfsc	SYSSTRINGB_H, 0
;bsf STATUS, IRP
	bsf	STATUS, IRP
;call SysStringTables
	call	SYSSTRINGTABLES
;movwf SysCalcTempA
	movwf	SYSCALCTEMPA
;movwf INDF
	movwf	INDF
;addwf SysStringB, F
	addwf	SYSSTRINGB, F
;goto SysStringReadCheck
	goto	SYSSTRINGREADCHECK
SYSREADSTRINGPART
;movf SysStringB, W
	movf	SYSSTRINGB, W
;movwf FSR
	movwf	FSR
;decf FSR,F
;bcf STATUS, IRP
	bcf	STATUS, IRP
;btfsc SysStringB_H, 0
	btfsc	SYSSTRINGB_H, 0
;bsf STATUS, IRP
	bsf	STATUS, IRP
;call SysStringTables
	call	SYSSTRINGTABLES
;movwf SysCalcTempA
	movwf	SYSCALCTEMPA
;addwf SysStringLength,F
	addwf	SYSSTRINGLENGTH,F
;addwf SysStringB,F
	addwf	SYSSTRINGB,F
SYSSTRINGREADCHECK
;movf SysCalcTempA,F
	movf	SYSCALCTEMPA,F
;btfsc STATUS,Z
	btfsc	STATUS,Z
;return
	return
SYSSTRINGREAD
;call SysStringTables
	call	SYSSTRINGTABLES
;incf FSR, F
	incf	FSR, F
;movwf INDF
	movwf	INDF
;decfsz SysCalcTempA, F
	decfsz	SYSCALCTEMPA, F
;goto SysStringRead
	goto	SYSSTRINGREAD
	return

;********************************************************************************

SysStringTables
	movf	SysStringA_H,W
	movwf	PCLATH
	movf	SysStringA,W
	incf	SysStringA,F
	btfsc	STATUS,Z
	incf	SysStringA_H,F
	movwf	PCL

StringTable1
	retlw	13
	retlw	84	;T
	retlw	101	;e
	retlw	109	;m
	retlw	112	;p
	retlw	101	;e
	retlw	114	;r
	retlw	97	;a
	retlw	116	;t
	retlw	117	;u
	retlw	114	;r
	retlw	101	;e
	retlw	58	;:
	retlw	32	; 


;********************************************************************************


 END
