;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
SYSDIVMULTA	EQU	119
SYSDIVMULTA_H	EQU	120
SYSDIVMULTB	EQU	123
SYSDIVMULTB_H	EQU	124
SYSDIVMULTX	EQU	114
SYSDIVMULTX_H	EQU	115
SysCalcTempA	EQU	117
SysCalcTempA_H	EQU	118
SysCalcTempB	EQU	121
SysCalcTempB_H	EQU	122
SysCalcTempX	EQU	112
SysCalcTempX_H	EQU	113
SysDivLoop	EQU	116
SysWaitTemp10US	EQU	117
ADREADPORT	EQU	32
ADTEMP	EQU	33
PATTERN	EQU	34
READAD10	EQU	35
READAD10_H	EQU	36
SysTemp1	EQU	38
TEMP1	EQU	39
TEMP1_H	EQU	40
TEMP2	EQU	41
TEMP2_H	EQU	42

;********************************************************************************

;Alias variables
ALLANSEL	EQU	ANSEL

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;This project displays temperature ranges using the LEDs.
;The ranges are below 50, 50-59, 60-69 and 70 and above.
;Connect AN0/GP0 to the sensor, then GP1, GP2, GP4
;and GP5 to LED1 through LED4, respectively. If desired,
;the bicolor LED could replace one of these, with
;green indicating a particular range. Just ground the
;red element to make it a green LED.
;----- Settings
;----- Constants
;#define sensor AN0							;temperature on pin 7
;----- Variables
;dim pattern as byte
;dim temp1, temp2 as word		
;----- Program
;dir GPIO out										;most pins are outputs
	banksel	TRISIO
	clrf	TRISIO
;dir GPIO.0 in										;except pin 7
	bsf	TRISIO,0
;do
SysDoLoop_S1
;temp2 = readAD10(sensor)			;get reading, 10 bit accuracy
	banksel	ADREADPORT
	clrf	ADREADPORT
	call	FN_READAD10
	movf	READAD10,W
	movwf	TEMP2
	movf	READAD10_H,W
	movwf	TEMP2_H
;temp1 = 125 * temp2						;now alter the scale
	movlw	125
	movwf	SysCalcTempA
	clrf	SysCalcTempA_H
	movf	TEMP2,W
	movwf	SysCalcTempB
	movf	TEMP2_H,W
	movwf	SysCalcTempB_H
	call	SysMultSub16
	movf	SysCalcTempX,W
	movwf	TEMP1
	movf	SysCalcTempX_H,W
	movwf	TEMP1_H
;temp2 = temp1 / 256						;quotient stored in temp2
	movf	TEMP1,W
	movwf	SysCalcTempA
	movf	TEMP1_H,W
	movwf	SysCalcTempA_H
	clrf	SysCalcTempB
	movlw	1
	movwf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	TEMP2
	movf	SysCalcTempA_H,W
	movwf	TEMP2_H
;temp1 = temp1 % 256						;remainder stored in temp1
	movf	TEMP1,W
	movwf	SysCalcTempA
	movf	TEMP1_H,W
	movwf	SysCalcTempA_H
	clrf	SysCalcTempB
	movlw	1
	movwf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempX,W
	movwf	TEMP1
	movf	SysCalcTempX_H,W
	movwf	TEMP1_H
;if temp1 > 127 then       		;is remainder past the midpoint?
	movf	TEMP1,W
	movwf	SysCalcTempB
	movf	TEMP1_H,W
	movwf	SysCalcTempB_H
	movlw	127
	movwf	SysCalcTempA
	clrf	SysCalcTempA_H
	call	SysCompLessThan16
	btfss	SysCalcTempX,0
	goto	ENDIF1
;temp2++                			;if so, bump to the next degree
	movlw	1
	addwf	TEMP2,F
	movf	TEMP2_H,W
	btfsc	STATUS,C
	addlw	1
	movwf	TEMP2_H
;end if
ENDIF1
;if temp2 > 69 then						;decide which LED is needed
	movf	TEMP2,W
	movwf	SysCalcTempB
	movf	TEMP2_H,W
	movwf	SysCalcTempB_H
	movlw	69
	movwf	SysCalcTempA
	clrf	SysCalcTempA_H
	call	SysCompLessThan16
	btfss	SysCalcTempX,0
	goto	ENDIF2
;pattern = 0b00100000
	movlw	32
	movwf	PATTERN
;goto done
	goto	DONE
;end if
ENDIF2
;if temp2 > 59 then
	movf	TEMP2,W
	movwf	SysCalcTempB
	movf	TEMP2_H,W
	movwf	SysCalcTempB_H
	movlw	59
	movwf	SysCalcTempA
	clrf	SysCalcTempA_H
	call	SysCompLessThan16
	btfss	SysCalcTempX,0
	goto	ENDIF3
;pattern = 0b00010000
	movlw	16
	movwf	PATTERN
;goto done
	goto	DONE
;end if
ENDIF3
;if temp2 > 49 then
	movf	TEMP2,W
	movwf	SysCalcTempB
	movf	TEMP2_H,W
	movwf	SysCalcTempB_H
	movlw	49
	movwf	SysCalcTempA
	clrf	SysCalcTempA_H
	call	SysCompLessThan16
	btfss	SysCalcTempX,0
	goto	ELSE4_1
;pattern = 0b00000100
	movlw	4
	movwf	PATTERN
;else
	goto	ENDIF4
ELSE4_1
;pattern = 0b00000010
	movlw	2
	movwf	PATTERN
;end if
ENDIF4
DONE
;gpio = pattern							;update LEDs
	movf	PATTERN,W
	movwf	GPIO
;loop														;repeat in perpetuity
	goto	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_10US
D10US_START
	movlw	5
	movwf	DELAYTEMP
DelayUS0
	decfsz	DELAYTEMP,F
	goto	DelayUS0
	nop
	decfsz	SysWaitTemp10US, F
	goto	D10US_START
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

FN_READAD10
;SET ADFM ON
	bsf	ADCON0,ADFM
;Do conversion
;LLReadAD
;Dim AllANSEL As Byte Alias ANSEL
;AllANSEL = 0
	banksel	ALLANSEL
	clrf	ALLANSEL
;ADTemp = ADReadPort + 1
	banksel	ADREADPORT
	incf	ADREADPORT,W
	movwf	ADTEMP
;Set C On
	bsf	STATUS,C
;Do
SysDoLoop_S2
;Rotate AllANSEL Left
	banksel	ALLANSEL
	rlf	ALLANSEL,F
;decfsz ADTemp,F
	banksel	ADTEMP
	decfsz	ADTEMP,F
;Loop
	goto	SysDoLoop_S2
SysDoLoop_E2
;SET ADCS1 OFF
	banksel	ANSEL
	bcf	ANSEL,ADCS1
;SET ADCS0 ON
	bsf	ANSEL,ADCS0
;SET ADCON0.CHS0 OFF
	banksel	ADCON0
	bcf	ADCON0,CHS0
;SET ADCON0.CHS1 OFF
	bcf	ADCON0,CHS1
;IF ADReadPort.0 On Then Set ADCON0.CHS0 On
	btfsc	ADREADPORT,0
	bsf	ADCON0,CHS0
;IF ADReadPort.1 On Then Set ADCON0.CHS1 On
	btfsc	ADREADPORT,1
	bsf	ADCON0,CHS1
;SET ADCON0.ADON ON
	bsf	ADCON0,ADON
;Wait AD_Delay
	movlw	2
	movwf	SysWaitTemp10US
	call	Delay_10US
;SET ADCON0.GO_DONE ON
	bsf	ADCON0,GO_DONE
;Wait While ADCON0.GO_DONE ON
SysWaitLoop1
	btfsc	ADCON0,GO_DONE
	goto	SysWaitLoop1
;SET ADCON0.ADON OFF
	bcf	ADCON0,ADON
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;ReadAD10 = ADRESL
	movf	ADRESL,W
	banksel	READAD10
	movwf	READAD10
	clrf	READAD10_H
;ReadAD10_H = ADRESH
	movf	ADRESH,W
	movwf	READAD10_H
;SET ADFM OFF
	bcf	ADCON0,ADFM
	return

;********************************************************************************

SYSCOMPEQUAL16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA, W
	movf	SYSCALCTEMPA, W
;subwf SysCalcTempB, W
	subwf	SYSCALCTEMPB, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;movf SysCalcTempA_H, W
	movf	SYSCALCTEMPA_H, W
;subwf SysCalcTempB_H, W
	subwf	SYSCALCTEMPB_H, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSCOMPLESSTHAN16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA_H,W
	movf	SYSCALCTEMPA_H,W
;subwf SysCalcTempB_H,W
	subwf	SYSCALCTEMPB_H,W
;btfss STATUS,C
	btfss	STATUS,C
;return
	return
;movf SysCalcTempB_H,W
	movf	SYSCALCTEMPB_H,W
;subwf SysCalcTempA_H,W
	subwf	SYSCALCTEMPA_H,W
;btfss STATUS,C
	btfss	STATUS,C
;goto SCLT16True
	goto	SCLT16TRUE
;movf SysCalcTempB,W
	movf	SYSCALCTEMPB,W
;subwf SysCalcTempA,W
	subwf	SYSCALCTEMPA,W
;btfsc STATUS,C
	btfsc	STATUS,C
;return
	return
SCLT16TRUE
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSDIVSUB16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as word
;dim SysDivMultA as word
;dim SysDivMultB as word
;dim SysDivMultX as word
;SysDivMultA = SysCalcTempA
	movf	SYSCALCTEMPA,W
	movwf	SYSDIVMULTA
	movf	SYSCALCTEMPA_H,W
	movwf	SYSDIVMULTA_H
;SysDivMultB = SysCalcTempB
	movf	SYSCALCTEMPB,W
	movwf	SYSDIVMULTB
	movf	SYSCALCTEMPB_H,W
	movwf	SYSDIVMULTB_H
;SysDivMultX = 0
	clrf	SYSDIVMULTX
	clrf	SYSDIVMULTX_H
;if SysDivMultB = 0 then
	movf	SYSDIVMULTB,W
	movwf	SysCalcTempA
	movf	SYSDIVMULTB_H,W
	movwf	SysCalcTempA_H
	clrf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysCompEqual16
	btfss	SysCalcTempX,0
	goto	ENDIF9
;SysCalcTempA = 0
	clrf	SYSCALCTEMPA
	clrf	SYSCALCTEMPA_H
;exit sub
	return
;end if
ENDIF9
;SysDivLoop = 16
	movlw	16
	movwf	SYSDIVLOOP
SYSDIV16START
;set C off
	bcf	STATUS,C
;Rotate SysDivMultA Left
	rlf	SYSDIVMULTA,F
	rlf	SYSDIVMULTA_H,F
;Rotate SysDivMultX Left
	rlf	SYSDIVMULTX,F
	rlf	SYSDIVMULTX_H,F
;SysDivMultX = SysDivMultX - SysDivMultB
	movf	SYSDIVMULTB,W
	subwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfss	STATUS,C
	addlw	1
	subwf	SYSDIVMULTX_H,F
;Set SysDivMultA.0 On
	bsf	SYSDIVMULTA,0
;If C Off Then
	btfsc	STATUS,C
	goto	ENDIF10
;Set SysDivMultA.0 Off
	bcf	SYSDIVMULTA,0
;SysDivMultX = SysDivMultX + SysDivMultB
	movf	SYSDIVMULTB,W
	addwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfsc	STATUS,C
	addlw	1
	addwf	SYSDIVMULTX_H,F
;End If
ENDIF10
;decfsz SysDivLoop, F
	decfsz	SYSDIVLOOP, F
;goto SysDiv16Start
	goto	SYSDIV16START
;SysCalcTempA = SysDivMultA
	movf	SYSDIVMULTA,W
	movwf	SYSCALCTEMPA
	movf	SYSDIVMULTA_H,W
	movwf	SYSCALCTEMPA_H
;SysCalcTempX = SysDivMultX
	movf	SYSDIVMULTX,W
	movwf	SYSCALCTEMPX
	movf	SYSDIVMULTX_H,W
	movwf	SYSCALCTEMPX_H
	return

;********************************************************************************

SYSMULTSUB16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as word
;dim SysDivMultA as word
;dim SysDivMultB as word
;dim SysDivMultX as word
;SysDivMultA = SysCalcTempA
	movf	SYSCALCTEMPA,W
	movwf	SYSDIVMULTA
	movf	SYSCALCTEMPA_H,W
	movwf	SYSDIVMULTA_H
;SysDivMultB = SysCalcTempB
	movf	SYSCALCTEMPB,W
	movwf	SYSDIVMULTB
	movf	SYSCALCTEMPB_H,W
	movwf	SYSDIVMULTB_H
;SysDivMultX = 0
	clrf	SYSDIVMULTX
	clrf	SYSDIVMULTX_H
MUL16LOOP
;IF SysDivMultB.0 ON then SysDivMultX += SysDivMultA
	btfss	SYSDIVMULTB,0
	goto	ENDIF7
	movf	SYSDIVMULTA,W
	addwf	SYSDIVMULTX,F
	movf	SYSDIVMULTA_H,W
	btfsc	STATUS,C
	addlw	1
	addwf	SYSDIVMULTX_H,F
ENDIF7
;set STATUS.C OFF
	bcf	STATUS,C
;rotate SysDivMultB right
	rrf	SYSDIVMULTB_H,F
	rrf	SYSDIVMULTB,F
;set STATUS.C off
	bcf	STATUS,C
;rotate SysDivMultA left
	rlf	SYSDIVMULTA,F
	rlf	SYSDIVMULTA_H,F
;if SysDivMultB > 0 then goto MUL16LOOP
	movf	SYSDIVMULTB,W
	movwf	SysCalcTempB
	movf	SYSDIVMULTB_H,W
	movwf	SysCalcTempB_H
	clrf	SysCalcTempA
	clrf	SysCalcTempA_H
	call	SysCompLessThan16
	btfsc	SysCalcTempX,0
	goto	MUL16LOOP
;SysCalcTempX = SysDivMultX
	movf	SYSDIVMULTX,W
	movwf	SYSCALCTEMPX
	movf	SYSDIVMULTX_H,W
	movwf	SYSCALCTEMPX_H
	return

;********************************************************************************


 END
