;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
DELAYTEMP2	EQU	113
SYSCALCTEMPX	EQU	112
SysCalcTempA	EQU	117
SysCalcTempB	EQU	121
SysDivLoop	EQU	116
SysWaitTemp10US	EQU	117
SysWaitTempMS	EQU	114
SysWaitTempMS_H	EQU	115
ADREADPORT	EQU	32
ADTEMP	EQU	33
CURRENT	EQU	34
LSN	EQU	35
MSN	EQU	36
PREV	EQU	37
READAD	EQU	38
SysTemp1	EQU	39

;********************************************************************************

;Alias variables
ALLANSEL	EQU	ANSEL

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;Display potentiometer setting on four LEDs; interpret result
;as a binary number. Connect AN0/GP0 to the pot. Connect
;GP1, GP2, GP4 and GP5 to LED1 through LED4, respectively.
;----- Settings
;----- Constants
;#define pot	GPIO.0							;pot on pin 7 (AN0)
;----- Variables
;dim current, prev, lsn, msn as byte
;----- Program
;dir GPIO out										;most lines are outputs
	banksel	TRISIO
	clrf	TRISIO
;dir pot in											;except for pot
	bsf	TRISIO,0
;prev = 0
	banksel	PREV
	clrf	PREV
;do
SysDoLoop_S1
;current = readAD(AN0)					;get pot reading
	clrf	ADREADPORT
	call	FN_READAD
	movf	READAD,W
	movwf	CURRENT
;current = current/16					;scale: 0 to F
	movwf	SysCalcTempA
	movlw	16
	movwf	SysCalcTempB
	call	SysDivSub
	movf	SysCalcTempA,W
	movwf	CURRENT
;if current <> prev then				;display only if new value
	movf	PREV,W
	subwf	CURRENT,W
	btfsc	STATUS, Z
	goto	ENDIF1
;showIt
	call	SHOWIT
;prev = current							;this becomes new previous value
	movf	CURRENT,W
	movwf	PREV
;end if	
ENDIF1
;wait 10 mS										;let it settle a bit
	movlw	10
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;loop														;repeat in perpetuity
	goto	SysDoLoop_S1
SysDoLoop_E1
;----- Subroutines
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_10US
D10US_START
	movlw	5
	movwf	DELAYTEMP
DelayUS0
	decfsz	DELAYTEMP,F
	goto	DelayUS0
	nop
	decfsz	SysWaitTemp10US, F
	goto	D10US_START
	return

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	4
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	165
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

FN_READAD
;Set up for 8 bit
;Perform conversion
;LLReadAD
;Dim AllANSEL As Byte Alias ANSEL
;AllANSEL = 0
	banksel	ALLANSEL
	clrf	ALLANSEL
;ADTemp = ADReadPort + 1
	banksel	ADREADPORT
	incf	ADREADPORT,W
	movwf	ADTEMP
;Set C On
	bsf	STATUS,C
;Do
SysDoLoop_S2
;Rotate AllANSEL Left
	banksel	ALLANSEL
	rlf	ALLANSEL,F
;decfsz ADTemp,F
	banksel	ADTEMP
	decfsz	ADTEMP,F
;Loop
	goto	SysDoLoop_S2
SysDoLoop_E2
;SET ADCS1 OFF
	banksel	ANSEL
	bcf	ANSEL,ADCS1
;SET ADCS0 ON
	bsf	ANSEL,ADCS0
;SET ADCON0.CHS0 OFF
	banksel	ADCON0
	bcf	ADCON0,CHS0
;SET ADCON0.CHS1 OFF
	bcf	ADCON0,CHS1
;IF ADReadPort.0 On Then Set ADCON0.CHS0 On
	btfsc	ADREADPORT,0
	bsf	ADCON0,CHS0
;IF ADReadPort.1 On Then Set ADCON0.CHS1 On
	btfsc	ADREADPORT,1
	bsf	ADCON0,CHS1
;SET ADCON0.ADON ON
	bsf	ADCON0,ADON
;Wait AD_Delay
	movlw	2
	movwf	SysWaitTemp10US
	call	Delay_10US
;SET ADCON0.GO_DONE ON
	bsf	ADCON0,GO_DONE
;Wait While ADCON0.GO_DONE ON
SysWaitLoop1
	btfsc	ADCON0,GO_DONE
	goto	SysWaitLoop1
;SET ADCON0.ADON OFF
	bcf	ADCON0,ADON
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;Write output
;ReadAD = ADRESH
	banksel	ADRESH
	movf	ADRESH,W
	movwf	READAD
	return

;********************************************************************************

SHOWIT
;lsn = current*2 & 0b00000110	;make least significant nibble
	bcf	STATUS,C
	rlf	CURRENT,W
	movwf	SysTemp1
	movlw	6
	andwf	SysTemp1,W
	movwf	LSN
;msn = current*4 & 0b00110000	;make most signicant nibble
	movf	CURRENT,W
	movwf	SysCalcTempA
	movlw	4
	movwf	SysCalcTempB
	call	SysMultSub
	movlw	48
	andwf	SYSCALCTEMPX,W
	movwf	MSN
;lsn = msn | lsn								;make final pattern							;
	iorwf	LSN,F
;GPIO = lsn
	movf	LSN,W
	movwf	GPIO
	return

;********************************************************************************

SYSDIVSUB
;dim SysCalcTempA as byte
;dim SysCalcTempB as byte
;dim SysCalcTempX as byte
;SysCalcTempX = 0
	clrf	SYSCALCTEMPX
;SysDivLoop = 8
	movlw	8
	movwf	SYSDIVLOOP
SYSDIV8START
;bcf STATUS, C
	bcf	STATUS, C
;rlf SysCalcTempA, F
	rlf	SYSCALCTEMPA, F
;rlf SysCalcTempX, F
	rlf	SYSCALCTEMPX, F
;movf SysCalcTempB, W
	movf	SYSCALCTEMPB, W
;subwf SysCalcTempX, F
	subwf	SYSCALCTEMPX, F
;bsf SysCalcTempA, 0
	bsf	SYSCALCTEMPA, 0
;btfsc STATUS, C
	btfsc	STATUS, C
;goto Div8NotNeg
	goto	DIV8NOTNEG
;bcf SysCalcTempA, 0
	bcf	SYSCALCTEMPA, 0
;movf SysCalcTempB, W
	movf	SYSCALCTEMPB, W
;addwf SysCalcTempX, F
	addwf	SYSCALCTEMPX, F
DIV8NOTNEG
;decfsz SysDivLoop, F
	decfsz	SYSDIVLOOP, F
;goto SysDiv8Start
	goto	SYSDIV8START
	return

;********************************************************************************

SYSMULTSUB
;dim SysCalcTempA as byte
;dim SysCalcTempB as byte
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
MUL8LOOP
;movf SysCalcTempA, W
	movf	SYSCALCTEMPA, W
;btfsc SysCalcTempB, 0
	btfsc	SYSCALCTEMPB, 0
;addwf SysCalcTempX, F
	addwf	SYSCALCTEMPX, F
;bcf STATUS, C
	bcf	STATUS, C
;rrf SysCalcTempB, F
	rrf	SYSCALCTEMPB, F
;bcf STATUS, C
	bcf	STATUS, C
;rlf SysCalcTempA, F
	rlf	SYSCALCTEMPA, F
;movf SysCalcTempB, F
	movf	SYSCALCTEMPB, F
;btfss STATUS, Z
	btfss	STATUS, Z
;goto MUL8LOOP
	goto	MUL8LOOP
	return

;********************************************************************************


 END
