;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
SYSDIVMULTA	EQU	119
SYSDIVMULTA_H	EQU	120
SYSDIVMULTB	EQU	123
SYSDIVMULTB_H	EQU	124
SYSDIVMULTX	EQU	114
SYSDIVMULTX_H	EQU	115
SysCalcTempA	EQU	117
SysCalcTempA_H	EQU	118
SysCalcTempB	EQU	121
SysCalcTempB_H	EQU	122
SysCalcTempX	EQU	112
SysCalcTempX_H	EQU	113
SysDivLoop	EQU	116
SysWaitTemp10US	EQU	117
ADREADPORT	EQU	32
ADTEMP	EQU	33
READAD10	EQU	34
READAD10_H	EQU	35
SysTemp1	EQU	37
SysTemp1_H	EQU	38
TONEDURATION	EQU	39
TONEDURATION_H	EQU	40
TONEFREQUENCY	EQU	41
TONEFREQUENCY_H	EQU	42
TONELOOP	EQU	43
TONELOOP_H	EQU	44
TONELOOP2	EQU	45
TONELOOP2_H	EQU	46
TONEPERIOD	EQU	47
VALUE	EQU	48
VALUE_H	EQU	49

;********************************************************************************

;Alias variables
ALLANSEL	EQU	ANSEL

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS
	call	INITSOUND

;Start of the main program
;Make a light theremin. Wave your hand over the LDR to
;change the pitch of the sound generator.
;Connect AN0/GP0 to the LDR and GP1 to the piezo.
;Alternatively, you could connect GP1 to the line
;output and drive an external speaker or amplifier and then
;use the volume control to tame things as required.
;----- Settings
;----- Constants
;#define ldr	GPIO.0						;LDR on pin 7 (AN0)
;#define SoundOut GPIO.1				;piezo on pin 6
;----- Variables
;dim value as word					
;----- Program
;dir ldr in										;LDR is input
	banksel	TRISIO
	bsf	TRISIO,0
;dir SoundOut out							;piezo is output
	bcf	TRISIO,1
;do
SysDoLoop_S1
;value = readAD10(AN0)				;get 10-bit light reading
	banksel	ADREADPORT
	clrf	ADREADPORT
	call	FN_READAD10
	movf	READAD10,W
	movwf	VALUE
	movf	READAD10_H,W
	movwf	VALUE_H
;tone value, 1								;play that tone for 10 mS
	movf	VALUE,W
	movwf	TONEFREQUENCY
	movf	VALUE_H,W
	movwf	TONEFREQUENCY_H
	movlw	1
	movwf	TONEDURATION
	clrf	TONEDURATION_H
	call	TONE
;loop													;repeat in perpetuity
	goto	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_10US
D10US_START
	movlw	5
	movwf	DELAYTEMP
DelayUS0
	decfsz	DELAYTEMP,F
	goto	DelayUS0
	nop
	decfsz	SysWaitTemp10US, F
	goto	D10US_START
	return

;********************************************************************************

INITSOUND
;dir SoundOut out
	banksel	TRISIO
	bcf	TRISIO,1
	banksel	STATUS
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

FN_READAD10
;SET ADFM ON
	bsf	ADCON0,ADFM
;Do conversion
;LLReadAD
;Dim AllANSEL As Byte Alias ANSEL
;AllANSEL = 0
	banksel	ALLANSEL
	clrf	ALLANSEL
;ADTemp = ADReadPort + 1
	banksel	ADREADPORT
	incf	ADREADPORT,W
	movwf	ADTEMP
;Set C On
	bsf	STATUS,C
;Do
SysDoLoop_S2
;Rotate AllANSEL Left
	banksel	ALLANSEL
	rlf	ALLANSEL,F
;decfsz ADTemp,F
	banksel	ADTEMP
	decfsz	ADTEMP,F
;Loop
	goto	SysDoLoop_S2
SysDoLoop_E2
;SET ADCS1 OFF
	banksel	ANSEL
	bcf	ANSEL,ADCS1
;SET ADCS0 ON
	bsf	ANSEL,ADCS0
;SET ADCON0.CHS0 OFF
	banksel	ADCON0
	bcf	ADCON0,CHS0
;SET ADCON0.CHS1 OFF
	bcf	ADCON0,CHS1
;IF ADReadPort.0 On Then Set ADCON0.CHS0 On
	btfsc	ADREADPORT,0
	bsf	ADCON0,CHS0
;IF ADReadPort.1 On Then Set ADCON0.CHS1 On
	btfsc	ADREADPORT,1
	bsf	ADCON0,CHS1
;SET ADCON0.ADON ON
	bsf	ADCON0,ADON
;Wait AD_Delay
	movlw	2
	movwf	SysWaitTemp10US
	call	Delay_10US
;SET ADCON0.GO_DONE ON
	bsf	ADCON0,GO_DONE
;Wait While ADCON0.GO_DONE ON
SysWaitLoop1
	btfsc	ADCON0,GO_DONE
	goto	SysWaitLoop1
;SET ADCON0.ADON OFF
	bcf	ADCON0,ADON
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;ReadAD10 = ADRESL
	movf	ADRESL,W
	banksel	READAD10
	movwf	READAD10
	clrf	READAD10_H
;ReadAD10_H = ADRESH
	movf	ADRESH,W
	movwf	READAD10_H
;SET ADFM OFF
	bcf	ADCON0,ADFM
	return

;********************************************************************************

SYSCOMPEQUAL16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA, W
	movf	SYSCALCTEMPA, W
;subwf SysCalcTempB, W
	subwf	SYSCALCTEMPB, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;movf SysCalcTempA_H, W
	movf	SYSCALCTEMPA_H, W
;subwf SysCalcTempB_H, W
	subwf	SYSCALCTEMPB_H, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSCOMPLESSTHAN16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA_H,W
	movf	SYSCALCTEMPA_H,W
;subwf SysCalcTempB_H,W
	subwf	SYSCALCTEMPB_H,W
;btfss STATUS,C
	btfss	STATUS,C
;return
	return
;movf SysCalcTempB_H,W
	movf	SYSCALCTEMPB_H,W
;subwf SysCalcTempA_H,W
	subwf	SYSCALCTEMPA_H,W
;btfss STATUS,C
	btfss	STATUS,C
;goto SCLT16True
	goto	SCLT16TRUE
;movf SysCalcTempB,W
	movf	SYSCALCTEMPB,W
;subwf SysCalcTempA,W
	subwf	SYSCALCTEMPA,W
;btfsc STATUS,C
	btfsc	STATUS,C
;return
	return
SCLT16TRUE
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSDIVSUB16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as word
;dim SysDivMultA as word
;dim SysDivMultB as word
;dim SysDivMultX as word
;SysDivMultA = SysCalcTempA
	movf	SYSCALCTEMPA,W
	movwf	SYSDIVMULTA
	movf	SYSCALCTEMPA_H,W
	movwf	SYSDIVMULTA_H
;SysDivMultB = SysCalcTempB
	movf	SYSCALCTEMPB,W
	movwf	SYSDIVMULTB
	movf	SYSCALCTEMPB_H,W
	movwf	SYSDIVMULTB_H
;SysDivMultX = 0
	clrf	SYSDIVMULTX
	clrf	SYSDIVMULTX_H
;if SysDivMultB = 0 then
	movf	SYSDIVMULTB,W
	movwf	SysCalcTempA
	movf	SYSDIVMULTB_H,W
	movwf	SysCalcTempA_H
	clrf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysCompEqual16
	btfss	SysCalcTempX,0
	goto	ENDIF8
;SysCalcTempA = 0
	clrf	SYSCALCTEMPA
	clrf	SYSCALCTEMPA_H
;exit sub
	return
;end if
ENDIF8
;SysDivLoop = 16
	movlw	16
	movwf	SYSDIVLOOP
SYSDIV16START
;set C off
	bcf	STATUS,C
;Rotate SysDivMultA Left
	rlf	SYSDIVMULTA,F
	rlf	SYSDIVMULTA_H,F
;Rotate SysDivMultX Left
	rlf	SYSDIVMULTX,F
	rlf	SYSDIVMULTX_H,F
;SysDivMultX = SysDivMultX - SysDivMultB
	movf	SYSDIVMULTB,W
	subwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfss	STATUS,C
	addlw	1
	subwf	SYSDIVMULTX_H,F
;Set SysDivMultA.0 On
	bsf	SYSDIVMULTA,0
;If C Off Then
	btfsc	STATUS,C
	goto	ENDIF9
;Set SysDivMultA.0 Off
	bcf	SYSDIVMULTA,0
;SysDivMultX = SysDivMultX + SysDivMultB
	movf	SYSDIVMULTB,W
	addwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfsc	STATUS,C
	addlw	1
	addwf	SYSDIVMULTX_H,F
;End If
ENDIF9
;decfsz SysDivLoop, F
	decfsz	SYSDIVLOOP, F
;goto SysDiv16Start
	goto	SYSDIV16START
;SysCalcTempA = SysDivMultA
	movf	SYSDIVMULTA,W
	movwf	SYSCALCTEMPA
	movf	SYSDIVMULTA_H,W
	movwf	SYSCALCTEMPA_H
;SysCalcTempX = SysDivMultX
	movf	SYSDIVMULTX,W
	movwf	SYSCALCTEMPX
	movf	SYSDIVMULTX_H,W
	movwf	SYSCALCTEMPX_H
	return

;********************************************************************************

TONE
;dim ToneLoop as word
;dim ToneLoop2 as word
;If ToneFrequency = 0 Then Exit Sub
	movf	TONEFREQUENCY,W
	movwf	SysCalcTempA
	movf	TONEFREQUENCY_H,W
	movwf	SysCalcTempA_H
	clrf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysCompEqual16
	btfsc	SysCalcTempX,0
	return
;TonePeriod = 50000 / ToneFrequency
	movlw	80
	movwf	SysCalcTempA
	movlw	195
	movwf	SysCalcTempA_H
	movf	TONEFREQUENCY,W
	movwf	SysCalcTempB
	movf	TONEFREQUENCY_H,W
	movwf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	TONEPERIOD
;ToneFrequency = ToneFrequency / 100
	movf	TONEFREQUENCY,W
	movwf	SysCalcTempA
	movf	TONEFREQUENCY_H,W
	movwf	SysCalcTempA_H
	movlw	100
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	TONEFREQUENCY
	movf	SysCalcTempA_H,W
	movwf	TONEFREQUENCY_H
;For ToneLoop = 1 to ToneDuration
	clrf	TONELOOP
	clrf	TONELOOP_H
	movlw	1
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	movf	TONEDURATION,W
	movwf	SysCalcTempA
	movf	TONEDURATION_H,W
	movwf	SysCalcTempA_H
	call	SysCompLessThan16
	btfsc	SysCalcTempX,0
	goto	SysForLoopEnd1
SysForLoop1
	movlw	1
	addwf	TONELOOP,F
	movf	TONELOOP_H,W
	btfsc	STATUS,C
	addlw	1
	movwf	TONELOOP_H
;For ToneLoop2 = 1 to ToneFrequency
	clrf	TONELOOP2
	clrf	TONELOOP2_H
	movlw	1
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	movf	TONEFREQUENCY,W
	movwf	SysCalcTempA
	movf	TONEFREQUENCY_H,W
	movwf	SysCalcTempA_H
	call	SysCompLessThan16
	btfsc	SysCalcTempX,0
	goto	SysForLoopEnd2
SysForLoop2
	movlw	1
	addwf	TONELOOP2,F
	movf	TONELOOP2_H,W
	btfsc	STATUS,C
	addlw	1
	movwf	TONELOOP2_H
;Set SoundOut ON
	bsf	GPIO,1
;SysToneDelay
	movf	TONEPERIOD,W
	movwf	SysWaitTemp10US
	call	Delay_10US
;Set SoundOut OFF
	bcf	GPIO,1
;SysToneDelay
	movf	TONEPERIOD,W
	movwf	SysWaitTemp10US
	call	Delay_10US
;Next
	movf	TONELOOP2,W
	movwf	SysCalcTempA
	movf	TONELOOP2_H,W
	movwf	SysCalcTempA_H
	movf	TONEFREQUENCY,W
	movwf	SysCalcTempB
	movf	TONEFREQUENCY_H,W
	movwf	SysCalcTempB_H
	call	SysCompLessThan16
	btfsc	SysCalcTempX,0
	goto	SysForLoop2
SysForLoopEnd2
;Next
	movf	TONELOOP,W
	movwf	SysCalcTempA
	movf	TONELOOP_H,W
	movwf	SysCalcTempA_H
	movf	TONEDURATION,W
	movwf	SysCalcTempB
	movf	TONEDURATION_H,W
	movwf	SysCalcTempB_H
	call	SysCompLessThan16
	btfsc	SysCalcTempX,0
	goto	SysForLoop1
SysForLoopEnd1
	return

;********************************************************************************


 END
