;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
DELAYTEMP2	EQU	113
SysWaitTempMS	EQU	114
SysWaitTempMS_H	EQU	115
SysWaitTempUS	EQU	117
SysWaitTempUS_H	EQU	118
BUTTON	EQU	169
PULSE	EQU	99
CMD	EQU	32
COUNT	EQU	33
DEVICE	EQU	34
I	EQU	35

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;Beep the buzzer a certain number of times under remote
;control.Connect GP0 to IR sensor and GP1 to the buzzer.
;Use a remote control compatible with Sony televisions.
;----- Settings
;----- Constants
;#define IR			GPIO.0	;sensor on pin 7
;#define buzzer	GPIO.1	;buzzer on pin 6
;----- Variables
;dim pulse(12)						;12-byte array holds pulse counts
;dim button as string		;ASCII string for button label
;----- Program
;dir IR in								;IR is input
	banksel	TRISIO
	bsf	TRISIO,0
;dir buzzer out 					;buzzer is output
	bcf	TRISIO,1
;do
SysDoLoop_S1
;getIR, cmd						;wait for IR signal
	banksel	STATUS
	call	GETIR
;beepIt   							;beep the number button pressed
	call	BEEPIT
;wait 10 mS						;ignore any repeats
	movlw	10
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;loop               			;and start all over again
	goto	SysDoLoop_S1
SysDoLoop_E1
;----- Subroutines
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

BEEPIT
;for i = 1 to cmd
	clrf	I
	movlw	1
	subwf	CMD,W
	btfss	STATUS, C
	goto	SysForLoopEnd4
SysForLoop4
	incf	I,F
;set buzzer on
	bsf	GPIO,1
;wait 250 mS
	movlw	250
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;set buzzer off
	bcf	GPIO,1
;wait 250 mS
	movlw	250
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;next i	
	movf	CMD,W
	subwf	I,W
	btfss	STATUS, C
	goto	SysForLoop4
SysForLoopEnd4
	return

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	4
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	165
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

GETIR
TARRY1
;count = 0						;wait for the start bit
	clrf	COUNT
;do while IR = 0			;measure pulse width (active low)
SysDoLoop_S2
	btfsc	GPIO,0
	goto	SysDoLoop_E2
;wait 100 uS				;24 units of 100 uS = 2.4 mS
	movlw	66
	movwf	DELAYTEMP
DelayUS1
	decfsz	DELAYTEMP,F
	goto	DelayUS1
	nop
;count += 1			
	incf	COUNT,F
;loop
	goto	SysDoLoop_S2
SysDoLoop_E2
;if count < 20 then goto tarry1	;less than this so wait
	movlw	20
	subwf	COUNT,W
	btfss	STATUS, C
	goto	TARRY1
;for i=1 to 12                 	;read/store the 12 pulses
	clrf	I
SysForLoop1
	incf	I,F
TARRY2
;count = 0
	clrf	COUNT
;do while IR = 0							;zero = 6 units = 0.6 mS
SysDoLoop_S3
	btfsc	GPIO,0
	goto	SysDoLoop_E3
;wait 100 uS								;one = 12 units = 1.2 mS
	movlw	66
	movwf	DELAYTEMP
DelayUS2
	decfsz	DELAYTEMP,F
	goto	DelayUS2
	nop
;count += 1
	incf	COUNT,F
;loop
	goto	SysDoLoop_S3
SysDoLoop_E3
;if count < 4 then goto tarry2	;too small to be legit
	movlw	4
	subwf	COUNT,W
	btfss	STATUS, C
	goto	TARRY2
;pulse(i) = count							;else store pulse width
	movlw	low(PULSE)
	addwf	I,W
	movwf	FSR
	movf	COUNT,W
	movwf	INDF
;next
	movlw	12
	subwf	I,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
;cmd = 0							  					;command built up here
	clrf	CMD
;for i = 1 to 7 									;1st seven bits are the cmd
	clrf	I
SysForLoop2
	incf	I,F
;cmd = cmd / 2									;shift into place
	bcf	STATUS,C
	rrf	CMD,F
;if pulse(i) > 10 then 	  		;longer than 10 mS
	movlw	low(PULSE)
	addwf	I,W
	movwf	FSR
	movf	INDF,W
	sublw	10
	btfsc	STATUS, C
	goto	ENDIF4
;cmd = cmd + 64   					;so call it a one
	movlw	64
	addwf	CMD,F
;end if
ENDIF4
;next
	movlw	7
	subwf	I,W
	btfss	STATUS, C
	goto	SysForLoop2
SysForLoopEnd2
;device = 0											;device number built up here
	clrf	DEVICE
;for i=8 to 12										;next 5 bits are device number
	movlw	7
	movwf	I
SysForLoop3
	incf	I,F
;device = device / 2						
	bcf	STATUS,C
	rrf	DEVICE,F
;if pulse(i) > 10 then
	movlw	low(PULSE)
	addwf	I,W
	movwf	FSR
	movf	INDF,W
	sublw	10
	btfsc	STATUS, C
	goto	ENDIF6
;device = device + 16
	movlw	16
	addwf	DEVICE,F
;end if
ENDIF6
;next	
	movlw	12
	subwf	I,W
	btfss	STATUS, C
	goto	SysForLoop3
SysForLoopEnd3
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************


 END
