;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
DELAYTEMP2	EQU	113
SYSSTRINGLENGTH	EQU	118
SysCalcTempA	EQU	117
SysCalcTempB	EQU	121
SysCalcTempX	EQU	112
SysDivLoop	EQU	116
SysStringA	EQU	119
SysStringA_H	EQU	120
SysStringB	EQU	114
SysStringB_H	EQU	115
SysWaitTempMS	EQU	114
SysWaitTempMS_H	EQU	115
SysWaitTempUS	EQU	117
SysWaitTempUS_H	EQU	118
BUTTON	EQU	169
SYSSTRINGPARAM1	EQU	91
PULSE	EQU	78
CMD	EQU	32
COUNT	EQU	33
DEVICE	EQU	34
I	EQU	35
OUTVALUETEMP	EQU	36
PRINTLEN	EQU	37
SERBIT	EQU	38
SERDELAYLOOP	EQU	39
SERPRINTVAL	EQU	40
SERTEMP	EQU	41
SER_BYTE	EQU	42
SER_DATA	EQU	43
SER_DATA_A	EQU	44
SER_INVERT	EQU	45
SER_INVERT_A	EQU	46
SER_PARITY	EQU	47
SER_PARITY_A	EQU	48
SER_RATE	EQU	49
SER_RATE_A	EQU	50
SER_SELECT	EQU	51
SER_SELECT_OLD	EQU	52
SER_START	EQU	53
SER_START_A	EQU	54
SER_STOP	EQU	55
SER_STOP_A	EQU	56
SYSPRINTTEMP	EQU	57
StringPointer	EQU	58
SysPRINTDATAHandler	EQU	59
SysPRINTDATAHandler_H	EQU	60
SysTemp1	EQU	61
SysTemp2	EQU	62
TEMPPARITY	EQU	63

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;This project decodes the remote control unit and sends
;the results to a PC. Use a Sony compatible remote.
;Connect GP0 to the IR sensor, GP1 to Rx and GP2
;to Tx. Communication is via RS-232. If your PC fails to
;have a COM port, use a cheap USB-to-COM converter (available
;from Amazon and other places). Use any terminal program to
;see the results.
;----- Settings
;----- Constants
;#define IR					GPIO.0						;IR on pin 7
;#define SerInPort		GPIO.1            ;Rx input on pin 6
;#define SerOutPort	GPIO.2            ;Tx output on pin 5
;#define SendAHigh Set SerOutPort  on  ;output logic levels
;#define SendALow  Set SerOutPort  off
;#define RecAHigh  SerInPort       on  ;input logic levels
;#define RecALow   SerInPort       off
;#define cr 13                         ;carriage return
;#define lf 10                         ;line feed
;----- Variables
;dim cmd, device as byte
;dim pulse(12)						;12-byte array holds pulse counts
;dim button as string		;ASCII string for button label
;----- Program
;dir IR in								;set up port lines
	banksel	TRISIO
	bsf	TRISIO,0
;dir SerInPort in 				
	bsf	TRISIO,1
;dir SerOutPort out
	bcf	TRISIO,2
;InitSer 1, r4800, 1+WaitForStart, 8, 1, none, invert
	movlw	1
	banksel	SER_SELECT
	movwf	SER_SELECT
	movlw	4
	movwf	SER_RATE
	movlw	129
	movwf	SER_START
	movlw	8
	movwf	SER_DATA
	movlw	1
	movwf	SER_STOP
	clrf	SER_PARITY
	movlw	1
	movwf	SER_INVERT
	call	INITSER
;do
SysDoLoop_S1
;getIR									;wait for IR signal
	call	GETIR
;sendIt   							;decode and echo to the PC
	call	SENDIT
;wait 500 mS						;ignore a heavy hand
	movlw	244
	movwf	SysWaitTempMS
	movlw	1
	movwf	SysWaitTempMS_H
	call	Delay_MS
;loop               			;and start all over again
	goto	SysDoLoop_S1
SysDoLoop_E1
;----- Subroutines
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	4
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	165
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

GETIR
TARRY1
;count = 0						;wait for the start bit
	clrf	COUNT
;do while IR = 0			;measure pulse width (active low)
SysDoLoop_S2
	btfsc	GPIO,0
	goto	SysDoLoop_E2
;wait 100 uS				;24 units of 100 uS = 2.4 mS
	movlw	66
	movwf	DELAYTEMP
DelayUS1
	decfsz	DELAYTEMP,F
	goto	DelayUS1
	nop
;count += 1			
	incf	COUNT,F
;loop
	goto	SysDoLoop_S2
SysDoLoop_E2
;if count < 20 then goto tarry1	;less than this so wait
	movlw	20
	subwf	COUNT,W
	btfss	STATUS, C
	goto	TARRY1
;for i=1 to 12                 	;read/store the 12 pulses
	clrf	I
SysForLoop1
	incf	I,F
TARRY2
;count = 0
	clrf	COUNT
;do while IR = 0							;zero = 6 units = 0.6 mS
SysDoLoop_S3
	btfsc	GPIO,0
	goto	SysDoLoop_E3
;wait 100 uS								;one = 12 units = 1.2 mS
	movlw	66
	movwf	DELAYTEMP
DelayUS2
	decfsz	DELAYTEMP,F
	goto	DelayUS2
	nop
;count += 1
	incf	COUNT,F
;loop
	goto	SysDoLoop_S3
SysDoLoop_E3
;if count < 4 then goto tarry2	;too small to be legit
	movlw	4
	subwf	COUNT,W
	btfss	STATUS, C
	goto	TARRY2
;pulse(i) = count							;else store pulse width
	movlw	low(PULSE)
	addwf	I,W
	movwf	FSR
	movf	COUNT,W
	movwf	INDF
;next
	movlw	12
	subwf	I,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
;cmd = 0							  					;command built up here
	clrf	CMD
;for i = 1 to 7 									;1st seven bits are the cmd
	clrf	I
SysForLoop2
	incf	I,F
;cmd = cmd / 2									;shift into place
	bcf	STATUS,C
	rrf	CMD,F
;if pulse(i) > 10 then 	  		;longer than 10 mS
	movlw	low(PULSE)
	addwf	I,W
	movwf	FSR
	movf	INDF,W
	sublw	10
	btfsc	STATUS, C
	goto	ENDIF4
;cmd = cmd + 64   					;so call it a one
	movlw	64
	addwf	CMD,F
;end if
ENDIF4
;next
	movlw	7
	subwf	I,W
	btfss	STATUS, C
	goto	SysForLoop2
SysForLoopEnd2
;device = 0											;device number built up here
	clrf	DEVICE
;for i=8 to 12										;next 5 bits are device number
	movlw	7
	movwf	I
SysForLoop3
	incf	I,F
;device = device / 2						
	bcf	STATUS,C
	rrf	DEVICE,F
;if pulse(i) > 10 then
	movlw	low(PULSE)
	addwf	I,W
	movwf	FSR
	movf	INDF,W
	sublw	10
	btfsc	STATUS, C
	goto	ENDIF6
;device = device + 16
	movlw	16
	addwf	DEVICE,F
;end if
ENDIF6
;next	
	movlw	12
	subwf	I,W
	btfss	STATUS, C
	goto	SysForLoop3
SysForLoopEnd3
	return

;********************************************************************************

INITSER
;Ser_Select_Old = Ser_Select
	movf	SER_SELECT,W
	movwf	SER_SELECT_OLD
;if Ser_Select = 1 THEN
	decf	SER_SELECT,W
	btfss	STATUS, Z
	goto	ENDIF8
;Ser_Rate_A = Ser_Rate
	movf	SER_RATE,W
	movwf	SER_RATE_A
;Ser_Start_A = Ser_Start
	movf	SER_START,W
	movwf	SER_START_A
;Ser_Data_A = Ser_Data
	movf	SER_DATA,W
	movwf	SER_DATA_A
;Ser_Stop_A = Ser_Stop
	movf	SER_STOP,W
	movwf	SER_STOP_A
;Ser_Parity_A = Ser_Parity
	movf	SER_PARITY,W
	movwf	SER_PARITY_A
;Ser_Invert_A = Ser_Invert
	movf	SER_INVERT,W
	movwf	SER_INVERT_A
;END IF
ENDIF8
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

SENDIT
;select case cmd						;These are all the buttons on the
SysSelect1Case1
	movf	CMD,F
	btfss	STATUS, Z
	goto	SysSelect1Case2
;button = "One"				;All Electronics. The codes are Sony.
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable1
	movwf	SysStringA
	movlw	high StringTable1
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case2
	decf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case3
;button = "Two"	
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable2
	movwf	SysStringA
	movlw	high StringTable2
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case3
	movlw	2
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case4
;button = "Three"
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable3
	movwf	SysStringA
	movlw	high StringTable3
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case4
	movlw	3
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case5
;button = "Four"
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable4
	movwf	SysStringA
	movlw	high StringTable4
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case5
	movlw	4
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case6
;button = "Five"
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable5
	movwf	SysStringA
	movlw	high StringTable5
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case6
	movlw	5
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case7
;button = "Six"	
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable6
	movwf	SysStringA
	movlw	high StringTable6
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case7
	movlw	6
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case8
;button = "Seven"
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable7
	movwf	SysStringA
	movlw	high StringTable7
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case8
	movlw	7
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case9
;button = "Eight"	
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable8
	movwf	SysStringA
	movlw	high StringTable8
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case9
	movlw	8
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case10
;button = "Nine"
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable9
	movwf	SysStringA
	movlw	high StringTable9
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case10
	movlw	9
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case11
;button = "Zero"	
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable10
	movwf	SysStringA
	movlw	high StringTable10
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case11
	movlw	11
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case12
;button = "Enter"
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable11
	movwf	SysStringA
	movlw	high StringTable11
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case12
	movlw	14
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case13
;button = "V-Chip"
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable12
	movwf	SysStringA
	movlw	high StringTable12
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case13
	movlw	16
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case14
;button = "Channel Up"
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable13
	movwf	SysStringA
	movlw	high StringTable13
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case14
	movlw	17
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case15
;button = "Channel Down"
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable14
	movwf	SysStringA
	movlw	high StringTable14
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case15
	movlw	18
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case16
;button = "Volume Up"	
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable15
	movwf	SysStringA
	movlw	high StringTable15
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case16
	movlw	19
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case17
;button = "Volume Down"
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable16
	movwf	SysStringA
	movlw	high StringTable16
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case17
	movlw	20
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case18
;button = "Mute"	
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable17
	movwf	SysStringA
	movlw	high StringTable17
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case18
	movlw	21
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case19
;button = "Power"
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable18
	movwf	SysStringA
	movlw	high StringTable18
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case19
	movlw	23
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case20
;button = "MTS"
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable19
	movwf	SysStringA
	movlw	high StringTable19
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case20
	movlw	28
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case21
;button = "Scaling"
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable20
	movwf	SysStringA
	movlw	high StringTable20
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case21
	movlw	37
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case22
;button = "Source"
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable21
	movwf	SysStringA
	movlw	high StringTable21
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case22
	movlw	54
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case23
;button = "Sleep"	
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable22
	movwf	SysStringA
	movlw	high StringTable22
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case23
	movlw	58
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case24
;button = "Display"
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable23
	movwf	SysStringA
	movlw	high StringTable23
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case24
	movlw	59
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case25
;button = "Return"
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable24
	movwf	SysStringA
	movlw	high StringTable24
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case25
	movlw	63
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case26
;button = "CC"
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable25
	movwf	SysStringA
	movlw	high StringTable25
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case26
	movlw	90
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case27
;button = "PIP Menu"
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable26
	movwf	SysStringA
	movlw	high StringTable26
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case27
	movlw	91
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case28
;button = "PIP"
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable27
	movwf	SysStringA
	movlw	high StringTable27
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case28
	movlw	92
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case29
;button = "100"
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable28
	movwf	SysStringA
	movlw	high StringTable28
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case29
	movlw	96
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case30
;button = "Menu"			
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable29
	movwf	SysStringA
	movlw	high StringTable29
	movwf	SysStringA_H
	call	SysReadString
	goto	SysSelectEnd1
SysSelect1Case30
	movlw	99
	subwf	CMD,W
	btfss	STATUS, Z
	goto	SysSelect1Case31
;button = "Exit"
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable30
	movwf	SysStringA
	movlw	high StringTable30
	movwf	SysStringA_H
	call	SysReadString
;case else
	goto	SysSelectEnd1
SysSelect1Case31
;button = "N/A"
	movlw	low BUTTON
	movwf	SysStringB
	movlw	high BUTTON
	movwf	SysStringB_H
	movlw	low StringTable31
	movwf	SysStringA
	movlw	high StringTable31
	movwf	SysStringA_H
	call	SysReadString
;end select	
SysSelect1Case32
SysSelectEnd1
;SerPrint 1, "Code: "			;print the code
	movlw	1
	movwf	SER_SELECT
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable32
	movwf	SysStringA
	movlw	high StringTable32
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysPRINTDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysPRINTDATAHandler_H
	call	SERPRINT15
;SerPrint 1, cmd
	movlw	1
	movwf	SER_SELECT
	movf	CMD,W
	movwf	SERPRINTVAL
	call	SERPRINT16
;SerPrint 1, " --- "
	movlw	1
	movwf	SER_SELECT
	movlw	low SYSSTRINGPARAM1
	movwf	SysStringB
	movlw	high SYSSTRINGPARAM1
	movwf	SysStringB_H
	movlw	low StringTable33
	movwf	SysStringA
	movlw	high StringTable33
	movwf	SysStringA_H
	call	SysReadString
	movlw	low SYSSTRINGPARAM1
	movwf	SysPRINTDATAHandler
	movlw	high SYSSTRINGPARAM1
	movwf	SysPRINTDATAHandler_H
	call	SERPRINT15
;SerPrint 1, button				;and button translation
	movlw	1
	movwf	SER_SELECT
	movlw	low BUTTON
	movwf	SysPRINTDATAHandler
	movlw	high BUTTON
	movwf	SysPRINTDATAHandler_H
	call	SERPRINT15
;SerSend 1, cr
	movlw	1
	movwf	SER_SELECT
	movlw	13
	movwf	SER_BYTE
	call	SERSEND
;SerSend 1, lf		
	movlw	1
	movwf	SER_SELECT
	movlw	10
	movwf	SER_BYTE
	goto	SERSEND

;********************************************************************************

SERBITDELAY
;if Ser_Rate = 1 then Wait SerFullDelay19200 us: exit sub	'19200 (52 us)
	decf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF41
	movlw	19
	movwf	DELAYTEMP
DelayUS3
	decfsz	DELAYTEMP,F
	goto	DelayUS3
	return
ENDIF41
;if Ser_Rate = 2 then Wait SerFullDelay9600 us: exit sub 	'9600 (104 us)
	movlw	2
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF42
	movlw	52
	movwf	DELAYTEMP
DelayUS4
	decfsz	DELAYTEMP,F
	goto	DelayUS4
	nop
	return
ENDIF42
;if Ser_Rate = 4 then Wait SerFullDelay4800 us: exit sub 	'4800 (208 us)
	movlw	4
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF43
	movlw	122
	movwf	DELAYTEMP
DelayUS5
	decfsz	DELAYTEMP,F
	goto	DelayUS5
	return
ENDIF43
;if Ser_Rate = 8 then Wait SerFullDelay2400 us: exit sub 	'2400 (417 us)
	movlw	8
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF44
	movlw	1
	movwf	DELAYTEMP2
DelayUSO6
	clrf	DELAYTEMP
DelayUS6
	decfsz	DELAYTEMP,F
	goto	DelayUS6
	decfsz	DELAYTEMP2,F
	goto	DelayUSO6
	movlw	4
	movwf	DELAYTEMP
DelayUS7
	decfsz	DELAYTEMP,F
	goto	DelayUS7
	return
ENDIF44
;if Ser_Rate = 16 then Wait SerFullDelay1200 us: exit sub 	'1200 (833 us)
	movlw	16
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF45
	movlw	2
	movwf	DELAYTEMP2
DelayUSO8
	clrf	DELAYTEMP
DelayUS8
	decfsz	DELAYTEMP,F
	goto	DelayUS8
	decfsz	DELAYTEMP2,F
	goto	DelayUSO8
	movlw	24
	movwf	DELAYTEMP
DelayUS9
	decfsz	DELAYTEMP,F
	goto	DelayUS9
	return
ENDIF45
;if Ser_Rate = 32 then Wait SerFullDelay600 us: exit sub 	'600 (1666 us)
	movlw	32
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF46
	movlw	4
	movwf	DELAYTEMP2
DelayUSO10
	clrf	DELAYTEMP
DelayUS10
	decfsz	DELAYTEMP,F
	goto	DelayUS10
	decfsz	DELAYTEMP2,F
	goto	DelayUSO10
	movlw	65
	movwf	DELAYTEMP
DelayUS11
	decfsz	DELAYTEMP,F
	goto	DelayUS11
	nop
	return
ENDIF46
;if Ser_Rate = 64 then Wait SerFullDelay300 us: exit sub '300 (3333 us)
	movlw	64
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF47
	movlw	8
	movwf	DELAYTEMP2
DelayUSO12
	clrf	DELAYTEMP
DelayUS12
	decfsz	DELAYTEMP,F
	goto	DelayUS12
	decfsz	DELAYTEMP2,F
	goto	DelayUSO12
	movlw	149
	movwf	DELAYTEMP
DelayUS13
	decfsz	DELAYTEMP,F
	goto	DelayUS13
	return
ENDIF47
;for SerDelayLoop = 1 to Ser_Rate
	clrf	SERDELAYLOOP
	movlw	1
	subwf	SER_RATE,W
	btfss	STATUS, C
	goto	SysForLoopEnd8
SysForLoop8
	incf	SERDELAYLOOP,F
;Wait 42 us
	movlw	28
	movwf	DELAYTEMP
DelayUS14
	decfsz	DELAYTEMP,F
	goto	DelayUS14
;next
	movf	SER_RATE,W
	subwf	SERDELAYLOOP,W
	btfss	STATUS, C
	goto	SysForLoop8
SysForLoopEnd8
	return

;********************************************************************************

SERCFGLOAD
;Ser_Select_Old = Ser_Select
	movf	SER_SELECT,W
	movwf	SER_SELECT_OLD
;if Ser_Select = 1 THEN
	decf	SER_SELECT,W
	btfss	STATUS, Z
	goto	ENDIF40
;Ser_Rate = Ser_Rate_A
	movf	SER_RATE_A,W
	movwf	SER_RATE
;Ser_Start = Ser_Start_A
	movf	SER_START_A,W
	movwf	SER_START
;Ser_Data = Ser_Data_A
	movf	SER_DATA_A,W
	movwf	SER_DATA
;Ser_Stop = Ser_Stop_A
	movf	SER_STOP_A,W
	movwf	SER_STOP
;Ser_Parity = Ser_Parity_A
	movf	SER_PARITY_A,W
	movwf	SER_PARITY
;Ser_Invert = Ser_Invert_A
	movf	SER_INVERT_A,W
	movwf	SER_INVERT
;end if
ENDIF40
	return

;********************************************************************************

;Overloaded signature: BYTE:STRING:
SERPRINT15
;PrintLen = PrintData(0)
	movf	SysPRINTDATAHandler,W
	movwf	FSR
	bcf	STATUS, IRP
	btfsc	SysPRINTDATAHandler_H,0
	bsf	STATUS, IRP
	movf	INDF,W
	movwf	PRINTLEN
;if PrintLen = 0 then Goto SerPrintStrEnd
	movf	PRINTLEN,F
	btfsc	STATUS, Z
	goto	SERPRINTSTREND
;for SysPrintTemp = 1 to PrintLen
	clrf	SYSPRINTTEMP
	movlw	1
	subwf	PRINTLEN,W
	btfss	STATUS, C
	goto	SysForLoopEnd7
SysForLoop7
	incf	SYSPRINTTEMP,F
;SerSend(Ser_Select, PrintData(SysPrintTemp))
	movf	SYSPRINTTEMP,W
	addwf	SysPRINTDATAHandler,W
	movwf	FSR
	bcf	STATUS, IRP
	btfsc	SysPRINTDATAHandler_H,0
	bsf	STATUS, IRP
	movf	INDF,W
	movwf	SER_BYTE
	call	SERSEND
;next
	movf	PRINTLEN,W
	subwf	SYSPRINTTEMP,W
	btfss	STATUS, C
	goto	SysForLoop7
SysForLoopEnd7
SERPRINTSTREND
	return

;********************************************************************************

;Overloaded signature: BYTE:BYTE:
SERPRINT16
;OutValueTemp = 0
	clrf	OUTVALUETEMP
;IF SerPrintVal >= 100 Then
	movlw	100
	subwf	SERPRINTVAL,W
	btfss	STATUS, C
	goto	ENDIF38
;OutValueTemp = SerPrintVal / 100
	movf	SERPRINTVAL,W
	movwf	SysCalcTempA
	movlw	100
	movwf	SysCalcTempB
	call	SysDivSub
	movf	SysCalcTempA,W
	movwf	OUTVALUETEMP
;SerPrintVal = SysCalcTempX
	movf	SYSCALCTEMPX,W
	movwf	SERPRINTVAL
;SerSend(Ser_Select, OutValueTemp + 48)
	movlw	48
	addwf	OUTVALUETEMP,W
	movwf	SER_BYTE
	call	SERSEND
;End If
ENDIF38
;If OutValueTemp > 0 Or SerPrintVal >= 10 Then
	movf	OUTVALUETEMP,W
	movwf	SysCalcTempB
	clrf	SysCalcTempA
	call	SysCompLessThan
	movf	SysCalcTempX,W
	movwf	SysTemp1
	movf	SERPRINTVAL,W
	movwf	SysCalcTempA
	movlw	10
	movwf	SysCalcTempB
	call	SysCompLessThan
	comf	SysCalcTempX,F
	movf	SysTemp1,W
	iorwf	SysCalcTempX,W
	movwf	SysTemp2
	btfss	SysTemp2,0
	goto	ENDIF39
;OutValueTemp = SerPrintVal / 10
	movf	SERPRINTVAL,W
	movwf	SysCalcTempA
	movlw	10
	movwf	SysCalcTempB
	call	SysDivSub
	movf	SysCalcTempA,W
	movwf	OUTVALUETEMP
;SerPrintVal = SysCalcTempX
	movf	SYSCALCTEMPX,W
	movwf	SERPRINTVAL
;SerSend(Ser_Select, OutValueTemp + 48)
	movlw	48
	addwf	OUTVALUETEMP,W
	movwf	SER_BYTE
	call	SERSEND
;End If
ENDIF39
;SerSend(Ser_Select, SerPrintVal + 48)
	movlw	48
	addwf	SERPRINTVAL,W
	movwf	SER_BYTE
	goto	SERSEND

;********************************************************************************

SERSEND
;if Ser_Select <> Ser_Select_Old then SerCfgLoad(Ser_Select)
	movf	SER_SELECT_OLD,W
	subwf	SER_SELECT,W
	btfss	STATUS, Z
	call	SERCFGLOAD
;SerTemp = Ser_Start and (not WaitForStart)
	movlw	127
	andwf	SER_START,W
	movwf	SERTEMP
;for SerBit = 1 to SerTemp
	clrf	SERBIT
	movlw	1
	subwf	SERTEMP,W
	btfss	STATUS, C
	goto	SysForLoopEnd4
SysForLoop4
	incf	SERBIT,F
;SerTxHigh
;if Ser_Select = 1 THEN SendAHigh
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bsf	GPIO,2
;SerBitDelay
	call	SERBITDELAY
;next
	movf	SERTEMP,W
	subwf	SERBIT,W
	btfss	STATUS, C
	goto	SysForLoop4
SysForLoopEnd4
;TempParity = SerTemp
	movf	SERTEMP,W
	movwf	TEMPPARITY
;for SerBit = 1 to Ser_Data
	clrf	SERBIT
	movlw	1
	subwf	SER_DATA,W
	btfss	STATUS, C
	goto	SysForLoopEnd5
SysForLoop5
	incf	SERBIT,F
;if Ser_Invert = normal then
	movf	SER_INVERT,F
	btfss	STATUS, Z
	goto	ENDIF14
;if Ser_Byte.0 ON then SerTxHigh: TempParity = TempParity + 1
	btfss	SER_BYTE,0
	goto	ENDIF21
;if Ser_Select = 1 THEN SendAHigh
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bsf	GPIO,2
;SerBitDelay
	call	SERBITDELAY
	incf	TEMPPARITY,F
ENDIF21
;if Ser_Byte.0 OFF then SerTxLow
	btfsc	SER_BYTE,0
	goto	ENDIF22
;if Ser_Select = 1 THEN SendALow
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bcf	GPIO,2
;SerBitDelay
	call	SERBITDELAY
ENDIF22
;end if
ENDIF14
;if Ser_Invert = invert then
	decf	SER_INVERT,W
	btfss	STATUS, Z
	goto	ENDIF15
;if Ser_Byte.0 ON then SerTxLow: TempParity = TempParity + 1
	btfss	SER_BYTE,0
	goto	ENDIF23
;if Ser_Select = 1 THEN SendALow
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bcf	GPIO,2
;SerBitDelay
	call	SERBITDELAY
	incf	TEMPPARITY,F
ENDIF23
;if Ser_Byte.0 OFF then SerTxHigh
	btfsc	SER_BYTE,0
	goto	ENDIF24
;if Ser_Select = 1 THEN SendAHigh
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bsf	GPIO,2
;SerBitDelay
	call	SERBITDELAY
ENDIF24
;end if
ENDIF15
;rotate Ser_Byte right
	rrf	SER_BYTE,F
;next
	movf	SER_DATA,W
	subwf	SERBIT,W
	btfss	STATUS, C
	goto	SysForLoop5
SysForLoopEnd5
;if Ser_Parity <> 0 THEN
	movf	SER_PARITY,F
	btfsc	STATUS, Z
	goto	ENDIF17
;if Ser_Parity = odd then TempParity = TempParity + 1
	decf	SER_PARITY,W
	btfsc	STATUS, Z
	incf	TEMPPARITY,F
;if Ser_Invert = invert then TempParity = TempParity + 1
	decf	SER_INVERT,W
	btfsc	STATUS, Z
	incf	TEMPPARITY,F
;if TempParity.0 = ON then SerTxLow
	btfss	TEMPPARITY,0
	goto	ENDIF27
;if Ser_Select = 1 THEN SendALow
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bcf	GPIO,2
;SerBitDelay
	call	SERBITDELAY
ENDIF27
;if TempParity.0 = OFF then SerTxHigh
	btfsc	TEMPPARITY,0
	goto	ENDIF28
;if Ser_Select = 1 THEN SendAHigh
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bsf	GPIO,2
;SerBitDelay
	call	SERBITDELAY
ENDIF28
;end if
ENDIF17
;for SerBit = 1 to Ser_Stop
	clrf	SERBIT
	movlw	1
	subwf	SER_STOP,W
	btfss	STATUS, C
	goto	SysForLoopEnd6
SysForLoop6
	incf	SERBIT,F
;SerTxLow
;if Ser_Select = 1 THEN SendALow
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bcf	GPIO,2
;SerBitDelay
	call	SERBITDELAY
;next
	movf	SER_STOP,W
	subwf	SERBIT,W
	btfss	STATUS, C
	goto	SysForLoop6
SysForLoopEnd6
;SerBitDelay
	goto	SERBITDELAY

;********************************************************************************

SYSCOMPLESSTHAN
;Dim SysCalcTempA, SysCalcTempB, SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;bsf STATUS, C
	bsf	STATUS, C
;movf SysCalcTempB, W
	movf	SYSCALCTEMPB, W
;subwf SysCalcTempA, W
	subwf	SYSCALCTEMPA, W
;btfss STATUS, C
	btfss	STATUS, C
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSDIVSUB
;dim SysCalcTempA as byte
;dim SysCalcTempB as byte
;dim SysCalcTempX as byte
;SysCalcTempX = 0
	clrf	SYSCALCTEMPX
;SysDivLoop = 8
	movlw	8
	movwf	SYSDIVLOOP
SYSDIV8START
;bcf STATUS, C
	bcf	STATUS, C
;rlf SysCalcTempA, F
	rlf	SYSCALCTEMPA, F
;rlf SysCalcTempX, F
	rlf	SYSCALCTEMPX, F
;movf SysCalcTempB, W
	movf	SYSCALCTEMPB, W
;subwf SysCalcTempX, F
	subwf	SYSCALCTEMPX, F
;bsf SysCalcTempA, 0
	bsf	SYSCALCTEMPA, 0
;btfsc STATUS, C
	btfsc	STATUS, C
;goto Div8NotNeg
	goto	DIV8NOTNEG
;bcf SysCalcTempA, 0
	bcf	SYSCALCTEMPA, 0
;movf SysCalcTempB, W
	movf	SYSCALCTEMPB, W
;addwf SysCalcTempX, F
	addwf	SYSCALCTEMPX, F
DIV8NOTNEG
;decfsz SysDivLoop, F
	decfsz	SYSDIVLOOP, F
;goto SysDiv8Start
	goto	SYSDIV8START
	return

;********************************************************************************

SYSREADSTRING
;Dim SysCalcTempA As Byte
;Dim SysStringLength As Byte
;movf SysStringB, W
	movf	SYSSTRINGB, W
;movwf FSR
	movwf	FSR
;bcf STATUS, IRP
	bcf	STATUS, IRP
;btfsc SysStringB_H, 0
	btfsc	SYSSTRINGB_H, 0
;bsf STATUS, IRP
	bsf	STATUS, IRP
;call SysStringTables
	call	SYSSTRINGTABLES
;movwf SysCalcTempA
	movwf	SYSCALCTEMPA
;movwf INDF
	movwf	INDF
;addwf SysStringB, F
	addwf	SYSSTRINGB, F
;goto SysStringReadCheck
	goto	SYSSTRINGREADCHECK
SYSREADSTRINGPART
;movf SysStringB, W
	movf	SYSSTRINGB, W
;movwf FSR
	movwf	FSR
;decf FSR,F
;bcf STATUS, IRP
	bcf	STATUS, IRP
;btfsc SysStringB_H, 0
	btfsc	SYSSTRINGB_H, 0
;bsf STATUS, IRP
	bsf	STATUS, IRP
;call SysStringTables
	call	SYSSTRINGTABLES
;movwf SysCalcTempA
	movwf	SYSCALCTEMPA
;addwf SysStringLength,F
	addwf	SYSSTRINGLENGTH,F
;addwf SysStringB,F
	addwf	SYSSTRINGB,F
SYSSTRINGREADCHECK
;movf SysCalcTempA,F
	movf	SYSCALCTEMPA,F
;btfsc STATUS,Z
	btfsc	STATUS,Z
;return
	return
SYSSTRINGREAD
;call SysStringTables
	call	SYSSTRINGTABLES
;incf FSR, F
	incf	FSR, F
;movwf INDF
	movwf	INDF
;decfsz SysCalcTempA, F
	decfsz	SYSCALCTEMPA, F
;goto SysStringRead
	goto	SYSSTRINGREAD
	return

;********************************************************************************

SysStringTables
	movf	SysStringA_H,W
	movwf	PCLATH
	movf	SysStringA,W
	incf	SysStringA,F
	btfsc	STATUS,Z
	incf	SysStringA_H,F
	movwf	PCL

StringTable1
	retlw	3
	retlw	79	;O
	retlw	110	;n
	retlw	101	;e


StringTable2
	retlw	3
	retlw	84	;T
	retlw	119	;w
	retlw	111	;o


StringTable3
	retlw	5
	retlw	84	;T
	retlw	104	;h
	retlw	114	;r
	retlw	101	;e
	retlw	101	;e


StringTable4
	retlw	4
	retlw	70	;F
	retlw	111	;o
	retlw	117	;u
	retlw	114	;r


StringTable5
	retlw	4
	retlw	70	;F
	retlw	105	;i
	retlw	118	;v
	retlw	101	;e


StringTable6
	retlw	3
	retlw	83	;S
	retlw	105	;i
	retlw	120	;x


StringTable7
	retlw	5
	retlw	83	;S
	retlw	101	;e
	retlw	118	;v
	retlw	101	;e
	retlw	110	;n


StringTable8
	retlw	5
	retlw	69	;E
	retlw	105	;i
	retlw	103	;g
	retlw	104	;h
	retlw	116	;t


StringTable9
	retlw	4
	retlw	78	;N
	retlw	105	;i
	retlw	110	;n
	retlw	101	;e


StringTable10
	retlw	4
	retlw	90	;Z
	retlw	101	;e
	retlw	114	;r
	retlw	111	;o


StringTable11
	retlw	5
	retlw	69	;E
	retlw	110	;n
	retlw	116	;t
	retlw	101	;e
	retlw	114	;r


StringTable12
	retlw	6
	retlw	86	;V
	retlw	45	;-
	retlw	67	;C
	retlw	104	;h
	retlw	105	;i
	retlw	112	;p


StringTable13
	retlw	10
	retlw	67	;C
	retlw	104	;h
	retlw	97	;a
	retlw	110	;n
	retlw	110	;n
	retlw	101	;e
	retlw	108	;l
	retlw	32	; 
	retlw	85	;U
	retlw	112	;p


StringTable14
	retlw	12
	retlw	67	;C
	retlw	104	;h
	retlw	97	;a
	retlw	110	;n
	retlw	110	;n
	retlw	101	;e
	retlw	108	;l
	retlw	32	; 
	retlw	68	;D
	retlw	111	;o
	retlw	119	;w
	retlw	110	;n


StringTable15
	retlw	9
	retlw	86	;V
	retlw	111	;o
	retlw	108	;l
	retlw	117	;u
	retlw	109	;m
	retlw	101	;e
	retlw	32	; 
	retlw	85	;U
	retlw	112	;p


StringTable16
	retlw	11
	retlw	86	;V
	retlw	111	;o
	retlw	108	;l
	retlw	117	;u
	retlw	109	;m
	retlw	101	;e
	retlw	32	; 
	retlw	68	;D
	retlw	111	;o
	retlw	119	;w
	retlw	110	;n


StringTable17
	retlw	4
	retlw	77	;M
	retlw	117	;u
	retlw	116	;t
	retlw	101	;e


StringTable18
	retlw	5
	retlw	80	;P
	retlw	111	;o
	retlw	119	;w
	retlw	101	;e
	retlw	114	;r


StringTable19
	retlw	3
	retlw	77	;M
	retlw	84	;T
	retlw	83	;S


StringTable20
	retlw	7
	retlw	83	;S
	retlw	99	;c
	retlw	97	;a
	retlw	108	;l
	retlw	105	;i
	retlw	110	;n
	retlw	103	;g


StringTable21
	retlw	6
	retlw	83	;S
	retlw	111	;o
	retlw	117	;u
	retlw	114	;r
	retlw	99	;c
	retlw	101	;e


StringTable22
	retlw	5
	retlw	83	;S
	retlw	108	;l
	retlw	101	;e
	retlw	101	;e
	retlw	112	;p


StringTable23
	retlw	7
	retlw	68	;D
	retlw	105	;i
	retlw	115	;s
	retlw	112	;p
	retlw	108	;l
	retlw	97	;a
	retlw	121	;y


StringTable24
	retlw	6
	retlw	82	;R
	retlw	101	;e
	retlw	116	;t
	retlw	117	;u
	retlw	114	;r
	retlw	110	;n


StringTable25
	retlw	2
	retlw	67	;C
	retlw	67	;C


StringTable26
	retlw	8
	retlw	80	;P
	retlw	73	;I
	retlw	80	;P
	retlw	32	; 
	retlw	77	;M
	retlw	101	;e
	retlw	110	;n
	retlw	117	;u


StringTable27
	retlw	3
	retlw	80	;P
	retlw	73	;I
	retlw	80	;P


StringTable28
	retlw	3
	retlw	49	;1
	retlw	48	;0
	retlw	48	;0


StringTable29
	retlw	4
	retlw	77	;M
	retlw	101	;e
	retlw	110	;n
	retlw	117	;u


StringTable30
	retlw	4
	retlw	69	;E
	retlw	120	;x
	retlw	105	;i
	retlw	116	;t


StringTable31
	retlw	3
	retlw	78	;N
	retlw	47	;/
	retlw	65	;A


StringTable32
	retlw	6
	retlw	67	;C
	retlw	111	;o
	retlw	100	;d
	retlw	101	;e
	retlw	58	;:
	retlw	32	; 


StringTable33
	retlw	5
	retlw	32	; 
	retlw	45	;-
	retlw	45	;-
	retlw	45	;-
	retlw	32	; 


;********************************************************************************


 END
