;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
SYSDIVMULTA	EQU	119
SYSDIVMULTA_H	EQU	120
SYSDIVMULTB	EQU	123
SYSDIVMULTB_H	EQU	124
SYSDIVMULTX	EQU	114
SYSDIVMULTX_H	EQU	115
SysCalcTempA	EQU	117
SysCalcTempA_H	EQU	118
SysCalcTempB	EQU	121
SysCalcTempB_H	EQU	122
SysCalcTempX	EQU	112
SysCalcTempX_H	EQU	113
SysDivLoop	EQU	116
CCPCONCACHE	EQU	32
PR2_TEMP	EQU	33
PR2_TEMP_H	EQU	34
PREV	EQU	36
PWMCHANNEL	EQU	37
PWMDUTY	EQU	38
PWMFREQ	EQU	39
SysTemp1	EQU	40
SysTemp1_H	EQU	41
SysTemp2	EQU	42
SysTemp2_H	EQU	43
T2_PR	EQU	44
TOGGLE	EQU	45

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS
	call	INITPWM

;Start of the main program
;A program to put the motor under control of the center-off
;toggle switch. There are three levels: off, medium and fast.
;Connect GP2 to the motor, and GP0 and GP1 to toggle legs 1 and 2,
;respectively. Also jumper the motor pins of header J4.
;However, you could also run this with the lamp for giggles.
;Hardware PWM is used.
;----- Settings
;----- Constants
;#define toggle1 GPIO.0	;center-off toggle switch
;#define toggle2 GPIO.1
;#define	control	GPIO.2	;PWM occurs on pin 5
;#define	frequency 5			;PWM frequency fixed at 5kHz
;----- Program
;dir toggle1 in
	banksel	TRISIO
	bsf	TRISIO,0
;dir toggle2 in
	bsf	TRISIO,1
;dir control out
	bcf	TRISIO,2
;prev = 0
	banksel	PREV
	clrf	PREV
;do
SysDoLoop_S1
;toggle = !GPIO & 0b00000011	;read the toggle
	comf	GPIO,W
	movwf	SysTemp1
	movlw	3
	andwf	SysTemp1,W
	movwf	TOGGLE
;select case toggle
SysSelect1Case1
	movf	TOGGLE,F
	btfss	STATUS, Z
	goto	SysSelect1Case2
;hpwm 1, frequency, 127	;CCP, frequency (kHz), 50%
	movlw	1
	movwf	PWMCHANNEL
	movlw	5
	movwf	PWMFREQ
	movlw	127
	movwf	PWMDUTY
	call	HPWM
	goto	SysSelectEnd1
SysSelect1Case2
	decf	TOGGLE,W
	btfss	STATUS, Z
	goto	SysSelect1Case3
;hpwm 1, frequency, 0		;CCP, frequency (kHz), 0%
	movlw	1
	movwf	PWMCHANNEL
	movlw	5
	movwf	PWMFREQ
	clrf	PWMDUTY
	call	HPWM
	goto	SysSelectEnd1
SysSelect1Case3
	movlw	2
	subwf	TOGGLE,W
	btfss	STATUS, Z
	goto	SysSelect1Case4
;hpwm 1, frequency, 255	;CCP, frequency (kHz), 100%
	movlw	1
	movwf	PWMCHANNEL
	movlw	5
	movwf	PWMFREQ
	movlw	255
	movwf	PWMDUTY
	call	HPWM
;end select		
SysSelect1Case4
SysSelectEnd1
;loop                      		;repeat in perpetuity
	goto	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

HPWM
;dim PR2_Temp as word
;T2_PR = 1
	movlw	1
	movwf	T2_PR
;PR2_Temp = PWMOsc1/PWMFreq
	movlw	208
	movwf	SysCalcTempA
	movlw	7
	movwf	SysCalcTempA_H
	movf	PWMFREQ,W
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	PR2_TEMP
	movf	SysCalcTempA_H,W
	movwf	PR2_TEMP_H
;IF PR2_Temp_H > 0 then
	sublw	0
	btfsc	STATUS, C
	goto	ENDIF1
;T2_PR = 4
	movlw	4
	movwf	T2_PR
;set STATUS.C off
	bcf	STATUS,C
;rotate PR2_Temp right
	rrf	PR2_TEMP_H,F
	rrf	PR2_TEMP,F
;set STATUS.C off
	bcf	STATUS,C
;rotate PR2_Temp right
	rrf	PR2_TEMP_H,F
	rrf	PR2_TEMP,F
;end if
ENDIF1
;IF PR2_Temp_H > 0 then
	movf	PR2_TEMP_H,W
	sublw	0
	btfsc	STATUS, C
	goto	ENDIF2
;T2_PR = 16
	movlw	16
	movwf	T2_PR
;set STATUS.C off
	bcf	STATUS,C
;rotate PR2_Temp right
	rrf	PR2_TEMP_H,F
	rrf	PR2_TEMP,F
;set STATUS.C off
	bcf	STATUS,C
;rotate PR2_Temp right
	rrf	PR2_TEMP_H,F
	rrf	PR2_TEMP,F
;end if
ENDIF2
;PR2 = PR2_Temp
	movf	PR2_TEMP,W
	banksel	PR2
	movwf	PR2
;SET T2CON.T2CKPS0 OFF
	banksel	T2CON
	bcf	T2CON,T2CKPS0
;SET T2CON.T2CKPS1 OFF
	bcf	T2CON,T2CKPS1
;if T2_PR = 4 then SET T2CON.T2CKPS0 ON
	movlw	4
	subwf	T2_PR,W
	btfsc	STATUS, Z
	bsf	T2CON,T2CKPS0
;if T2_PR = 16 then SET T2CON.T2CKPS1 ON
	movlw	16
	subwf	T2_PR,W
	btfsc	STATUS, Z
	bsf	T2CON,T2CKPS1
;SET T2CON.TMR2ON ON
	bsf	T2CON,TMR2ON
;CCPR1L = ([word]PWMDuty * PR2) / 255
	movf	PWMDUTY,W
	movwf	SysCalcTempA
	clrf	SysCalcTempA_H
	banksel	PR2
	movf	PR2,W
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	banksel	STATUS
	call	SysMultSub16
	movf	SysCalcTempX,W
	movwf	SysTemp1
	movf	SysCalcTempX_H,W
	movwf	SysTemp1_H
	movf	SysTemp1,W
	movwf	SysCalcTempA
	movf	SysTemp1_H,W
	movwf	SysCalcTempA_H
	movlw	255
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	CCPR1L
;SET CCP1CON.CCP1M3 ON
	bsf	CCP1CON,CCP1M3
;SET CCP1CON.CCP1M2 ON
	bsf	CCP1CON,CCP1M2
;SET CCP1CON.CCP1M1 OFF
	bcf	CCP1CON,CCP1M1
;SET CCP1CON.CCP1M0 OFF
	bcf	CCP1CON,CCP1M0
	return

;********************************************************************************

INITPWM
;PR2 = PR2Temp
	movlw	52
	banksel	PR2
	movwf	PR2
;SET T2CON.T2CKPS0 OFF
	banksel	T2CON
	bcf	T2CON,T2CKPS0
;SET T2CON.T2CKPS1 OFF
	bcf	T2CON,T2CKPS1
;CCPR1L = DutyCycleH
	movlw	26
	movwf	CCPR1L
;SET CCPCONCache.DC1B1 ON
	bsf	CCPCONCACHE,DC1B1
;SET CCPCONCache.DC1B0 OFF
	bcf	CCPCONCACHE,DC1B0
;SET CCPCONCache.CCP1M3 ON
	bsf	CCPCONCACHE,CCP1M3
;SET CCPCONCache.CCP1M2 ON
	bsf	CCPCONCACHE,CCP1M2
;SET CCPCONCache.CCP1M1 OFF
	bcf	CCPCONCACHE,CCP1M1
;SET CCPCONCache.CCP1M0 OFF
	bcf	CCPCONCACHE,CCP1M0
;SET T2CON.TMR2ON ON
	bsf	T2CON,TMR2ON
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

SYSCOMPEQUAL16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA, W
	movf	SYSCALCTEMPA, W
;subwf SysCalcTempB, W
	subwf	SYSCALCTEMPB, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;movf SysCalcTempA_H, W
	movf	SYSCALCTEMPA_H, W
;subwf SysCalcTempB_H, W
	subwf	SYSCALCTEMPB_H, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSCOMPLESSTHAN16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA_H,W
	movf	SYSCALCTEMPA_H,W
;subwf SysCalcTempB_H,W
	subwf	SYSCALCTEMPB_H,W
;btfss STATUS,C
	btfss	STATUS,C
;return
	return
;movf SysCalcTempB_H,W
	movf	SYSCALCTEMPB_H,W
;subwf SysCalcTempA_H,W
	subwf	SYSCALCTEMPA_H,W
;btfss STATUS,C
	btfss	STATUS,C
;goto SCLT16True
	goto	SCLT16TRUE
;movf SysCalcTempB,W
	movf	SYSCALCTEMPB,W
;subwf SysCalcTempA,W
	subwf	SYSCALCTEMPA,W
;btfsc STATUS,C
	btfsc	STATUS,C
;return
	return
SCLT16TRUE
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSDIVSUB16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as word
;dim SysDivMultA as word
;dim SysDivMultB as word
;dim SysDivMultX as word
;SysDivMultA = SysCalcTempA
	movf	SYSCALCTEMPA,W
	movwf	SYSDIVMULTA
	movf	SYSCALCTEMPA_H,W
	movwf	SYSDIVMULTA_H
;SysDivMultB = SysCalcTempB
	movf	SYSCALCTEMPB,W
	movwf	SYSDIVMULTB
	movf	SYSCALCTEMPB_H,W
	movwf	SYSDIVMULTB_H
;SysDivMultX = 0
	clrf	SYSDIVMULTX
	clrf	SYSDIVMULTX_H
;if SysDivMultB = 0 then
	movf	SYSDIVMULTB,W
	movwf	SysCalcTempA
	movf	SYSDIVMULTB_H,W
	movwf	SysCalcTempA_H
	clrf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysCompEqual16
	btfss	SysCalcTempX,0
	goto	ENDIF7
;SysCalcTempA = 0
	clrf	SYSCALCTEMPA
	clrf	SYSCALCTEMPA_H
;exit sub
	return
;end if
ENDIF7
;SysDivLoop = 16
	movlw	16
	movwf	SYSDIVLOOP
SYSDIV16START
;set C off
	bcf	STATUS,C
;Rotate SysDivMultA Left
	rlf	SYSDIVMULTA,F
	rlf	SYSDIVMULTA_H,F
;Rotate SysDivMultX Left
	rlf	SYSDIVMULTX,F
	rlf	SYSDIVMULTX_H,F
;SysDivMultX = SysDivMultX - SysDivMultB
	movf	SYSDIVMULTB,W
	subwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfss	STATUS,C
	addlw	1
	subwf	SYSDIVMULTX_H,F
;Set SysDivMultA.0 On
	bsf	SYSDIVMULTA,0
;If C Off Then
	btfsc	STATUS,C
	goto	ENDIF8
;Set SysDivMultA.0 Off
	bcf	SYSDIVMULTA,0
;SysDivMultX = SysDivMultX + SysDivMultB
	movf	SYSDIVMULTB,W
	addwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfsc	STATUS,C
	addlw	1
	addwf	SYSDIVMULTX_H,F
;End If
ENDIF8
;decfsz SysDivLoop, F
	decfsz	SYSDIVLOOP, F
;goto SysDiv16Start
	goto	SYSDIV16START
;SysCalcTempA = SysDivMultA
	movf	SYSDIVMULTA,W
	movwf	SYSCALCTEMPA
	movf	SYSDIVMULTA_H,W
	movwf	SYSCALCTEMPA_H
;SysCalcTempX = SysDivMultX
	movf	SYSDIVMULTX,W
	movwf	SYSCALCTEMPX
	movf	SYSDIVMULTX_H,W
	movwf	SYSCALCTEMPX_H
	return

;********************************************************************************

SYSMULTSUB16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as word
;dim SysDivMultA as word
;dim SysDivMultB as word
;dim SysDivMultX as word
;SysDivMultA = SysCalcTempA
	movf	SYSCALCTEMPA,W
	movwf	SYSDIVMULTA
	movf	SYSCALCTEMPA_H,W
	movwf	SYSDIVMULTA_H
;SysDivMultB = SysCalcTempB
	movf	SYSCALCTEMPB,W
	movwf	SYSDIVMULTB
	movf	SYSCALCTEMPB_H,W
	movwf	SYSDIVMULTB_H
;SysDivMultX = 0
	clrf	SYSDIVMULTX
	clrf	SYSDIVMULTX_H
MUL16LOOP
;IF SysDivMultB.0 ON then SysDivMultX += SysDivMultA
	btfss	SYSDIVMULTB,0
	goto	ENDIF5
	movf	SYSDIVMULTA,W
	addwf	SYSDIVMULTX,F
	movf	SYSDIVMULTA_H,W
	btfsc	STATUS,C
	addlw	1
	addwf	SYSDIVMULTX_H,F
ENDIF5
;set STATUS.C OFF
	bcf	STATUS,C
;rotate SysDivMultB right
	rrf	SYSDIVMULTB_H,F
	rrf	SYSDIVMULTB,F
;set STATUS.C off
	bcf	STATUS,C
;rotate SysDivMultA left
	rlf	SYSDIVMULTA,F
	rlf	SYSDIVMULTA_H,F
;if SysDivMultB > 0 then goto MUL16LOOP
	movf	SYSDIVMULTB,W
	movwf	SysCalcTempB
	movf	SYSDIVMULTB_H,W
	movwf	SysCalcTempB_H
	clrf	SysCalcTempA
	clrf	SysCalcTempA_H
	call	SysCompLessThan16
	btfsc	SysCalcTempX,0
	goto	MUL16LOOP
;SysCalcTempX = SysDivMultX
	movf	SYSDIVMULTX,W
	movwf	SYSCALCTEMPX
	movf	SYSDIVMULTX_H,W
	movwf	SYSCALCTEMPX_H
	return

;********************************************************************************


 END
