;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
DELAYTEMP2	EQU	113
SYSDIVMULTA	EQU	119
SYSDIVMULTA_H	EQU	120
SYSDIVMULTB	EQU	123
SYSDIVMULTB_H	EQU	124
SYSDIVMULTX	EQU	114
SYSDIVMULTX_H	EQU	115
SysCalcTempA	EQU	117
SysCalcTempA_H	EQU	118
SysCalcTempB	EQU	121
SysCalcTempB_H	EQU	122
SysCalcTempX	EQU	112
SysCalcTempX_H	EQU	113
SysDivLoop	EQU	116
SysWaitTempMS	EQU	114
SysWaitTempMS_H	EQU	115
SysWaitTempUS	EQU	117
SysWaitTempUS_H	EQU	118
PULSE	EQU	177
CCPCONCACHE	EQU	32
CMD	EQU	33
COUNT	EQU	34
DEVICE	EQU	35
DUTY	EQU	36
I	EQU	37
NUMBER	EQU	38
PR2_TEMP	EQU	39
PR2_TEMP_H	EQU	40
PWMCHANNEL	EQU	42
PWMDUTY	EQU	43
PWMFREQ	EQU	44
SysTemp1	EQU	45
SysTemp1_H	EQU	46
SysTemp2	EQU	47
SysTemp2_H	EQU	48
SysTemp3	EQU	49
T2_PR	EQU	50

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS
	call	INITPWM

;Start of the main program
;This project will change the motor's speed under remote
;control. In addition, four LEDs will display the current
;speed (0 through 15). A television remote control that
;obeys the Sony commands is assumed. Use the Channel Up
;button to increase the speed and Channel Down to decrease it.
;Connect GP0, GP1, GP4 and GP5 to LED1 through LED4,
;respectively. Connect GP3 to the IR detector. Connect
;GP2 to the motor. Also jumper the motor pins of header J4.
;----- Constants
;#define LED0		GPIO.0	;LED0 on pin 7
;#define LED1		GPIO.1	;LED1 on pin 6
;#define	control	GPIO.2	;PWM occurs on pin 5
;#define IR			GPIO.3	;IR sensor on pin 4
;#define LED2		GPIO.4	;LED2 on pin 3
;#define LED3		GPIO.5	;LED3 on pin 2
;#define channelUp		16	;Channel Up code
;#define channelDown 17	;Channel Down code
;#define	frequency 5			;PWM frequency fixed at 5kHz
;----- Variables
;dim pulse(12)						;12-byte array holds pulse code
;dim number, count, i, cmd, device, duty as byte
;----- Main Program
;dir GPIO out						;all but GP3 are outputs
	banksel	TRISIO
	clrf	TRISIO
;number = 0							;assume not button pressed
	banksel	NUMBER
	clrf	NUMBER
MAIN
;getIR, cmd						;read the remote control
	call	GETIR
;if (cmd = channelUp) & (number < 15) then
	movf	CMD,W
	movwf	SysCalcTempA
	movlw	16
	movwf	SysCalcTempB
	call	SysCompEqual
	movf	SysCalcTempX,W
	movwf	SysTemp1
	movf	NUMBER,W
	movwf	SysCalcTempA
	movlw	15
	movwf	SysCalcTempB
	call	SysCompLessThan
	movf	SysCalcTempX,W
	movwf	SysTemp2
	movf	SysTemp1,W
	andwf	SysTemp2,W
	movwf	SysTemp3
	btfss	SysTemp3,0
	goto	ENDIF1
;number += 1					;bump the speed
	incf	NUMBER,F
;goto process
	goto	PROCESS
;end if
ENDIF1
;if (cmd = channelDown) & (number > 0) then	
	movf	CMD,W
	movwf	SysCalcTempA
	movlw	17
	movwf	SysCalcTempB
	call	SysCompEqual
	movf	SysCalcTempX,W
	movwf	SysTemp1
	movf	NUMBER,W
	movwf	SysCalcTempB
	clrf	SysCalcTempA
	call	SysCompLessThan
	movf	SysCalcTempX,W
	movwf	SysTemp2
	movf	SysTemp1,W
	andwf	SysTemp2,W
	movwf	SysTemp3
	btfss	SysTemp3,0
	goto	ENDIF2
;number -= 1					;decrease the speed
	decf	NUMBER,F
;goto process
	goto	PROCESS
;end if
ENDIF2
;goto main               ;no update required
	goto	MAIN
PROCESS
;updateLEDs						;show number on LEDs
	call	UPDATELEDS
;updateMotor						;change motor speed
	call	UPDATEMOTOR
;wait 500 mS						;ignore any repeats
	movlw	244
	movwf	SysWaitTempMS
	movlw	1
	movwf	SysWaitTempMS_H
	call	Delay_MS
;goto main								;repeat in perpetuity
	goto	MAIN
;----- Subroutines
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	4
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	165
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

GETIR
TARRY1
;count = 0						;wait for the start bit
	clrf	COUNT
;do while IR = 0			;measure pulse width (active low)
SysDoLoop_S1
	btfsc	GPIO,3
	goto	SysDoLoop_E1
;wait 100 uS				;24 units of 100 uS = 2.4 mS
	movlw	66
	movwf	DELAYTEMP
DelayUS1
	decfsz	DELAYTEMP,F
	goto	DelayUS1
	nop
;count += 1			
	incf	COUNT,F
;loop
	goto	SysDoLoop_S1
SysDoLoop_E1
;if count < 20 then goto tarry1	;less than this so wait
	movlw	20
	subwf	COUNT,W
	btfss	STATUS, C
	goto	TARRY1
;for i=1 to 12                 	;read/store the 12 pulses
	clrf	I
SysForLoop1
	incf	I,F
TARRY2
;count = 0
	clrf	COUNT
;do while IR = 0							;zero = 6 units = 0.6 mS
SysDoLoop_S2
	btfsc	GPIO,3
	goto	SysDoLoop_E2
;wait 100 uS								;one = 12 units = 1.2 mS
	movlw	66
	movwf	DELAYTEMP
DelayUS2
	decfsz	DELAYTEMP,F
	goto	DelayUS2
	nop
;count += 1
	incf	COUNT,F
;loop
	goto	SysDoLoop_S2
SysDoLoop_E2
;if count < 4 then goto tarry2	;too small to be legit
	movlw	4
	subwf	COUNT,W
	btfss	STATUS, C
	goto	TARRY2
;pulse(i) = count							;else store pulse width
	movlw	low(PULSE)
	addwf	I,W
	movwf	FSR
	movf	COUNT,W
	movwf	INDF
;next
	movlw	12
	subwf	I,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
;cmd = 0							  					;command built up here
	clrf	CMD
;for i = 1 to 7 									;1st seven bits are the cmd
	clrf	I
SysForLoop2
	incf	I,F
;cmd = cmd / 2									;shift into place
	bcf	STATUS,C
	rrf	CMD,F
;if pulse(i) > 10 then 	  		;longer than 10 mS
	movlw	low(PULSE)
	addwf	I,W
	movwf	FSR
	movf	INDF,W
	sublw	10
	btfsc	STATUS, C
	goto	ENDIF6
;cmd = cmd + 64   					;so call it a one
	movlw	64
	addwf	CMD,F
;end if
ENDIF6
;next
	movlw	7
	subwf	I,W
	btfss	STATUS, C
	goto	SysForLoop2
SysForLoopEnd2
;device = 0											;device number built up here
	clrf	DEVICE
;for i=8 to 12										;next 5 bits are device number
	movlw	7
	movwf	I
SysForLoop3
	incf	I,F
;device = device / 2						
	bcf	STATUS,C
	rrf	DEVICE,F
;if pulse(i) > 10 then
	movlw	low(PULSE)
	addwf	I,W
	movwf	FSR
	movf	INDF,W
	sublw	10
	btfsc	STATUS, C
	goto	ENDIF8
;device = device + 16
	movlw	16
	addwf	DEVICE,F
;end if
ENDIF8
;next	
	movlw	12
	subwf	I,W
	btfss	STATUS, C
	goto	SysForLoop3
SysForLoopEnd3
	return

;********************************************************************************

HPWM
;dim PR2_Temp as word
;T2_PR = 1
	movlw	1
	movwf	T2_PR
;PR2_Temp = PWMOsc1/PWMFreq
	movlw	208
	movwf	SysCalcTempA
	movlw	7
	movwf	SysCalcTempA_H
	movf	PWMFREQ,W
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	PR2_TEMP
	movf	SysCalcTempA_H,W
	movwf	PR2_TEMP_H
;IF PR2_Temp_H > 0 then
	sublw	0
	btfsc	STATUS, C
	goto	ENDIF14
;T2_PR = 4
	movlw	4
	movwf	T2_PR
;set STATUS.C off
	bcf	STATUS,C
;rotate PR2_Temp right
	rrf	PR2_TEMP_H,F
	rrf	PR2_TEMP,F
;set STATUS.C off
	bcf	STATUS,C
;rotate PR2_Temp right
	rrf	PR2_TEMP_H,F
	rrf	PR2_TEMP,F
;end if
ENDIF14
;IF PR2_Temp_H > 0 then
	movf	PR2_TEMP_H,W
	sublw	0
	btfsc	STATUS, C
	goto	ENDIF15
;T2_PR = 16
	movlw	16
	movwf	T2_PR
;set STATUS.C off
	bcf	STATUS,C
;rotate PR2_Temp right
	rrf	PR2_TEMP_H,F
	rrf	PR2_TEMP,F
;set STATUS.C off
	bcf	STATUS,C
;rotate PR2_Temp right
	rrf	PR2_TEMP_H,F
	rrf	PR2_TEMP,F
;end if
ENDIF15
;PR2 = PR2_Temp
	movf	PR2_TEMP,W
	banksel	PR2
	movwf	PR2
;SET T2CON.T2CKPS0 OFF
	banksel	T2CON
	bcf	T2CON,T2CKPS0
;SET T2CON.T2CKPS1 OFF
	bcf	T2CON,T2CKPS1
;if T2_PR = 4 then SET T2CON.T2CKPS0 ON
	movlw	4
	subwf	T2_PR,W
	btfsc	STATUS, Z
	bsf	T2CON,T2CKPS0
;if T2_PR = 16 then SET T2CON.T2CKPS1 ON
	movlw	16
	subwf	T2_PR,W
	btfsc	STATUS, Z
	bsf	T2CON,T2CKPS1
;SET T2CON.TMR2ON ON
	bsf	T2CON,TMR2ON
;CCPR1L = ([word]PWMDuty * PR2) / 255
	movf	PWMDUTY,W
	movwf	SysCalcTempA
	clrf	SysCalcTempA_H
	banksel	PR2
	movf	PR2,W
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	banksel	STATUS
	call	SysMultSub16
	movf	SysCalcTempX,W
	movwf	SysTemp1
	movf	SysCalcTempX_H,W
	movwf	SysTemp1_H
	movf	SysTemp1,W
	movwf	SysCalcTempA
	movf	SysTemp1_H,W
	movwf	SysCalcTempA_H
	movlw	255
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	CCPR1L
;SET CCP1CON.CCP1M3 ON
	bsf	CCP1CON,CCP1M3
;SET CCP1CON.CCP1M2 ON
	bsf	CCP1CON,CCP1M2
;SET CCP1CON.CCP1M1 OFF
	bcf	CCP1CON,CCP1M1
;SET CCP1CON.CCP1M0 OFF
	bcf	CCP1CON,CCP1M0
	return

;********************************************************************************

INITPWM
;PR2 = PR2Temp
	movlw	52
	banksel	PR2
	movwf	PR2
;SET T2CON.T2CKPS0 OFF
	banksel	T2CON
	bcf	T2CON,T2CKPS0
;SET T2CON.T2CKPS1 OFF
	bcf	T2CON,T2CKPS1
;CCPR1L = DutyCycleH
	movlw	26
	movwf	CCPR1L
;SET CCPCONCache.DC1B1 ON
	bsf	CCPCONCACHE,DC1B1
;SET CCPCONCache.DC1B0 OFF
	bcf	CCPCONCACHE,DC1B0
;SET CCPCONCache.CCP1M3 ON
	bsf	CCPCONCACHE,CCP1M3
;SET CCPCONCache.CCP1M2 ON
	bsf	CCPCONCACHE,CCP1M2
;SET CCPCONCache.CCP1M1 OFF
	bcf	CCPCONCACHE,CCP1M1
;SET CCPCONCache.CCP1M0 OFF
	bcf	CCPCONCACHE,CCP1M0
;SET T2CON.TMR2ON ON
	bsf	T2CON,TMR2ON
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

SYSCOMPEQUAL
;Dim SysCalcTempA, SysCalcTempB, SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA, W
	movf	SYSCALCTEMPA, W
;subwf SysCalcTempB, W
	subwf	SYSCALCTEMPB, W
;btfsc STATUS, Z
	btfsc	STATUS, Z
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSCOMPEQUAL16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA, W
	movf	SYSCALCTEMPA, W
;subwf SysCalcTempB, W
	subwf	SYSCALCTEMPB, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;movf SysCalcTempA_H, W
	movf	SYSCALCTEMPA_H, W
;subwf SysCalcTempB_H, W
	subwf	SYSCALCTEMPB_H, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSCOMPLESSTHAN
;Dim SysCalcTempA, SysCalcTempB, SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;bsf STATUS, C
	bsf	STATUS, C
;movf SysCalcTempB, W
	movf	SYSCALCTEMPB, W
;subwf SysCalcTempA, W
	subwf	SYSCALCTEMPA, W
;btfss STATUS, C
	btfss	STATUS, C
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSCOMPLESSTHAN16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA_H,W
	movf	SYSCALCTEMPA_H,W
;subwf SysCalcTempB_H,W
	subwf	SYSCALCTEMPB_H,W
;btfss STATUS,C
	btfss	STATUS,C
;return
	return
;movf SysCalcTempB_H,W
	movf	SYSCALCTEMPB_H,W
;subwf SysCalcTempA_H,W
	subwf	SYSCALCTEMPA_H,W
;btfss STATUS,C
	btfss	STATUS,C
;goto SCLT16True
	goto	SCLT16TRUE
;movf SysCalcTempB,W
	movf	SYSCALCTEMPB,W
;subwf SysCalcTempA,W
	subwf	SYSCALCTEMPA,W
;btfsc STATUS,C
	btfsc	STATUS,C
;return
	return
SCLT16TRUE
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSDIVSUB16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as word
;dim SysDivMultA as word
;dim SysDivMultB as word
;dim SysDivMultX as word
;SysDivMultA = SysCalcTempA
	movf	SYSCALCTEMPA,W
	movwf	SYSDIVMULTA
	movf	SYSCALCTEMPA_H,W
	movwf	SYSDIVMULTA_H
;SysDivMultB = SysCalcTempB
	movf	SYSCALCTEMPB,W
	movwf	SYSDIVMULTB
	movf	SYSCALCTEMPB_H,W
	movwf	SYSDIVMULTB_H
;SysDivMultX = 0
	clrf	SYSDIVMULTX
	clrf	SYSDIVMULTX_H
;if SysDivMultB = 0 then
	movf	SYSDIVMULTB,W
	movwf	SysCalcTempA
	movf	SYSDIVMULTB_H,W
	movwf	SysCalcTempA_H
	clrf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysCompEqual16
	btfss	SysCalcTempX,0
	goto	ENDIF20
;SysCalcTempA = 0
	clrf	SYSCALCTEMPA
	clrf	SYSCALCTEMPA_H
;exit sub
	return
;end if
ENDIF20
;SysDivLoop = 16
	movlw	16
	movwf	SYSDIVLOOP
SYSDIV16START
;set C off
	bcf	STATUS,C
;Rotate SysDivMultA Left
	rlf	SYSDIVMULTA,F
	rlf	SYSDIVMULTA_H,F
;Rotate SysDivMultX Left
	rlf	SYSDIVMULTX,F
	rlf	SYSDIVMULTX_H,F
;SysDivMultX = SysDivMultX - SysDivMultB
	movf	SYSDIVMULTB,W
	subwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfss	STATUS,C
	addlw	1
	subwf	SYSDIVMULTX_H,F
;Set SysDivMultA.0 On
	bsf	SYSDIVMULTA,0
;If C Off Then
	btfsc	STATUS,C
	goto	ENDIF21
;Set SysDivMultA.0 Off
	bcf	SYSDIVMULTA,0
;SysDivMultX = SysDivMultX + SysDivMultB
	movf	SYSDIVMULTB,W
	addwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfsc	STATUS,C
	addlw	1
	addwf	SYSDIVMULTX_H,F
;End If
ENDIF21
;decfsz SysDivLoop, F
	decfsz	SYSDIVLOOP, F
;goto SysDiv16Start
	goto	SYSDIV16START
;SysCalcTempA = SysDivMultA
	movf	SYSDIVMULTA,W
	movwf	SYSCALCTEMPA
	movf	SYSDIVMULTA_H,W
	movwf	SYSCALCTEMPA_H
;SysCalcTempX = SysDivMultX
	movf	SYSDIVMULTX,W
	movwf	SYSCALCTEMPX
	movf	SYSDIVMULTX_H,W
	movwf	SYSCALCTEMPX_H
	return

;********************************************************************************

SYSMULTSUB
;dim SysCalcTempA as byte
;dim SysCalcTempB as byte
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
MUL8LOOP
;movf SysCalcTempA, W
	movf	SYSCALCTEMPA, W
;btfsc SysCalcTempB, 0
	btfsc	SYSCALCTEMPB, 0
;addwf SysCalcTempX, F
	addwf	SYSCALCTEMPX, F
;bcf STATUS, C
	bcf	STATUS, C
;rrf SysCalcTempB, F
	rrf	SYSCALCTEMPB, F
;bcf STATUS, C
	bcf	STATUS, C
;rlf SysCalcTempA, F
	rlf	SYSCALCTEMPA, F
;movf SysCalcTempB, F
	movf	SYSCALCTEMPB, F
;btfss STATUS, Z
	btfss	STATUS, Z
;goto MUL8LOOP
	goto	MUL8LOOP
	return

;********************************************************************************

SYSMULTSUB16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as word
;dim SysDivMultA as word
;dim SysDivMultB as word
;dim SysDivMultX as word
;SysDivMultA = SysCalcTempA
	movf	SYSCALCTEMPA,W
	movwf	SYSDIVMULTA
	movf	SYSCALCTEMPA_H,W
	movwf	SYSDIVMULTA_H
;SysDivMultB = SysCalcTempB
	movf	SYSCALCTEMPB,W
	movwf	SYSDIVMULTB
	movf	SYSCALCTEMPB_H,W
	movwf	SYSDIVMULTB_H
;SysDivMultX = 0
	clrf	SYSDIVMULTX
	clrf	SYSDIVMULTX_H
MUL16LOOP
;IF SysDivMultB.0 ON then SysDivMultX += SysDivMultA
	btfss	SYSDIVMULTB,0
	goto	ENDIF18
	movf	SYSDIVMULTA,W
	addwf	SYSDIVMULTX,F
	movf	SYSDIVMULTA_H,W
	btfsc	STATUS,C
	addlw	1
	addwf	SYSDIVMULTX_H,F
ENDIF18
;set STATUS.C OFF
	bcf	STATUS,C
;rotate SysDivMultB right
	rrf	SYSDIVMULTB_H,F
	rrf	SYSDIVMULTB,F
;set STATUS.C off
	bcf	STATUS,C
;rotate SysDivMultA left
	rlf	SYSDIVMULTA,F
	rlf	SYSDIVMULTA_H,F
;if SysDivMultB > 0 then goto MUL16LOOP
	movf	SYSDIVMULTB,W
	movwf	SysCalcTempB
	movf	SYSDIVMULTB_H,W
	movwf	SysCalcTempB_H
	clrf	SysCalcTempA
	clrf	SysCalcTempA_H
	call	SysCompLessThan16
	btfsc	SysCalcTempX,0
	goto	MUL16LOOP
;SysCalcTempX = SysDivMultX
	movf	SYSDIVMULTX,W
	movwf	SYSCALCTEMPX
	movf	SYSDIVMULTX_H,W
	movwf	SYSCALCTEMPX_H
	return

;********************************************************************************

UPDATELEDS
;set LED0 off										;clear current display
	bcf	GPIO,0
;set LED1 off
	bcf	GPIO,1
;set LED2 off
	bcf	GPIO,4
;set LED3 off
	bcf	GPIO,5
;if number.0 then								;turn on bits one by one
	btfsc	NUMBER,0
;set LED0 on
	bsf	GPIO,0
;end if
;if number.1 then
	btfsc	NUMBER,1
;set LED1 on
	bsf	GPIO,1
;end if
;if number.2 then
	btfsc	NUMBER,2
;set LED2 on
	bsf	GPIO,4
;end if
;if number.3 then
	btfsc	NUMBER,3
;set LED3 on
	bsf	GPIO,5
;end if
	return

;********************************************************************************

UPDATEMOTOR
;duty = 16*number								;convert to 0 to 240
	movlw	16
	movwf	SysCalcTempA
	movf	NUMBER,W
	movwf	SysCalcTempB
	call	SysMultSub
	movf	SysCalcTempX,W
	movwf	DUTY
;hpwm 1, frequency, duty	  			;CCP1, frequency (kHz), duty cycle
	movlw	1
	movwf	PWMCHANNEL
	movlw	5
	movwf	PWMFREQ
	movf	DUTY,W
	movwf	PWMDUTY
	goto	HPWM

;********************************************************************************


 END
