;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
SYSDIVMULTA	EQU	119
SYSDIVMULTA_H	EQU	120
SYSDIVMULTB	EQU	123
SYSDIVMULTB_H	EQU	124
SYSDIVMULTX	EQU	114
SYSDIVMULTX_H	EQU	115
SysCalcTempA	EQU	117
SysCalcTempA_H	EQU	118
SysCalcTempB	EQU	121
SysCalcTempB_H	EQU	122
SysCalcTempX	EQU	112
SysCalcTempX_H	EQU	113
SysDivLoop	EQU	116
SysWaitTemp10US	EQU	117
CCPCONCACHE	EQU	32
DURATION	EQU	33
FREQ	EQU	34
I	EQU	35
PR2_TEMP	EQU	36
PR2_TEMP_H	EQU	37
PWMCHANNEL	EQU	39
PWMDUTY	EQU	40
PWMFREQ	EQU	41
RANDOM	EQU	42
RANDOMSEED	EQU	43
RANDOMSEED_H	EQU	44
RANDOMTEMP	EQU	46
RANDOMTEMP_H	EQU	47
SysRepeatTemp1	EQU	48
SysRepeatTemp3	EQU	49
SysTemp1	EQU	50
SysTemp1_H	EQU	51
SysTemp2	EQU	52
SysTemp2_H	EQU	53
T2_PR	EQU	54
TONEDURATION	EQU	55
TONEDURATION_H	EQU	56
TONEFREQUENCY	EQU	57
TONEFREQUENCY_H	EQU	58
TONELOOP	EQU	59
TONELOOP_H	EQU	60
TONELOOP2	EQU	61
TONELOOP2_H	EQU	62
TONEPERIOD	EQU	63

;********************************************************************************

;Alias variables
TIMER0	EQU	TMR0

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS
	call	INITPWM
	call	INITSOUND
	call	INITRANDOM

;Start of the main program
;This creates a crazy R2D2 effect. In the old days it
;would have been called a do-nothing box.
;Connect GP0 and GP1 to LED1 and LED2. Connect GP2 to
;the motor and also select the motor on header J4.
;Connect GP3 to pushbutton 1. Connect GP4 to
;the piezo. Alternatively, you could connect GP4 to
;the line output and drive an external speaker or
;amplifier and then use the volume control to tame
;things as required. Connect GP5 to the green LED
;element ;and ground the red element.
;Press the pushbutton to start the action, then sit
;back and enjoy the show.
;----- Settings
;----- Constants
;#define LED1 GPIO.0						;LED1 on pin 7
;#define LED2 GPIO.1						;LED2 on pin 6
;#define motor GPIO.2					;motor on pin 5
;#define button GPIO.3					;pushbutton on pin 4
;#define SOUNDOUT GPIO.4				;piezo on pin 3
;#define green GPIO.5					;green LED on pin 2
;#define	frequency 5						;PWM frequency fixed at 5kHz
;----- Variables
;dim i, duration, freq as byte
;----- Program
;dir GPIO 0b00001000						;only the switch is input
	movlw	8
	banksel	TRISIO
	movwf	TRISIO
;randomize											;seed the random number generator
	banksel	TIMER0
	movf	TIMER0,W
	movwf	RANDOMTEMP
	clrf	RANDOMTEMP_H
	call	RANDOMIZE
;do
SysDoLoop_S1
;GPIO = 0b00000000						;turn everything off
	clrf	GPIO
;do
SysDoLoop_S2
;loop while button = 1				;wait for a button press
	btfsc	GPIO,3
	goto	SysDoLoop_S2
SysDoLoop_E2
;repeat 100									;do a bunch of warbling
	movlw	100
	movwf	SysRepeatTemp1
SysRepeatLoop1
;freq = random							;and random LED flashing
	call	FN_RANDOM
	movf	RANDOM,W
	movwf	FREQ
;set LED1 off
	bcf	GPIO,0
;set LED2 off
	bcf	GPIO,1
;set green off
	bcf	GPIO,5
;if freq.0 then
	btfsc	FREQ,0
;set LED1 on
	bsf	GPIO,0
;end if
;if freq.1 then
	btfsc	FREQ,1
;set LED2 on
	bsf	GPIO,1
;end if
;if freq.2 then
	btfsc	FREQ,2
;set green on
	bsf	GPIO,5
;end if	
;tone freq, 10							;a random tone here
	movf	FREQ,W
	movwf	TONEFREQUENCY
	clrf	TONEFREQUENCY_H
	movlw	10
	movwf	TONEDURATION
	clrf	TONEDURATION_H
	call	TONE
;end repeat
	decfsz	SysRepeatTemp1,F
	goto	SysRepeatLoop1
SysRepeatLoopEnd1
;repeat 25
	movlw	25
	movwf	SysRepeatTemp1
SysRepeatLoop2
;hpwm 1, frequency, 255		;motor at full speed
	movlw	1
	movwf	PWMCHANNEL
	movlw	5
	movwf	PWMFREQ
	movlw	255
	movwf	PWMDUTY
	call	HPWM
;freq = random							;continue with lights and sound
	call	FN_RANDOM
	movf	RANDOM,W
	movwf	FREQ
;set LED1 off
	bcf	GPIO,0
;set LED2 off
	bcf	GPIO,1
;set green off
	bcf	GPIO,5
;if freq.0 then
	btfsc	FREQ,0
;set LED1 on
	bsf	GPIO,0
;end if
;if freq.1 then
	btfsc	FREQ,1
;set LED2 on
	bsf	GPIO,1
;end if
;if freq.2 then
	btfsc	FREQ,2
;set green on
	bsf	GPIO,5
;end if	
;tone freq, 10
	movf	FREQ,W
	movwf	TONEFREQUENCY
	clrf	TONEFREQUENCY_H
	movlw	10
	movwf	TONEDURATION
	clrf	TONEDURATION_H
	call	TONE
;end repeat
	decfsz	SysRepeatTemp1,F
	goto	SysRepeatLoop2
SysRepeatLoopEnd2
;for i = 255 to 0 step -1		;now ramp down the motor as well
	clrf	I
SysForLoop1
	decf	I,F
;hpwm 1, frequency, i			;as the lights and sounds
	movlw	1
	movwf	PWMCHANNEL
	movlw	5
	movwf	PWMFREQ
	movf	I,W
	movwf	PWMDUTY
	call	HPWM
;freq = random
	call	FN_RANDOM
	movf	RANDOM,W
	movwf	FREQ
;set LED1 off
	bcf	GPIO,0
;set LED2 off
	bcf	GPIO,1
;set green off
	bcf	GPIO,5
;if freq.0 then
	btfsc	FREQ,0
;set LED1 on
	bsf	GPIO,0
;end if
;if freq.1 then
	btfsc	FREQ,1
;set LED2 on
	bsf	GPIO,1
;end if
;if freq.2 then
	btfsc	FREQ,2
;set green on
	bsf	GPIO,5
;end if	
;duration = (265-i)/4
	movf	I,W
	sublw	9
	movwf	SysTemp1
	movlw	1
	btfss	STATUS,C
	addlw	255
	movwf	SysTemp1_H
	movf	SysTemp1,W
	movwf	SysCalcTempA
	movf	SysTemp1_H,W
	movwf	SysCalcTempA_H
	movlw	4
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	DURATION
;tone freq, duration
	movf	FREQ,W
	movwf	TONEFREQUENCY
	clrf	TONEFREQUENCY_H
	movf	DURATION,W
	movwf	TONEDURATION
	clrf	TONEDURATION_H
	call	TONE
;next i
	movf	I,W
	sublw	0
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
;loop
	goto	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_10US
D10US_START
	movlw	5
	movwf	DELAYTEMP
DelayUS0
	decfsz	DELAYTEMP,F
	goto	DelayUS0
	nop
	decfsz	SysWaitTemp10US, F
	goto	D10US_START
	return

;********************************************************************************

HPWM
;dim PR2_Temp as word
;T2_PR = 1
	movlw	1
	movwf	T2_PR
;PR2_Temp = PWMOsc1/PWMFreq
	movlw	208
	movwf	SysCalcTempA
	movlw	7
	movwf	SysCalcTempA_H
	movf	PWMFREQ,W
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	PR2_TEMP
	movf	SysCalcTempA_H,W
	movwf	PR2_TEMP_H
;IF PR2_Temp_H > 0 then
	sublw	0
	btfsc	STATUS, C
	goto	ENDIF11
;T2_PR = 4
	movlw	4
	movwf	T2_PR
;set STATUS.C off
	bcf	STATUS,C
;rotate PR2_Temp right
	rrf	PR2_TEMP_H,F
	rrf	PR2_TEMP,F
;set STATUS.C off
	bcf	STATUS,C
;rotate PR2_Temp right
	rrf	PR2_TEMP_H,F
	rrf	PR2_TEMP,F
;end if
ENDIF11
;IF PR2_Temp_H > 0 then
	movf	PR2_TEMP_H,W
	sublw	0
	btfsc	STATUS, C
	goto	ENDIF12
;T2_PR = 16
	movlw	16
	movwf	T2_PR
;set STATUS.C off
	bcf	STATUS,C
;rotate PR2_Temp right
	rrf	PR2_TEMP_H,F
	rrf	PR2_TEMP,F
;set STATUS.C off
	bcf	STATUS,C
;rotate PR2_Temp right
	rrf	PR2_TEMP_H,F
	rrf	PR2_TEMP,F
;end if
ENDIF12
;PR2 = PR2_Temp
	movf	PR2_TEMP,W
	banksel	PR2
	movwf	PR2
;SET T2CON.T2CKPS0 OFF
	banksel	T2CON
	bcf	T2CON,T2CKPS0
;SET T2CON.T2CKPS1 OFF
	bcf	T2CON,T2CKPS1
;if T2_PR = 4 then SET T2CON.T2CKPS0 ON
	movlw	4
	subwf	T2_PR,W
	btfsc	STATUS, Z
	bsf	T2CON,T2CKPS0
;if T2_PR = 16 then SET T2CON.T2CKPS1 ON
	movlw	16
	subwf	T2_PR,W
	btfsc	STATUS, Z
	bsf	T2CON,T2CKPS1
;SET T2CON.TMR2ON ON
	bsf	T2CON,TMR2ON
;CCPR1L = ([word]PWMDuty * PR2) / 255
	movf	PWMDUTY,W
	movwf	SysCalcTempA
	clrf	SysCalcTempA_H
	banksel	PR2
	movf	PR2,W
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	banksel	STATUS
	call	SysMultSub16
	movf	SysCalcTempX,W
	movwf	SysTemp1
	movf	SysCalcTempX_H,W
	movwf	SysTemp1_H
	movf	SysTemp1,W
	movwf	SysCalcTempA
	movf	SysTemp1_H,W
	movwf	SysCalcTempA_H
	movlw	255
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	CCPR1L
;SET CCP1CON.CCP1M3 ON
	bsf	CCP1CON,CCP1M3
;SET CCP1CON.CCP1M2 ON
	bsf	CCP1CON,CCP1M2
;SET CCP1CON.CCP1M1 OFF
	bcf	CCP1CON,CCP1M1
;SET CCP1CON.CCP1M0 OFF
	bcf	CCP1CON,CCP1M0
	return

;********************************************************************************

INITPWM
;PR2 = PR2Temp
	movlw	52
	banksel	PR2
	movwf	PR2
;SET T2CON.T2CKPS0 OFF
	banksel	T2CON
	bcf	T2CON,T2CKPS0
;SET T2CON.T2CKPS1 OFF
	bcf	T2CON,T2CKPS1
;CCPR1L = DutyCycleH
	movlw	26
	movwf	CCPR1L
;SET CCPCONCache.DC1B1 ON
	bsf	CCPCONCACHE,DC1B1
;SET CCPCONCache.DC1B0 OFF
	bcf	CCPCONCACHE,DC1B0
;SET CCPCONCache.CCP1M3 ON
	bsf	CCPCONCACHE,CCP1M3
;SET CCPCONCache.CCP1M2 ON
	bsf	CCPCONCACHE,CCP1M2
;SET CCPCONCache.CCP1M1 OFF
	bcf	CCPCONCACHE,CCP1M1
;SET CCPCONCache.CCP1M0 OFF
	bcf	CCPCONCACHE,CCP1M0
;SET T2CON.TMR2ON ON
	bsf	T2CON,TMR2ON
	return

;********************************************************************************

INITRANDOM
;Dim RandomSeed As Word
;RandomSeed = RandStart
	movlw	157
	movwf	RANDOMSEED
	movlw	248
	movwf	RANDOMSEED_H
	return

;********************************************************************************

INITSOUND
;dir SoundOut out
	banksel	TRISIO
	bcf	TRISIO,4
	banksel	STATUS
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

FN_RANDOM
;Repeat 7
	movlw	7
	movwf	SysRepeatTemp3
SysRepeatLoop3
;Dim RandomTemp As Word
;Dim RandomSeed As Word
;RandomTemp = RandomSeed
	movf	RANDOMSEED,W
	movwf	RANDOMTEMP
	movf	RANDOMSEED_H,W
	movwf	RANDOMTEMP_H
;Rotate RandomTemp Left Simple
	rlf	RANDOMTEMP_H,W
	rlf	RANDOMTEMP,F
	rlf	RANDOMTEMP_H,F
;RandomSeed = RandomTemp XOR (Not (RandomSeed And 1) + 1 And 0xB400)
	movlw	1
	andwf	RANDOMSEED,W
	movwf	SysTemp1
	clrf	SysTemp1_H
	comf	SysTemp1,W
	movwf	SysTemp2
	comf	SysTemp1_H,W
	movwf	SysTemp2_H
	movlw	1
	addwf	SysTemp2,W
	movwf	SysTemp1
	movf	SysTemp2_H,W
	btfsc	STATUS,C
	addlw	1
	movwf	SysTemp1_H
	clrf	SysTemp2
	movlw	180
	andwf	SysTemp1_H,W
	movwf	SysTemp2_H
	movf	RANDOMTEMP,W
	xorwf	SysTemp2,W
	movwf	RANDOMSEED
	movf	RANDOMTEMP_H,W
	xorwf	SysTemp2_H,W
	movwf	RANDOMSEED_H
;Random = Random Xor RandomSeed_H
	movf	RANDOM,W
	xorwf	RANDOMSEED_H,W
	movwf	RANDOM
;End Repeat
	decfsz	SysRepeatTemp3,F
	goto	SysRepeatLoop3
SysRepeatLoopEnd3
	return

;********************************************************************************

RANDOMIZE
;Dim RandomSeed As Word
;RandomSeed += RandomTemp
	movf	RANDOMTEMP,W
	addwf	RANDOMSEED,F
	movf	RANDOMTEMP_H,W
	btfsc	STATUS,C
	addlw	1
	addwf	RANDOMSEED_H,F
;If RandomSeed = 0 Then RandomSeed = 1
	movf	RANDOMSEED,W
	movwf	SysCalcTempA
	movf	RANDOMSEED_H,W
	movwf	SysCalcTempA_H
	clrf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysCompEqual16
	btfss	SysCalcTempX,0
	goto	ENDIF24
	movlw	1
	movwf	RANDOMSEED
	clrf	RANDOMSEED_H
ENDIF24
	return

;********************************************************************************

SYSCOMPEQUAL16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA, W
	movf	SYSCALCTEMPA, W
;subwf SysCalcTempB, W
	subwf	SYSCALCTEMPB, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;movf SysCalcTempA_H, W
	movf	SYSCALCTEMPA_H, W
;subwf SysCalcTempB_H, W
	subwf	SYSCALCTEMPB_H, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSCOMPLESSTHAN16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA_H,W
	movf	SYSCALCTEMPA_H,W
;subwf SysCalcTempB_H,W
	subwf	SYSCALCTEMPB_H,W
;btfss STATUS,C
	btfss	STATUS,C
;return
	return
;movf SysCalcTempB_H,W
	movf	SYSCALCTEMPB_H,W
;subwf SysCalcTempA_H,W
	subwf	SYSCALCTEMPA_H,W
;btfss STATUS,C
	btfss	STATUS,C
;goto SCLT16True
	goto	SCLT16TRUE
;movf SysCalcTempB,W
	movf	SYSCALCTEMPB,W
;subwf SysCalcTempA,W
	subwf	SYSCALCTEMPA,W
;btfsc STATUS,C
	btfsc	STATUS,C
;return
	return
SCLT16TRUE
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSDIVSUB16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as word
;dim SysDivMultA as word
;dim SysDivMultB as word
;dim SysDivMultX as word
;SysDivMultA = SysCalcTempA
	movf	SYSCALCTEMPA,W
	movwf	SYSDIVMULTA
	movf	SYSCALCTEMPA_H,W
	movwf	SYSDIVMULTA_H
;SysDivMultB = SysCalcTempB
	movf	SYSCALCTEMPB,W
	movwf	SYSDIVMULTB
	movf	SYSCALCTEMPB_H,W
	movwf	SYSDIVMULTB_H
;SysDivMultX = 0
	clrf	SYSDIVMULTX
	clrf	SYSDIVMULTX_H
;if SysDivMultB = 0 then
	movf	SYSDIVMULTB,W
	movwf	SysCalcTempA
	movf	SYSDIVMULTB_H,W
	movwf	SysCalcTempA_H
	clrf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysCompEqual16
	btfss	SysCalcTempX,0
	goto	ENDIF22
;SysCalcTempA = 0
	clrf	SYSCALCTEMPA
	clrf	SYSCALCTEMPA_H
;exit sub
	return
;end if
ENDIF22
;SysDivLoop = 16
	movlw	16
	movwf	SYSDIVLOOP
SYSDIV16START
;set C off
	bcf	STATUS,C
;Rotate SysDivMultA Left
	rlf	SYSDIVMULTA,F
	rlf	SYSDIVMULTA_H,F
;Rotate SysDivMultX Left
	rlf	SYSDIVMULTX,F
	rlf	SYSDIVMULTX_H,F
;SysDivMultX = SysDivMultX - SysDivMultB
	movf	SYSDIVMULTB,W
	subwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfss	STATUS,C
	addlw	1
	subwf	SYSDIVMULTX_H,F
;Set SysDivMultA.0 On
	bsf	SYSDIVMULTA,0
;If C Off Then
	btfsc	STATUS,C
	goto	ENDIF23
;Set SysDivMultA.0 Off
	bcf	SYSDIVMULTA,0
;SysDivMultX = SysDivMultX + SysDivMultB
	movf	SYSDIVMULTB,W
	addwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfsc	STATUS,C
	addlw	1
	addwf	SYSDIVMULTX_H,F
;End If
ENDIF23
;decfsz SysDivLoop, F
	decfsz	SYSDIVLOOP, F
;goto SysDiv16Start
	goto	SYSDIV16START
;SysCalcTempA = SysDivMultA
	movf	SYSDIVMULTA,W
	movwf	SYSCALCTEMPA
	movf	SYSDIVMULTA_H,W
	movwf	SYSCALCTEMPA_H
;SysCalcTempX = SysDivMultX
	movf	SYSDIVMULTX,W
	movwf	SYSCALCTEMPX
	movf	SYSDIVMULTX_H,W
	movwf	SYSCALCTEMPX_H
	return

;********************************************************************************

SYSMULTSUB16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as word
;dim SysDivMultA as word
;dim SysDivMultB as word
;dim SysDivMultX as word
;SysDivMultA = SysCalcTempA
	movf	SYSCALCTEMPA,W
	movwf	SYSDIVMULTA
	movf	SYSCALCTEMPA_H,W
	movwf	SYSDIVMULTA_H
;SysDivMultB = SysCalcTempB
	movf	SYSCALCTEMPB,W
	movwf	SYSDIVMULTB
	movf	SYSCALCTEMPB_H,W
	movwf	SYSDIVMULTB_H
;SysDivMultX = 0
	clrf	SYSDIVMULTX
	clrf	SYSDIVMULTX_H
MUL16LOOP
;IF SysDivMultB.0 ON then SysDivMultX += SysDivMultA
	btfss	SYSDIVMULTB,0
	goto	ENDIF20
	movf	SYSDIVMULTA,W
	addwf	SYSDIVMULTX,F
	movf	SYSDIVMULTA_H,W
	btfsc	STATUS,C
	addlw	1
	addwf	SYSDIVMULTX_H,F
ENDIF20
;set STATUS.C OFF
	bcf	STATUS,C
;rotate SysDivMultB right
	rrf	SYSDIVMULTB_H,F
	rrf	SYSDIVMULTB,F
;set STATUS.C off
	bcf	STATUS,C
;rotate SysDivMultA left
	rlf	SYSDIVMULTA,F
	rlf	SYSDIVMULTA_H,F
;if SysDivMultB > 0 then goto MUL16LOOP
	movf	SYSDIVMULTB,W
	movwf	SysCalcTempB
	movf	SYSDIVMULTB_H,W
	movwf	SysCalcTempB_H
	clrf	SysCalcTempA
	clrf	SysCalcTempA_H
	call	SysCompLessThan16
	btfsc	SysCalcTempX,0
	goto	MUL16LOOP
;SysCalcTempX = SysDivMultX
	movf	SYSDIVMULTX,W
	movwf	SYSCALCTEMPX
	movf	SYSDIVMULTX_H,W
	movwf	SYSCALCTEMPX_H
	return

;********************************************************************************

TONE
;dim ToneLoop as word
;dim ToneLoop2 as word
;If ToneFrequency = 0 Then Exit Sub
	movf	TONEFREQUENCY,W
	movwf	SysCalcTempA
	movf	TONEFREQUENCY_H,W
	movwf	SysCalcTempA_H
	clrf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysCompEqual16
	btfsc	SysCalcTempX,0
	return
;TonePeriod = 50000 / ToneFrequency
	movlw	80
	movwf	SysCalcTempA
	movlw	195
	movwf	SysCalcTempA_H
	movf	TONEFREQUENCY,W
	movwf	SysCalcTempB
	movf	TONEFREQUENCY_H,W
	movwf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	TONEPERIOD
;ToneFrequency = ToneFrequency / 100
	movf	TONEFREQUENCY,W
	movwf	SysCalcTempA
	movf	TONEFREQUENCY_H,W
	movwf	SysCalcTempA_H
	movlw	100
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	TONEFREQUENCY
	movf	SysCalcTempA_H,W
	movwf	TONEFREQUENCY_H
;For ToneLoop = 1 to ToneDuration
	clrf	TONELOOP
	clrf	TONELOOP_H
	movlw	1
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	movf	TONEDURATION,W
	movwf	SysCalcTempA
	movf	TONEDURATION_H,W
	movwf	SysCalcTempA_H
	call	SysCompLessThan16
	btfsc	SysCalcTempX,0
	goto	SysForLoopEnd2
SysForLoop2
	movlw	1
	addwf	TONELOOP,F
	movf	TONELOOP_H,W
	btfsc	STATUS,C
	addlw	1
	movwf	TONELOOP_H
;For ToneLoop2 = 1 to ToneFrequency
	clrf	TONELOOP2
	clrf	TONELOOP2_H
	movlw	1
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	movf	TONEFREQUENCY,W
	movwf	SysCalcTempA
	movf	TONEFREQUENCY_H,W
	movwf	SysCalcTempA_H
	call	SysCompLessThan16
	btfsc	SysCalcTempX,0
	goto	SysForLoopEnd3
SysForLoop3
	movlw	1
	addwf	TONELOOP2,F
	movf	TONELOOP2_H,W
	btfsc	STATUS,C
	addlw	1
	movwf	TONELOOP2_H
;Set SoundOut ON
	bsf	GPIO,4
;SysToneDelay
	movf	TONEPERIOD,W
	movwf	SysWaitTemp10US
	call	Delay_10US
;Set SoundOut OFF
	bcf	GPIO,4
;SysToneDelay
	movf	TONEPERIOD,W
	movwf	SysWaitTemp10US
	call	Delay_10US
;Next
	movf	TONELOOP2,W
	movwf	SysCalcTempA
	movf	TONELOOP2_H,W
	movwf	SysCalcTempA_H
	movf	TONEFREQUENCY,W
	movwf	SysCalcTempB
	movf	TONEFREQUENCY_H,W
	movwf	SysCalcTempB_H
	call	SysCompLessThan16
	btfsc	SysCalcTempX,0
	goto	SysForLoop3
SysForLoopEnd3
;Next
	movf	TONELOOP,W
	movwf	SysCalcTempA
	movf	TONELOOP_H,W
	movwf	SysCalcTempA_H
	movf	TONEDURATION,W
	movwf	SysCalcTempB
	movf	TONEDURATION_H,W
	movwf	SysCalcTempB_H
	call	SysCompLessThan16
	btfsc	SysCalcTempX,0
	goto	SysForLoop2
SysForLoopEnd2
	return

;********************************************************************************


 END
