;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
SysWaitTemp10US	EQU	117
COUNT	EQU	32
COUNT_H	EQU	33
I	EQU	34
PERIOD	EQU	35
SysRepeatTemp1	EQU	36
TEMPO	EQU	37

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;This experiment creates a ring modulator effect on
;the buzzer. It is very piercing and very annoying,
;good for attention-getting. Connect GP0 to the buzzer.
;----- Settings
;----- Constants
;#define SOUNDOUT GPIO.0				;buzzer on pin 7
;----- Variables
;dim tempo, i, period as byte
;dim count as word				
;----- Program
;dir SOUNDOUT out											;set as output
	banksel	TRISIO
	bcf	TRISIO,0
;do
SysDoLoop_S1
;for period = 88 to 11 step -1   		;sweep modulation up     		
	movlw	89
	banksel	PERIOD
	movwf	PERIOD
SysForLoop1
	decf	PERIOD,F
;repeat 20											
	movlw	20
	movwf	SysRepeatTemp1
SysRepeatLoop1
;pulseOut SOUNDOUT, period 10us	
;Set Pin On
	bsf	GPIO,0
;Wait Time
	movf	PERIOD,W
	movwf	SysWaitTemp10US
	call	Delay_10US
;Set Pin Off
	bcf	GPIO,0
;wait period 10us								
	movf	PERIOD,W
	movwf	SysWaitTemp10US
	call	Delay_10US
;end repeat
	decfsz	SysRepeatTemp1,F
	goto	SysRepeatLoop1
SysRepeatLoopEnd1
;next period		
	movf	PERIOD,W
	sublw	11
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
;for period = 11 to 88          			;sweep down
	movlw	10
	movwf	PERIOD
SysForLoop2
	incf	PERIOD,F
;repeat 20											
	movlw	20
	movwf	SysRepeatTemp1
SysRepeatLoop2
;pulseOut SOUNDOUT, period 10us	
;Set Pin On
	bsf	GPIO,0
;Wait Time
	movf	PERIOD,W
	movwf	SysWaitTemp10US
	call	Delay_10US
;Set Pin Off
	bcf	GPIO,0
;wait period 10us								
	movf	PERIOD,W
	movwf	SysWaitTemp10US
	call	Delay_10US
;end repeat
	decfsz	SysRepeatTemp1,F
	goto	SysRepeatLoop2
SysRepeatLoopEnd2
;next period					
	movlw	88
	subwf	PERIOD,W
	btfss	STATUS, C
	goto	SysForLoop2
SysForLoopEnd2
;loop		
	goto	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_10US
D10US_START
	movlw	5
	movwf	DELAYTEMP
DelayUS0
	decfsz	DELAYTEMP,F
	goto	DelayUS0
	nop
	decfsz	SysWaitTemp10US, F
	goto	D10US_START
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************


 END
