;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
DELAYTEMP2	EQU	113
SYSDIVMULTA	EQU	119
SYSDIVMULTA_H	EQU	120
SYSDIVMULTB	EQU	123
SYSDIVMULTB_H	EQU	124
SYSDIVMULTX	EQU	114
SYSDIVMULTX_H	EQU	115
SysCalcTempA	EQU	117
SysCalcTempA_H	EQU	118
SysCalcTempB	EQU	121
SysCalcTempB_H	EQU	122
SysCalcTempX	EQU	112
SysCalcTempX_H	EQU	113
SysDivLoop	EQU	116
SysWaitTemp10MS	EQU	116
SysWaitTemp10US	EQU	117
SysWaitTempMS	EQU	114
SysWaitTempMS_H	EQU	115
SysWaitTempUS	EQU	117
SysWaitTempUS_H	EQU	118
BUFFER	EQU	79
CHAR	EQU	32
COUNT	EQU	33
I	EQU	34
J	EQU	35
LENGTH	EQU	36
MORSE	EQU	37
RXHIGHCOUNT	EQU	38
SERBIT	EQU	39
SERBITSAMPLE	EQU	40
SERDELAYLOOP	EQU	41
SERQUICKSAMPLE	EQU	42
SERTEMP	EQU	43
SER_BYTE	EQU	44
SER_DATA	EQU	45
SER_DATA_A	EQU	46
SER_INVERT	EQU	47
SER_INVERT_A	EQU	48
SER_PARITY	EQU	49
SER_PARITY_A	EQU	50
SER_RATE	EQU	51
SER_RATE_A	EQU	52
SER_SELECT	EQU	53
SER_SELECT_OLD	EQU	54
SER_START	EQU	55
SER_START_A	EQU	56
SER_STOP	EQU	57
SER_STOP_A	EQU	58
SysTemp1	EQU	59
SysTemp1_H	EQU	60
SysTemp2	EQU	61
TEMPPARITY	EQU	62
TONEDURATION	EQU	63
TONEDURATION_H	EQU	64
TONEFREQUENCY	EQU	65
TONEFREQUENCY_H	EQU	66
TONELOOP	EQU	67
TONELOOP_H	EQU	68
TONELOOP2	EQU	69
TONELOOP2_H	EQU	70
TONEPERIOD	EQU	71

;********************************************************************************

;Alias variables
EEAddress	EQU	EEADR
EEDataValue	EQU	EEDATA

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS
	call	INITSOUND

;Start of the main program
;Convert messages typed in from a keyboard to Morse code.
;Connect GP0 to the piezo. Alternatively, you could connect
;GP0 to the line output and drive an external speaker or
;amplifier and then use the volume control to tame things
;as required. The buzzer also works well. Connect GP1 to Rx
;and GP2 to Tx. Connect a PC to the DB-9. Use a USB-to-COM
;adapter if needed. Test the unit with any terminal program.
;Feel free to change the constant RATE for faster/slower practice.
;Note how codes are stored in EEPROM.
;----- Settings
;----- Constants
;#define SoundOut GPIO.0					;piezo on pin 7
;#define SerInPort	GPIO.1				;Rx input on pin 6
;#define SerOutPort GPIO.2				;Tx output on pin 5
;#define Hertz 750								;tone frequency
;#define rate 24									;rate in tens of milliseconds
;#define little rate/6						;little delay in tens of mS
;#define big rate-little					;big delay in tens of mS			
;#define SendAHigh Set SerOutPort  on  ;output logic levels
;#define SendALow  Set SerOutPort  off
;#define RecAHigh  SerInPort       on  ;input logic levels
;#define RecALow   SerInPort       off
;#define back 8									;backspace character
;#define cr 13										;carriage return
;#define lf 10										;line feed
;#define esc 27									;escape character
;#define space 32								;space character
;----- Variables
;dim char, count, i, j, length, morse as byte						
;dim buffer(32)									;message buffer
;----- EEPROM Table of Codes
;Bits b7, b6 and b5 give the length of the code.
;Bits b4, b3, b2, b1 and b0 give the code in
;reverse order.
;----- Program
;dir GPIO 0b00001010						;two outputs, one input
	movlw	10
	banksel	TRISIO
	movwf	TRISIO
;InitSer 1, r4800, 1+WaitForStart, 8, 1, none, invert
	movlw	1
	banksel	SER_SELECT
	movwf	SER_SELECT
	movlw	4
	movwf	SER_RATE
	movlw	129
	movwf	SER_START
	movlw	8
	movwf	SER_DATA
	movlw	1
	movwf	SER_STOP
	clrf	SER_PARITY
	movlw	1
	movwf	SER_INVERT
	call	INITSER
;count = 0											;number chars in the buffer
	clrf	COUNT
MAIN
;	SerReceive 1, char	    		;get character from terminal
	movlw	1
	movwf	SER_SELECT
	call	SERRECEIVE
	movf	SER_BYTE,W
	movwf	CHAR
;select case char
SysSelect1Case1
	movlw	32
	subwf	CHAR,W
	btfss	STATUS, Z
	goto	SysSelect1Case2

;goto good
	goto	GOOD
	goto	SysSelectEnd1
SysSelect1Case2
	movlw	13
	subwf	CHAR,W
	btfss	STATUS, Z
	goto	SysSelect1Case3

;sendMorse
	call	SENDMORSE
;goto main
	goto	MAIN
;case esc									;escape to dump buffer
	goto	SysSelectEnd1
SysSelect1Case3
	movlw	27
	subwf	CHAR,W
	btfss	STATUS, Z
	goto	SysSelect1Case4
;count = 0
	clrf	COUNT
;goto main
	goto	MAIN
;case back									;backspace to rub out previous
	goto	SysSelectEnd1
SysSelect1Case4
	movlw	8
	subwf	CHAR,W
	btfss	STATUS, Z
	goto	SysSelect1Case5
;if count <> 0 then
	movf	COUNT,F
	btfss	STATUS, Z
;count -= 1
	decf	COUNT,F
;end if
;goto main
	goto	MAIN
;end select
SysSelect1Case5
SysSelectEnd1
;if char > 47 and char < 58 then	;a digit
	movf	CHAR,W
	movwf	SysCalcTempB
	movlw	47
	movwf	SysCalcTempA
	call	SysCompLessThan
	movf	SysCalcTempX,W
	movwf	SysTemp1
	movf	CHAR,W
	movwf	SysCalcTempA
	movlw	58
	movwf	SysCalcTempB
	call	SysCompLessThan
	movf	SysTemp1,W
	andwf	SysCalcTempX,W
	movwf	SysTemp2
	btfsc	SysTemp2,0
;goto good
	goto	GOOD
;end if
;if char > 64 and char < 91 then	;uppercase letter
	movf	CHAR,W
	movwf	SysCalcTempB
	movlw	64
	movwf	SysCalcTempA
	call	SysCompLessThan
	movf	SysCalcTempX,W
	movwf	SysTemp1
	movf	CHAR,W
	movwf	SysCalcTempA
	movlw	91
	movwf	SysCalcTempB
	call	SysCompLessThan
	movf	SysTemp1,W
	andwf	SysCalcTempX,W
	movwf	SysTemp2
	btfsc	SysTemp2,0
;goto good
	goto	GOOD
;end if
;if char > 96 and char < 123 then	;convert lower to upper
	movf	CHAR,W
	movwf	SysCalcTempB
	movlw	96
	movwf	SysCalcTempA
	call	SysCompLessThan
	movf	SysCalcTempX,W
	movwf	SysTemp1
	movf	CHAR,W
	movwf	SysCalcTempA
	movlw	123
	movwf	SysCalcTempB
	call	SysCompLessThan
	movf	SysTemp1,W
	andwf	SysCalcTempX,W
	movwf	SysTemp2
	btfss	SysTemp2,0
	goto	ENDIF4
;char -= 32 								
	movlw	32
	subwf	CHAR,F
;goto good
	goto	GOOD
;end if
ENDIF4
;goto main 								;all others ignored
	goto	MAIN
GOOD
;count = count +1					;now add character to buffer
	incf	COUNT,F
;buffer(count) = char
	movlw	low(BUFFER)
	addwf	COUNT,W
	movwf	FSR
	movf	CHAR,W
	movwf	INDF
;goto Main											;repeat in perpetuity
	goto	MAIN
;----- Subroutines
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_10MS
D10MS_START
	movlw	10
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
	decfsz	SysWaitTemp10MS, F
	goto	D10MS_START
	return

;********************************************************************************

Delay_10US
D10US_START
	movlw	5
	movwf	DELAYTEMP
DelayUS0
	decfsz	DELAYTEMP,F
	goto	DelayUS0
	nop
	decfsz	SysWaitTemp10US, F
	goto	D10US_START
	return

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	4
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	165
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

INITSER
;Ser_Select_Old = Ser_Select
	movf	SER_SELECT,W
	movwf	SER_SELECT_OLD
;if Ser_Select = 1 THEN
	decf	SER_SELECT,W
	btfss	STATUS, Z
	goto	ENDIF12
;Ser_Rate_A = Ser_Rate
	movf	SER_RATE,W
	movwf	SER_RATE_A
;Ser_Start_A = Ser_Start
	movf	SER_START,W
	movwf	SER_START_A
;Ser_Data_A = Ser_Data
	movf	SER_DATA,W
	movwf	SER_DATA_A
;Ser_Stop_A = Ser_Stop
	movf	SER_STOP,W
	movwf	SER_STOP_A
;Ser_Parity_A = Ser_Parity
	movf	SER_PARITY,W
	movwf	SER_PARITY_A
;Ser_Invert_A = Ser_Invert
	movf	SER_INVERT,W
	movwf	SER_INVERT_A
;END IF
ENDIF12
	return

;********************************************************************************

INITSOUND
;dir SoundOut out
	banksel	TRISIO
	bcf	TRISIO,0
	banksel	STATUS
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

SENDMORSE
;for i = 1 to count					;this many chars in buffer
	clrf	I
	movlw	1
	subwf	COUNT,W
	btfss	STATUS, C
	goto	SysForLoopEnd1
SysForLoop1
	incf	I,F
;char = buffer(i)					;fetch the next one
	movlw	low(BUFFER)
	addwf	I,W
	movwf	FSR
	movf	INDF,W
	movwf	CHAR
;if char = space then			;just pause regular time
	movlw	32
	subwf	CHAR,W
	btfss	STATUS, Z
	goto	ENDIF6
;wait rate 10mS
	movlw	24
	movwf	SysWaitTemp10MS
	call	Delay_10MS
;goto done
	goto	DONE
;end if	
ENDIF6
;if char < 58 then					;it's a digit
	movlw	58
	subwf	CHAR,W
	btfsc	STATUS, C
	goto	ELSE7_1
;char -= 47							;index into table
	movlw	47
	subwf	CHAR,F
;goto lookUp
	goto	LOOKUP
;else
	goto	ENDIF7
ELSE7_1
;char -= 54							;else a letter
	movlw	54
	subwf	CHAR,F
;end if	
ENDIF7
LOOKUP
;	readTable eeprom, char, morse
	movlw	low(TableEEPROM)
	addwf	CHAR,W
	banksel	EEAddress
	movwf	EEAddress
	banksel	STATUS
	call	SysEPRead
	banksel	EEDataValue
	movf	EEDataValue,W
	banksel	MORSE
	movwf	MORSE
;	length = morse / 32			;length of the code
	movwf	SysCalcTempA
	movlw	32
	movwf	SysCalcTempB
	call	SysDivSub
	movf	SysCalcTempA,W
	movwf	LENGTH
;	for j = 1 to length
	clrf	J
	movlw	1
	subwf	LENGTH,W
	btfss	STATUS, C
	goto	SysForLoopEnd2
SysForLoop2
	incf	J,F
;		rotate morse right
	rrf	MORSE,F
;		if status.c then			;a dash
	btfss	STATUS,C
	goto	ELSE9_1
;			tone Hertz, big
	movlw	238
	movwf	TONEFREQUENCY
	movlw	2
	movwf	TONEFREQUENCY_H
	movlw	20
	movwf	TONEDURATION
	clrf	TONEDURATION_H
	call	TONE
;			wait little 10mS
	movlw	4
	movwf	SysWaitTemp10MS
	call	Delay_10MS
;		else
	goto	ENDIF9
ELSE9_1
;			tone Hertz, little	;a dot
	movlw	238
	movwf	TONEFREQUENCY
	movlw	2
	movwf	TONEFREQUENCY_H
	movlw	4
	movwf	TONEDURATION
	clrf	TONEDURATION_H
	call	TONE
;			wait big 10mS
	movlw	20
	movwf	SysWaitTemp10MS
	call	Delay_10MS
;		end if
ENDIF9
;	next j
	movf	LENGTH,W
	subwf	J,W
	btfss	STATUS, C
	goto	SysForLoop2
SysForLoopEnd2
DONE
;next i
	movf	COUNT,W
	subwf	I,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
;count = 0	
	clrf	COUNT
	return

;********************************************************************************

SERCFGLOAD
;Ser_Select_Old = Ser_Select
	movf	SER_SELECT,W
	movwf	SER_SELECT_OLD
;if Ser_Select = 1 THEN
	decf	SER_SELECT,W
	btfss	STATUS, Z
	goto	ENDIF31
;Ser_Rate = Ser_Rate_A
	movf	SER_RATE_A,W
	movwf	SER_RATE
;Ser_Start = Ser_Start_A
	movf	SER_START_A,W
	movwf	SER_START
;Ser_Data = Ser_Data_A
	movf	SER_DATA_A,W
	movwf	SER_DATA
;Ser_Stop = Ser_Stop_A
	movf	SER_STOP_A,W
	movwf	SER_STOP
;Ser_Parity = Ser_Parity_A
	movf	SER_PARITY_A,W
	movwf	SER_PARITY
;Ser_Invert = Ser_Invert_A
	movf	SER_INVERT_A,W
	movwf	SER_INVERT
;end if
ENDIF31
	return

;********************************************************************************

FN_SERQUICKSAMPLE
;SerQuickSample = FALSE
	clrf	SERQUICKSAMPLE
;if Ser_Select = 1 THEN
	decf	SER_SELECT,W
	btfss	STATUS, Z
	goto	ENDIF29
;if RecAHigh then SerQuickSample = TRUE
	btfss	GPIO,1
	goto	ENDIF30
	movlw	255
	movwf	SERQUICKSAMPLE
ENDIF30
;end if
ENDIF29
	return

;********************************************************************************

SERRECEIVE
;if Ser_Select <> Ser_Select_Old then SerCfgLoad(Ser_Select)
	movf	SER_SELECT_OLD,W
	subwf	SER_SELECT,W
	btfss	STATUS, Z
	call	SERCFGLOAD
;If Ser_Start.7 = On Then
	btfss	SER_START,7
	goto	ELSE14_1
;Wait Until SerQuickSample = TRUE
SysWaitLoop1
	call	FN_SERQUICKSAMPLE
	incf	SERQUICKSAMPLE,W
	btfss	STATUS, Z
	goto	SysWaitLoop1
;Else
	goto	ENDIF14
ELSE14_1
;If SerQuickSample = False Then Exit Sub
	call	FN_SERQUICKSAMPLE
	movf	SERQUICKSAMPLE,F
	btfsc	STATUS, Z
	return
;End If
ENDIF14
;IntOff
;SerTemp = Ser_Start and (not WaitForStart)
	movlw	127
	andwf	SER_START,W
	movwf	SERTEMP
;for SerBit = 1 to SerTemp
	clrf	SERBIT
	movlw	1
	subwf	SERTEMP,W
	btfss	STATUS, C
	goto	SysForLoopEnd3
SysForLoop3
	incf	SERBIT,F
;SerRxBit
	call	SERRXBIT
;next
	movf	SERTEMP,W
	subwf	SERBIT,W
	btfss	STATUS, C
	goto	SysForLoop3
SysForLoopEnd3
;Ser_Byte = 0
	clrf	SER_BYTE
;for SerBit = 1 to Ser_Data
	clrf	SERBIT
	movlw	1
	subwf	SER_DATA,W
	btfss	STATUS, C
	goto	SysForLoopEnd4
SysForLoop4
	incf	SERBIT,F
;SerRxBit
	call	SERRXBIT
;Rotate Ser_Byte Right
	rrf	SER_BYTE,F
;next
	movf	SER_DATA,W
	subwf	SERBIT,W
	btfss	STATUS, C
	goto	SysForLoop4
SysForLoopEnd4
;if Ser_Data < 8 then
	movlw	8
	subwf	SER_DATA,W
	btfsc	STATUS, C
	goto	ENDIF19
;for SerBit = Ser_Data to 8
	decf	SER_DATA,W
	movwf	SERBIT
	movf	SER_DATA,W
	sublw	8
	btfss	STATUS, C
	goto	SysForLoopEnd5
SysForLoop5
	incf	SERBIT,F
;Set C Off
	bcf	STATUS,C
;ROTATE Ser_Byte RIGHT
	rrf	SER_BYTE,F
;next
	movlw	8
	subwf	SERBIT,W
	btfss	STATUS, C
	goto	SysForLoop5
SysForLoopEnd5
;end if
ENDIF19
;if Ser_Invert = invert then Ser_Byte = !Ser_Byte
	decf	SER_INVERT,W
	btfsc	STATUS, Z
	comf	SER_BYTE,F
;if Ser_Parity <> 0 THEN
	movf	SER_PARITY,F
	btfsc	STATUS, Z
	goto	ENDIF21
;TempParity = 0
	clrf	TEMPPARITY
;SerRxBit
	call	SERRXBIT
;end if
ENDIF21
;Wait Until SerQuickSample = FALSE
SysWaitLoop2
	call	FN_SERQUICKSAMPLE
	movf	SERQUICKSAMPLE,F
	btfss	STATUS, Z
	goto	SysWaitLoop2
;IntOn
	return

;********************************************************************************

SERRXBIT
;RxHighCount = 0
	clrf	RXHIGHCOUNT
;if Ser_Select = 1 THEN
	decf	SER_SELECT,W
	btfss	STATUS, Z
	goto	ENDIF25
;for SerBitSample = 1 to 3
	clrf	SERBITSAMPLE
SysForLoop6
	incf	SERBITSAMPLE,F
;if RecAHigh then RxHighCount = RxHighCount + 1
	btfsc	GPIO,1
	incf	RXHIGHCOUNT,F
;SerThirdBitDelay
	call	SERTHIRDBITDELAY
;next
	movlw	3
	subwf	SERBITSAMPLE,W
	btfss	STATUS, C
	goto	SysForLoop6
SysForLoopEnd6
;end if
ENDIF25
;SET C OFF
	bcf	STATUS,C
;If RxHighCount.1 = ON Then SET C ON
	btfsc	RXHIGHCOUNT,1
	bsf	STATUS,C
	return

;********************************************************************************

SERTHIRDBITDELAY
;if Ser_Rate = 1 then Wait SerThirdDelay19200 us: exit sub	'19200 (17 us)
	decf	SER_RATE,W
	btfsc	STATUS, Z
	return
;if Ser_Rate = 2 then Wait SerThirdDelay9600 us: exit sub 	'9600 (35 us)
	movlw	2
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF33
	movlw	11
	movwf	DELAYTEMP
DelayUS1
	decfsz	DELAYTEMP,F
	goto	DelayUS1
	return
ENDIF33
;if Ser_Rate = 4 then Wait SerThirdDelay4800 us: exit sub 	'4800 (69 us)
	movlw	4
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF34
	movlw	34
	movwf	DELAYTEMP
DelayUS2
	decfsz	DELAYTEMP,F
	goto	DelayUS2
	return
ENDIF34
;if Ser_Rate = 8 then Wait SerThirdDelay2400 us: exit sub 	'2400 (139 us)
	movlw	8
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF35
	movlw	80
	movwf	DELAYTEMP
DelayUS3
	decfsz	DELAYTEMP,F
	goto	DelayUS3
	nop
	return
ENDIF35
;if Ser_Rate = 16 then Wait SerThirdDelay1200 us: exit sub 	'1200 (278 us)
	movlw	16
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF36
	movlw	173
	movwf	DELAYTEMP
DelayUS4
	decfsz	DELAYTEMP,F
	goto	DelayUS4
	return
ENDIF36
;if Ser_Rate = 32 then Wait SerThirdDelay600 us: exit sub 	'600 (555 us)
	movlw	32
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF37
	movlw	1
	movwf	DELAYTEMP2
DelayUSO5
	clrf	DELAYTEMP
DelayUS5
	decfsz	DELAYTEMP,F
	goto	DelayUS5
	decfsz	DELAYTEMP2,F
	goto	DelayUSO5
	movlw	100
	movwf	DELAYTEMP
DelayUS6
	decfsz	DELAYTEMP,F
	goto	DelayUS6
	nop
	return
ENDIF37
;if Ser_Rate = 64 then Wait SerThirdDelay300 us: exit sub	'300 (1111 us)
	movlw	64
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF38
	movlw	2
	movwf	DELAYTEMP2
DelayUSO7
	clrf	DELAYTEMP
DelayUS7
	decfsz	DELAYTEMP,F
	goto	DelayUS7
	decfsz	DELAYTEMP2,F
	goto	DelayUSO7
	movlw	214
	movwf	DELAYTEMP
DelayUS8
	decfsz	DELAYTEMP,F
	goto	DelayUS8
	return
ENDIF38
;for SerDelayLoop = 1 to Ser_Rate
	clrf	SERDELAYLOOP
	movlw	1
	subwf	SER_RATE,W
	btfss	STATUS, C
	goto	SysForLoopEnd7
SysForLoop7
	incf	SERDELAYLOOP,F
;Wait 13 us
	movlw	8
	movwf	DELAYTEMP
DelayUS9
	decfsz	DELAYTEMP,F
	goto	DelayUS9
	nop
;next
	movf	SER_RATE,W
	subwf	SERDELAYLOOP,W
	btfss	STATUS, C
	goto	SysForLoop7
SysForLoopEnd7
	return

;********************************************************************************

SYSCOMPEQUAL16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA, W
	movf	SYSCALCTEMPA, W
;subwf SysCalcTempB, W
	subwf	SYSCALCTEMPB, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;movf SysCalcTempA_H, W
	movf	SYSCALCTEMPA_H, W
;subwf SysCalcTempB_H, W
	subwf	SYSCALCTEMPB_H, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSCOMPLESSTHAN
;Dim SysCalcTempA, SysCalcTempB, SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;bsf STATUS, C
	bsf	STATUS, C
;movf SysCalcTempB, W
	movf	SYSCALCTEMPB, W
;subwf SysCalcTempA, W
	subwf	SYSCALCTEMPA, W
;btfss STATUS, C
	btfss	STATUS, C
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSCOMPLESSTHAN16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA_H,W
	movf	SYSCALCTEMPA_H,W
;subwf SysCalcTempB_H,W
	subwf	SYSCALCTEMPB_H,W
;btfss STATUS,C
	btfss	STATUS,C
;return
	return
;movf SysCalcTempB_H,W
	movf	SYSCALCTEMPB_H,W
;subwf SysCalcTempA_H,W
	subwf	SYSCALCTEMPA_H,W
;btfss STATUS,C
	btfss	STATUS,C
;goto SCLT16True
	goto	SCLT16TRUE
;movf SysCalcTempB,W
	movf	SYSCALCTEMPB,W
;subwf SysCalcTempA,W
	subwf	SYSCALCTEMPA,W
;btfsc STATUS,C
	btfsc	STATUS,C
;return
	return
SCLT16TRUE
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSDIVSUB
;dim SysCalcTempA as byte
;dim SysCalcTempB as byte
;dim SysCalcTempX as byte
;SysCalcTempX = 0
	clrf	SYSCALCTEMPX
;SysDivLoop = 8
	movlw	8
	movwf	SYSDIVLOOP
SYSDIV8START
;bcf STATUS, C
	bcf	STATUS, C
;rlf SysCalcTempA, F
	rlf	SYSCALCTEMPA, F
;rlf SysCalcTempX, F
	rlf	SYSCALCTEMPX, F
;movf SysCalcTempB, W
	movf	SYSCALCTEMPB, W
;subwf SysCalcTempX, F
	subwf	SYSCALCTEMPX, F
;bsf SysCalcTempA, 0
	bsf	SYSCALCTEMPA, 0
;btfsc STATUS, C
	btfsc	STATUS, C
;goto Div8NotNeg
	goto	DIV8NOTNEG
;bcf SysCalcTempA, 0
	bcf	SYSCALCTEMPA, 0
;movf SysCalcTempB, W
	movf	SYSCALCTEMPB, W
;addwf SysCalcTempX, F
	addwf	SYSCALCTEMPX, F
DIV8NOTNEG
;decfsz SysDivLoop, F
	decfsz	SYSDIVLOOP, F
;goto SysDiv8Start
	goto	SYSDIV8START
	return

;********************************************************************************

SYSDIVSUB16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as word
;dim SysDivMultA as word
;dim SysDivMultB as word
;dim SysDivMultX as word
;SysDivMultA = SysCalcTempA
	movf	SYSCALCTEMPA,W
	movwf	SYSDIVMULTA
	movf	SYSCALCTEMPA_H,W
	movwf	SYSDIVMULTA_H
;SysDivMultB = SysCalcTempB
	movf	SYSCALCTEMPB,W
	movwf	SYSDIVMULTB
	movf	SYSCALCTEMPB_H,W
	movwf	SYSDIVMULTB_H
;SysDivMultX = 0
	clrf	SYSDIVMULTX
	clrf	SYSDIVMULTX_H
;if SysDivMultB = 0 then
	movf	SYSDIVMULTB,W
	movwf	SysCalcTempA
	movf	SYSDIVMULTB_H,W
	movwf	SysCalcTempA_H
	clrf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysCompEqual16
	btfss	SysCalcTempX,0
	goto	ENDIF46
;SysCalcTempA = 0
	clrf	SYSCALCTEMPA
	clrf	SYSCALCTEMPA_H
;exit sub
	return
;end if
ENDIF46
;SysDivLoop = 16
	movlw	16
	movwf	SYSDIVLOOP
SYSDIV16START
;set C off
	bcf	STATUS,C
;Rotate SysDivMultA Left
	rlf	SYSDIVMULTA,F
	rlf	SYSDIVMULTA_H,F
;Rotate SysDivMultX Left
	rlf	SYSDIVMULTX,F
	rlf	SYSDIVMULTX_H,F
;SysDivMultX = SysDivMultX - SysDivMultB
	movf	SYSDIVMULTB,W
	subwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfss	STATUS,C
	addlw	1
	subwf	SYSDIVMULTX_H,F
;Set SysDivMultA.0 On
	bsf	SYSDIVMULTA,0
;If C Off Then
	btfsc	STATUS,C
	goto	ENDIF47
;Set SysDivMultA.0 Off
	bcf	SYSDIVMULTA,0
;SysDivMultX = SysDivMultX + SysDivMultB
	movf	SYSDIVMULTB,W
	addwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfsc	STATUS,C
	addlw	1
	addwf	SYSDIVMULTX_H,F
;End If
ENDIF47
;decfsz SysDivLoop, F
	decfsz	SYSDIVLOOP, F
;goto SysDiv16Start
	goto	SYSDIV16START
;SysCalcTempA = SysDivMultA
	movf	SYSDIVMULTA,W
	movwf	SYSCALCTEMPA
	movf	SYSDIVMULTA_H,W
	movwf	SYSCALCTEMPA_H
;SysCalcTempX = SysDivMultX
	movf	SYSDIVMULTX,W
	movwf	SYSCALCTEMPX
	movf	SYSDIVMULTX_H,W
	movwf	SYSCALCTEMPX_H
	return

;********************************************************************************

SYSEPREAD
;Dim EEAddress Alias EEADR
;Dim EEDataValue Alias EEDATA
;IntOff
;SET EECON1.RD ON
	banksel	EECON1
	bsf	EECON1,RD
;IntOn
	banksel	STATUS
	return

;********************************************************************************

TONE
;dim ToneLoop as word
;dim ToneLoop2 as word
;If ToneFrequency = 0 Then Exit Sub
	movf	TONEFREQUENCY,W
	movwf	SysCalcTempA
	movf	TONEFREQUENCY_H,W
	movwf	SysCalcTempA_H
	clrf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysCompEqual16
	btfsc	SysCalcTempX,0
	return
;TonePeriod = 50000 / ToneFrequency
	movlw	80
	movwf	SysCalcTempA
	movlw	195
	movwf	SysCalcTempA_H
	movf	TONEFREQUENCY,W
	movwf	SysCalcTempB
	movf	TONEFREQUENCY_H,W
	movwf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	TONEPERIOD
;ToneFrequency = ToneFrequency / 100
	movf	TONEFREQUENCY,W
	movwf	SysCalcTempA
	movf	TONEFREQUENCY_H,W
	movwf	SysCalcTempA_H
	movlw	100
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	call	SysDivSub16
	movf	SysCalcTempA,W
	movwf	TONEFREQUENCY
	movf	SysCalcTempA_H,W
	movwf	TONEFREQUENCY_H
;For ToneLoop = 1 to ToneDuration
	clrf	TONELOOP
	clrf	TONELOOP_H
	movlw	1
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	movf	TONEDURATION,W
	movwf	SysCalcTempA
	movf	TONEDURATION_H,W
	movwf	SysCalcTempA_H
	call	SysCompLessThan16
	btfsc	SysCalcTempX,0
	goto	SysForLoopEnd8
SysForLoop8
	movlw	1
	addwf	TONELOOP,F
	movf	TONELOOP_H,W
	btfsc	STATUS,C
	addlw	1
	movwf	TONELOOP_H
;For ToneLoop2 = 1 to ToneFrequency
	clrf	TONELOOP2
	clrf	TONELOOP2_H
	movlw	1
	movwf	SysCalcTempB
	clrf	SysCalcTempB_H
	movf	TONEFREQUENCY,W
	movwf	SysCalcTempA
	movf	TONEFREQUENCY_H,W
	movwf	SysCalcTempA_H
	call	SysCompLessThan16
	btfsc	SysCalcTempX,0
	goto	SysForLoopEnd9
SysForLoop9
	movlw	1
	addwf	TONELOOP2,F
	movf	TONELOOP2_H,W
	btfsc	STATUS,C
	addlw	1
	movwf	TONELOOP2_H
;Set SoundOut ON
	bsf	GPIO,0
;SysToneDelay
	movf	TONEPERIOD,W
	movwf	SysWaitTemp10US
	call	Delay_10US
;Set SoundOut OFF
	bcf	GPIO,0
;SysToneDelay
	movf	TONEPERIOD,W
	movwf	SysWaitTemp10US
	call	Delay_10US
;Next
	movf	TONELOOP2,W
	movwf	SysCalcTempA
	movf	TONELOOP2_H,W
	movwf	SysCalcTempA_H
	movf	TONEFREQUENCY,W
	movwf	SysCalcTempB
	movf	TONEFREQUENCY_H,W
	movwf	SysCalcTempB_H
	call	SysCompLessThan16
	btfsc	SysCalcTempX,0
	goto	SysForLoop9
SysForLoopEnd9
;Next
	movf	TONELOOP,W
	movwf	SysCalcTempA
	movf	TONELOOP_H,W
	movwf	SysCalcTempA_H
	movf	TONEDURATION,W
	movwf	SysCalcTempB
	movf	TONEDURATION_H,W
	movwf	SysCalcTempB_H
	call	SysCompLessThan16
	btfsc	SysCalcTempX,0
	goto	SysForLoop8
SysForLoopEnd8
	return

;********************************************************************************

;********************************************************************************

; Data Lookup Tables (data memory)
	ORG	0x2100
TableEEPROM	equ	0
	de	36, 191, 190, 188, 184, 176, 160, 161, 163, 167, 175, 66, 129, 133, 100, 32, 132, 99, 128, 64, 142, 101, 130, 67, 65, 103, 134, 139, 98, 96, 33, 100, 136, 102, 137, 141, 131

 END
