;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
SysCalcTempA	EQU	117
SysCalcTempA_H	EQU	118
SysCalcTempB	EQU	121
SysCalcTempB_H	EQU	122
SysCalcTempX	EQU	112
SysCalcTempX_H	EQU	113
SysSTATUS	EQU	127
SysW	EQU	126
NUMTICKS	EQU	32
NUMTICKS_H	EQU	33
PATTERN	EQU	34
SYSBITVAR0	EQU	35
SavePCLATH	EQU	36
SaveSysCalcTempA	EQU	37
SaveSysCalcTempA_H	EQU	38
SaveSysCalcTempB	EQU	39
SaveSysCalcTempB_H	EQU	40
SaveSysCalcTempX	EQU	41
SysIntOffCount	EQU	42
SysTemp1	EQU	43
TICKS	EQU	44
TICKS_H	EQU	45
TMR1PRES	EQU	46
TMR1SOURCE	EQU	47
TMR2PRES	EQU	48
TMRNUMBER	EQU	49

;********************************************************************************

;Alias variables
TIMER	EQU	TMR1L
TIMER_H	EQU	TMR1H

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
Interrupt

;********************************************************************************

;Save Context
	movwf	SysW
	swapf	STATUS,W
	movwf	SysSTATUS
	incf	SysIntOffCount,F
	banksel	STATUS
;Store system variables
	movf	SysCalcTempA,W
	movwf	SaveSysCalcTempA
	movf	SysCalcTempA_H,W
	movwf	SaveSysCalcTempA_H
	movf	SysCalcTempB,W
	movwf	SaveSysCalcTempB
	movf	SysCalcTempB_H,W
	movwf	SaveSysCalcTempB_H
	movf	SysCalcTempX,W
	movwf	SaveSysCalcTempX
	movf	PCLATH,W
	movwf	SavePCLATH
	clrf	PCLATH
;On Interrupt handlers
	banksel	PIE1
	btfss	PIE1,T1IE
	goto	NotT1IF
	banksel	PIR1
	btfss	PIR1,T1IF
	goto	NotT1IF
	call	UPDATE
	bcf	PIR1,T1IF
	goto	INTERRUPTDONE
NotT1IF
;User Interrupt routine
INTERRUPTDONE
;Restore Context
;Restore system variables
	banksel	SAVESYSCALCTEMPA
	movf	SaveSysCalcTempA,W
	movwf	SysCalcTempA
	movf	SaveSysCalcTempA_H,W
	movwf	SysCalcTempA_H
	movf	SaveSysCalcTempB,W
	movwf	SysCalcTempB
	movf	SaveSysCalcTempB_H,W
	movwf	SysCalcTempB_H
	movf	SaveSysCalcTempX,W
	movwf	SysCalcTempX
	movf	SavePCLATH,W
	movwf	PCLATH
	clrf	SysIntOffCount
	swapf	SysSTATUS,W
	movwf	STATUS
	swapf	SysW,F
	swapf	SysW,W
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	55
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS
;Enable interrupts
	bsf	INTCON,GIE
	bsf	INTCON,PEIE
	clrf	SysIntOffCount

;Start of the main program
;Here's an egg timer based on TIMER1. It has three settings
;for one minute, two minutes and three minutes. Connect
;GP0 and GP1 to the center-off toggle switch. Connect GP2 to
;the buzzer and GP3 to pushbutton1. Connect GP4 to LED1.
;Connect GP5 to the green element of the bicolor LED and
;ground to the red element.
;TIMER1 runs at 8MHz/4/8/25000 = 10 Hz. Thus, an interrupt
;occurs 10 times per second.
;----- Setup
;----- Constants
;#define buzzer GPIO.2				;buzzer on pin 5
;#define button GPIO.3				;button on pin 4
;#define red GPIO.4					;red LED on pin 3
;#define green GPIO.5				;green LED on pin 2
;#define prescaler PS1_8 		;divide-by-8 prescaler
;#define timing 40536				;65536-25000
;----- Variables
;dim pattern as byte
;dim timer as word alias TMR1H, TMR1L
;dim ticks, numTicks as word
;dim alarm as bit
;----- Program
;dir GPIO 0b00001011					;set up port lines
	movlw	11
	banksel	TRISIO
	movwf	TRISIO
;initTimer1 osc, prescaler		;set up TIMER1
	movlw	1
	banksel	TMR1SOURCE
	movwf	TMR1SOURCE
	movlw	48
	movwf	TMR1PRES
	call	INITTIMER1
;startTimer 1								;start the timer
	movlw	1
	movwf	TMRNUMBER
	call	STARTTIMER
;on interrupt Timer1Overflow call update	;set up interrupt
	banksel	PIE1
	bsf	PIE1,T1IE
;alarm = false								;no alarm at outset
	banksel	SYSBITVAR0
	bcf	SYSBITVAR0,0
;do													;main loop
SysDoLoop_S1
;do												;wait until button pressed
SysDoLoop_S2
;pattern = GPIO & 0b00000011	
	movlw	3
	andwf	GPIO,W
	movwf	PATTERN
;select case pattern			;but read toggle in the meanwhile
SysSelect1Case1
	decf	PATTERN,W
	btfss	STATUS, Z
	goto	SysSelect1Case2
;numTicks = 600			;1 minute
	movlw	88
	movwf	NUMTICKS
	movlw	2
	movwf	NUMTICKS_H
	goto	SysSelectEnd1
SysSelect1Case2
	movlw	3
	subwf	PATTERN,W
	btfss	STATUS, Z
	goto	SysSelect1Case3
;numTicks = 1200			;2 minutes
	movlw	176
	movwf	NUMTICKS
	movlw	4
	movwf	NUMTICKS_H
	goto	SysSelectEnd1
SysSelect1Case3
	movlw	2
	subwf	PATTERN,W
	btfss	STATUS, Z
	goto	SysSelect1Case4
;numTicks = 1800			;3 minutes
	movlw	8
	movwf	NUMTICKS
	movlw	7
	movwf	NUMTICKS_H
;end select	
SysSelect1Case4
SysSelectEnd1
;ticks = 0								;might as well have
	clrf	TICKS
	clrf	TICKS_H
;timer = timing					;these ready to go, too	
	movlw	88
	movwf	TIMER
	movlw	158
	movwf	TIMER_H
;loop while button = 1
	btfsc	GPIO,3
	goto	SysDoLoop_S2
SysDoLoop_E2
;intOn											;enable interrupts now
	movf	SysIntOffCount,F
	btfss	STATUS,Z
	decf	SysIntOffCount,F
	btfsc	STATUS,Z
	bsf	INTCON,GIE
;set green on							;green means timing began
	bsf	GPIO,5
;do												;wait until time is up
SysDoLoop_S3
;loop until alarm
	btfss	SYSBITVAR0,0
	goto	SysDoLoop_S3
SysDoLoop_E3
;intOff										;disable interrupts
	bcf	INTCON,GIE
	incf	SysIntOffCount,F
;set green off							;toggle the LEDs
	bcf	GPIO,5
;set red on
	bsf	GPIO,4
;do while button 					;buzz until disengaged
SysDoLoop_S4
	btfss	GPIO,3
	goto	SysDoLoop_E4
;set buzzer on
	bsf	GPIO,2
;loop
	goto	SysDoLoop_S4
SysDoLoop_E4
;set buzzer off						;stop buzzing now
	bcf	GPIO,2
;set red off								;turn off red LED
	bcf	GPIO,4
;alarm = false							;end of alarm
	bcf	SYSBITVAR0,0
;do												;wait until released
SysDoLoop_S5
;loop until button
	btfss	GPIO,3
	goto	SysDoLoop_S5
SysDoLoop_E5
;loop	
	goto	SysDoLoop_S1
SysDoLoop_E1
;----- Interrupt Subroutine
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

INITTIMER1
;SInitTimer1
	goto	SINITTIMER1

;********************************************************************************

SINITTIMER1
;T1CON = TMR1Pres
	movf	TMR1PRES,W
	movwf	T1CON
;If TMR1Source = Ext Then
	movlw	2
	subwf	TMR1SOURCE,W
	btfsc	STATUS, Z
;Set TMR1CS On
	bsf	T1CON,TMR1CS
;End If
;If TMR1Source = ExtOsc Then
	movlw	3
	subwf	TMR1SOURCE,W
	btfss	STATUS, Z
	goto	ENDIF5
;Set TMR1CS On
	bsf	T1CON,TMR1CS
;Set T1OSCEN On
	bsf	T1CON,T1OSCEN
;End If
ENDIF5
	return

;********************************************************************************

STARTTIMER
;If TMRNumber = 1 Then
	decf	TMRNUMBER,W
	btfsc	STATUS, Z
;Set TMR1ON On
	bsf	T1CON,TMR1ON
;End If
;If TMRNumber = 2 Then
	movlw	2
	subwf	TMRNUMBER,W
	btfss	STATUS, Z
	goto	ENDIF3
;T2CON = TMR2Pres
	movf	TMR2PRES,W
	movwf	T2CON
;Set TMR2ON On
	bsf	T2CON,TMR2ON
;End If
ENDIF3
	return

;********************************************************************************

SYSCOMPEQUAL16
;dim SysCalcTempA as word
;dim SysCalcTempB as word
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA, W
	movf	SYSCALCTEMPA, W
;subwf SysCalcTempB, W
	subwf	SYSCALCTEMPB, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;movf SysCalcTempA_H, W
	movf	SYSCALCTEMPA_H, W
;subwf SysCalcTempB_H, W
	subwf	SYSCALCTEMPB_H, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

UPDATE
;timer = timing						;get set for next time
	movlw	88
	movwf	TIMER
	movlw	158
	movwf	TIMER_H
;T1IF = 0									;clear the overflow flag
	bcf	PIR1,T1IF
;ticks += 1								;increment tick counter
	movlw	1
	addwf	TICKS,F
	movf	TICKS_H,W
	btfsc	STATUS,C
	addlw	1
	movwf	TICKS_H
;if ticks = numTicks then	;see if long enough
	movf	TICKS,W
	movwf	SysCalcTempA
	movf	TICKS_H,W
	movwf	SysCalcTempA_H
	movf	NUMTICKS,W
	movwf	SysCalcTempB
	movf	NUMTICKS_H,W
	movwf	SysCalcTempB_H
	call	SysCompEqual16
	btfsc	SysCalcTempX,0
;alarm = true
	bsf	SYSBITVAR0,0
;end if	
	return

;********************************************************************************


 END
