;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
DELAYTEMP2	EQU	113
SysWaitTempMS	EQU	114
SysWaitTempMS_H	EQU	115
CURRENT	EQU	32
PREV	EQU	33

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS
;Automatic pin direction setting
	banksel	TRISIO
	bcf	TRISIO,1

;Start of the main program
;Like the previous experiment, this will change the DC
;polarity applied to a device. What's new is that it is
;now possible to shut the device down completely. Thus
;there are three states: forward, reverse and off.
;Don't try this with a motor directly, though, since the
;PIC pin can only supply 10 mA maximum.Connect GP0 to
;the relay. Connect GP1 to A1 and B2 on the relay (use
;a multiple). Also connect A2 and B1 to ground. Connect
;A to the red element and B to the green element.
;----- Settings
;----- Constants
;#define relay GPIO.0     		;relay on pin 7
;#define source GPIO.1				;source voltage to the LED
;----- Variables
;dim prev, current as byte		
;----- Program
;dir relay out								;set up port line
	bcf	TRISIO,0
;do
SysDoLoop_S1
;set source on							;apply voltage
	banksel	GPIO
	bsf	GPIO,1
;set relay on							;show red
	bsf	GPIO,0
;pause 500
;Wait Time ms
	movlw	244
	movwf	SysWaitTempMS
	movlw	1
	movwf	SysWaitTempMS_H
	call	Delay_MS
;set relay off							;then show green
	bcf	GPIO,0
;pause 500
;Wait Time ms
	movlw	244
	movwf	SysWaitTempMS
	movlw	1
	movwf	SysWaitTempMS_H
	call	Delay_MS
;set source off						;then extinguish
	bcf	GPIO,1
;pause 500
;Wait Time ms
	movlw	244
	movwf	SysWaitTempMS
	movlw	1
	movwf	SysWaitTempMS_H
	call	Delay_MS
;loop                    		;repeat in perpetuity
	goto	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	4
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	165
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************


 END
