;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
DELAYTEMP2	EQU	113
SysWaitTempUS	EQU	117
SysWaitTempUS_H	EQU	118
CHAR	EQU	32
I	EQU	33
SERBIT	EQU	34
SERDELAYLOOP	EQU	35
SERTEMP	EQU	36
SER_BYTE	EQU	37
SER_DATA	EQU	38
SER_DATA_A	EQU	39
SER_INVERT	EQU	40
SER_INVERT_A	EQU	41
SER_PARITY	EQU	42
SER_PARITY_A	EQU	43
SER_RATE	EQU	44
SER_RATE_A	EQU	45
SER_SELECT	EQU	46
SER_SELECT_OLD	EQU	47
SER_START	EQU	48
SER_START_A	EQU	49
SER_STOP	EQU	50
SER_STOP_A	EQU	51
SysTemp1	EQU	52
TEMPPARITY	EQU	53

;********************************************************************************

;Alias variables
EEAddress	EQU	EEADR
EEDataValue	EQU	EEDATA

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;Here we have a demonstration of EEPROM access. In particular,
;data that was stored in EEPROM during the programming process
;will be called up and sent to the terminal. Connect GP0 to
;Rx, GP1 to Tx and GP2 to pushbutton1. Then connect your PC
;to the DB-9 port, using a USB-to-COM adapter if required.
;Run the affair at 4800 Baud. Each time you press the button,
;the message stored in EEPROM will be transmitted. Use any
;terminal program to receive it.
;IMPORTANT NOTE: You'll need to assemble the code with
;Great Cow Basic's internal assembler. The Microchip
;MPASM software has the nasty habit of truncating the long
;lines of data in the "message.h" data file which is burned
;into the EEPROM.
;----- Settings
;----- Constants
;#define SerInPort		GPIO.0            ;Rx input on pin 7
;#define SerOutPort	GPIO.1            ;Tx output on pin 6
;#define button			GPIO.2  					;button on pin 5
;#define SendAHigh Set SerOutPort  on  ;output logic levels
;#define SendALow  Set SerOutPort  off
;#define RecAHigh  SerInPort       on  ;input logic levels
;#define RecALow   SerInPort       off
;#define lf 10									;line feed
;#define cr 13									;carriage return
;----- Variables
;dim char, i as byte
;----- Program
;dir SerInPort in
	banksel	TRISIO
	bsf	TRISIO,0
;dir SerOutPort out
	bcf	TRISIO,1
;dir button in
	bsf	TRISIO,2
;InitSer 1, r4800, 1+WaitForStart, 8, 1, none, invert
	movlw	1
	banksel	SER_SELECT
	movwf	SER_SELECT
	movlw	4
	movwf	SER_RATE
	movlw	129
	movwf	SER_START
	movlw	8
	movwf	SER_DATA
	movlw	1
	movwf	SER_STOP
	clrf	SER_PARITY
	movlw	1
	movwf	SER_INVERT
	call	INITSER
;do
SysDoLoop_S1
;do																;wait for button
SysDoLoop_S2
;loop while button
	btfsc	GPIO,2
	goto	SysDoLoop_S2
SysDoLoop_E2
;i = 1															;prime the loop
	movlw	1
	movwf	I
;readTable eeprom, i, char
	movlw	low(TableEEPROM)
	addwf	I,W
	banksel	EEAddress
	movwf	EEAddress
	banksel	STATUS
	call	SysEPRead
	banksel	EEDataValue
	movf	EEDataValue,W
	banksel	CHAR
	movwf	CHAR
;do
SysDoLoop_S3
;serSend 1, char									;transmit it
	movlw	1
	movwf	SER_SELECT
	movf	CHAR,W
	movwf	SER_BYTE
	call	SERSEND
;i++															;get set for next
	incf	I,F
;readTable eeprom, i, char
	movlw	low(TableEEPROM)
	addwf	I,W
	banksel	EEAddress
	movwf	EEAddress
	banksel	STATUS
	call	SysEPRead
	banksel	EEDataValue
	movf	EEDataValue,W
	banksel	CHAR
	movwf	CHAR
;loop until char = 0
	movf	CHAR,F
	btfss	STATUS, Z
	goto	SysDoLoop_S3
SysDoLoop_E3
;serSend 1, cr
	movlw	1
	movwf	SER_SELECT
	movlw	13
	movwf	SER_BYTE
	call	SERSEND
;serSend 1, lf
	movlw	1
	movwf	SER_SELECT
	movlw	10
	movwf	SER_BYTE
	call	SERSEND
;do
SysDoLoop_S4
;loop until button									;wait for release
	btfss	GPIO,2
	goto	SysDoLoop_S4
SysDoLoop_E4
;loop                          			;repeat in perpetuity
	goto	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

INITSER
;Ser_Select_Old = Ser_Select
	movf	SER_SELECT,W
	movwf	SER_SELECT_OLD
;if Ser_Select = 1 THEN
	decf	SER_SELECT,W
	btfss	STATUS, Z
	goto	ENDIF1
;Ser_Rate_A = Ser_Rate
	movf	SER_RATE,W
	movwf	SER_RATE_A
;Ser_Start_A = Ser_Start
	movf	SER_START,W
	movwf	SER_START_A
;Ser_Data_A = Ser_Data
	movf	SER_DATA,W
	movwf	SER_DATA_A
;Ser_Stop_A = Ser_Stop
	movf	SER_STOP,W
	movwf	SER_STOP_A
;Ser_Parity_A = Ser_Parity
	movf	SER_PARITY,W
	movwf	SER_PARITY_A
;Ser_Invert_A = Ser_Invert
	movf	SER_INVERT,W
	movwf	SER_INVERT_A
;END IF
ENDIF1
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

SERBITDELAY
;if Ser_Rate = 1 then Wait SerFullDelay19200 us: exit sub	'19200 (52 us)
	decf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF29
	movlw	19
	movwf	DELAYTEMP
DelayUS1
	decfsz	DELAYTEMP,F
	goto	DelayUS1
	return
ENDIF29
;if Ser_Rate = 2 then Wait SerFullDelay9600 us: exit sub 	'9600 (104 us)
	movlw	2
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF30
	movlw	52
	movwf	DELAYTEMP
DelayUS2
	decfsz	DELAYTEMP,F
	goto	DelayUS2
	nop
	return
ENDIF30
;if Ser_Rate = 4 then Wait SerFullDelay4800 us: exit sub 	'4800 (208 us)
	movlw	4
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF31
	movlw	122
	movwf	DELAYTEMP
DelayUS3
	decfsz	DELAYTEMP,F
	goto	DelayUS3
	return
ENDIF31
;if Ser_Rate = 8 then Wait SerFullDelay2400 us: exit sub 	'2400 (417 us)
	movlw	8
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF32
	movlw	1
	movwf	DELAYTEMP2
DelayUSO4
	clrf	DELAYTEMP
DelayUS4
	decfsz	DELAYTEMP,F
	goto	DelayUS4
	decfsz	DELAYTEMP2,F
	goto	DelayUSO4
	movlw	4
	movwf	DELAYTEMP
DelayUS5
	decfsz	DELAYTEMP,F
	goto	DelayUS5
	return
ENDIF32
;if Ser_Rate = 16 then Wait SerFullDelay1200 us: exit sub 	'1200 (833 us)
	movlw	16
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF33
	movlw	2
	movwf	DELAYTEMP2
DelayUSO6
	clrf	DELAYTEMP
DelayUS6
	decfsz	DELAYTEMP,F
	goto	DelayUS6
	decfsz	DELAYTEMP2,F
	goto	DelayUSO6
	movlw	24
	movwf	DELAYTEMP
DelayUS7
	decfsz	DELAYTEMP,F
	goto	DelayUS7
	return
ENDIF33
;if Ser_Rate = 32 then Wait SerFullDelay600 us: exit sub 	'600 (1666 us)
	movlw	32
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF34
	movlw	4
	movwf	DELAYTEMP2
DelayUSO8
	clrf	DELAYTEMP
DelayUS8
	decfsz	DELAYTEMP,F
	goto	DelayUS8
	decfsz	DELAYTEMP2,F
	goto	DelayUSO8
	movlw	65
	movwf	DELAYTEMP
DelayUS9
	decfsz	DELAYTEMP,F
	goto	DelayUS9
	nop
	return
ENDIF34
;if Ser_Rate = 64 then Wait SerFullDelay300 us: exit sub '300 (3333 us)
	movlw	64
	subwf	SER_RATE,W
	btfss	STATUS, Z
	goto	ENDIF35
	movlw	8
	movwf	DELAYTEMP2
DelayUSO10
	clrf	DELAYTEMP
DelayUS10
	decfsz	DELAYTEMP,F
	goto	DelayUS10
	decfsz	DELAYTEMP2,F
	goto	DelayUSO10
	movlw	149
	movwf	DELAYTEMP
DelayUS11
	decfsz	DELAYTEMP,F
	goto	DelayUS11
	return
ENDIF35
;for SerDelayLoop = 1 to Ser_Rate
	clrf	SERDELAYLOOP
	movlw	1
	subwf	SER_RATE,W
	btfss	STATUS, C
	goto	SysForLoopEnd4
SysForLoop4
	incf	SERDELAYLOOP,F
;Wait 42 us
	movlw	28
	movwf	DELAYTEMP
DelayUS12
	decfsz	DELAYTEMP,F
	goto	DelayUS12
;next
	movf	SER_RATE,W
	subwf	SERDELAYLOOP,W
	btfss	STATUS, C
	goto	SysForLoop4
SysForLoopEnd4
	return

;********************************************************************************

SERCFGLOAD
;Ser_Select_Old = Ser_Select
	movf	SER_SELECT,W
	movwf	SER_SELECT_OLD
;if Ser_Select = 1 THEN
	decf	SER_SELECT,W
	btfss	STATUS, Z
	goto	ENDIF28
;Ser_Rate = Ser_Rate_A
	movf	SER_RATE_A,W
	movwf	SER_RATE
;Ser_Start = Ser_Start_A
	movf	SER_START_A,W
	movwf	SER_START
;Ser_Data = Ser_Data_A
	movf	SER_DATA_A,W
	movwf	SER_DATA
;Ser_Stop = Ser_Stop_A
	movf	SER_STOP_A,W
	movwf	SER_STOP
;Ser_Parity = Ser_Parity_A
	movf	SER_PARITY_A,W
	movwf	SER_PARITY
;Ser_Invert = Ser_Invert_A
	movf	SER_INVERT_A,W
	movwf	SER_INVERT
;end if
ENDIF28
	return

;********************************************************************************

SERSEND
;if Ser_Select <> Ser_Select_Old then SerCfgLoad(Ser_Select)
	movf	SER_SELECT_OLD,W
	subwf	SER_SELECT,W
	btfss	STATUS, Z
	call	SERCFGLOAD
;SerTemp = Ser_Start and (not WaitForStart)
	movlw	127
	andwf	SER_START,W
	movwf	SERTEMP
;for SerBit = 1 to SerTemp
	clrf	SERBIT
	movlw	1
	subwf	SERTEMP,W
	btfss	STATUS, C
	goto	SysForLoopEnd1
SysForLoop1
	incf	SERBIT,F
;SerTxHigh
;if Ser_Select = 1 THEN SendAHigh
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bsf	GPIO,1
;SerBitDelay
	call	SERBITDELAY
;next
	movf	SERTEMP,W
	subwf	SERBIT,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
;TempParity = SerTemp
	movf	SERTEMP,W
	movwf	TEMPPARITY
;for SerBit = 1 to Ser_Data
	clrf	SERBIT
	movlw	1
	subwf	SER_DATA,W
	btfss	STATUS, C
	goto	SysForLoopEnd2
SysForLoop2
	incf	SERBIT,F
;if Ser_Invert = normal then
	movf	SER_INVERT,F
	btfss	STATUS, Z
	goto	ENDIF7
;if Ser_Byte.0 ON then SerTxHigh: TempParity = TempParity + 1
	btfss	SER_BYTE,0
	goto	ENDIF14
;if Ser_Select = 1 THEN SendAHigh
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bsf	GPIO,1
;SerBitDelay
	call	SERBITDELAY
	incf	TEMPPARITY,F
ENDIF14
;if Ser_Byte.0 OFF then SerTxLow
	btfsc	SER_BYTE,0
	goto	ENDIF15
;if Ser_Select = 1 THEN SendALow
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bcf	GPIO,1
;SerBitDelay
	call	SERBITDELAY
ENDIF15
;end if
ENDIF7
;if Ser_Invert = invert then
	decf	SER_INVERT,W
	btfss	STATUS, Z
	goto	ENDIF8
;if Ser_Byte.0 ON then SerTxLow: TempParity = TempParity + 1
	btfss	SER_BYTE,0
	goto	ENDIF16
;if Ser_Select = 1 THEN SendALow
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bcf	GPIO,1
;SerBitDelay
	call	SERBITDELAY
	incf	TEMPPARITY,F
ENDIF16
;if Ser_Byte.0 OFF then SerTxHigh
	btfsc	SER_BYTE,0
	goto	ENDIF17
;if Ser_Select = 1 THEN SendAHigh
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bsf	GPIO,1
;SerBitDelay
	call	SERBITDELAY
ENDIF17
;end if
ENDIF8
;rotate Ser_Byte right
	rrf	SER_BYTE,F
;next
	movf	SER_DATA,W
	subwf	SERBIT,W
	btfss	STATUS, C
	goto	SysForLoop2
SysForLoopEnd2
;if Ser_Parity <> 0 THEN
	movf	SER_PARITY,F
	btfsc	STATUS, Z
	goto	ENDIF10
;if Ser_Parity = odd then TempParity = TempParity + 1
	decf	SER_PARITY,W
	btfsc	STATUS, Z
	incf	TEMPPARITY,F
;if Ser_Invert = invert then TempParity = TempParity + 1
	decf	SER_INVERT,W
	btfsc	STATUS, Z
	incf	TEMPPARITY,F
;if TempParity.0 = ON then SerTxLow
	btfss	TEMPPARITY,0
	goto	ENDIF20
;if Ser_Select = 1 THEN SendALow
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bcf	GPIO,1
;SerBitDelay
	call	SERBITDELAY
ENDIF20
;if TempParity.0 = OFF then SerTxHigh
	btfsc	TEMPPARITY,0
	goto	ENDIF21
;if Ser_Select = 1 THEN SendAHigh
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bsf	GPIO,1
;SerBitDelay
	call	SERBITDELAY
ENDIF21
;end if
ENDIF10
;for SerBit = 1 to Ser_Stop
	clrf	SERBIT
	movlw	1
	subwf	SER_STOP,W
	btfss	STATUS, C
	goto	SysForLoopEnd3
SysForLoop3
	incf	SERBIT,F
;SerTxLow
;if Ser_Select = 1 THEN SendALow
	decf	SER_SELECT,W
	btfsc	STATUS, Z
	bcf	GPIO,1
;SerBitDelay
	call	SERBITDELAY
;next
	movf	SER_STOP,W
	subwf	SERBIT,W
	btfss	STATUS, C
	goto	SysForLoop3
SysForLoopEnd3
;SerBitDelay
	goto	SERBITDELAY

;********************************************************************************

SYSEPREAD
;Dim EEAddress Alias EEADR
;Dim EEDataValue Alias EEDATA
;IntOff
;SET EECON1.RD ON
	banksel	EECON1
	bsf	EECON1,RD
;IntOn
	banksel	STATUS
	return

;********************************************************************************

;********************************************************************************

; Data Lookup Tables (data memory)
	ORG	0x2100
TableEEPROM	equ	0
	de	232, 84, 104, 105, 115, 32, 112, 114, 111, 103, 114, 97, 109, 32, 100, 101, 109, 111, 110, 115, 116, 114, 97, 116, 101, 115, 32, 104, 111, 119, 32, 100, 97, 116, 97, 32, 40, 105, 110, 32, 116, 104, 105, 115, 32, 99, 97, 115, 101, 32, 99, 104, 97, 114, 97, 99, 116, 101, 114, 32, 100, 97, 116, 97, 41, 32, 99, 97, 110, 32, 98, 101, 32, 98, 117, 114, 110, 101, 100, 32, 105, 110, 116, 111, 32, 69, 69, 80, 82, 79, 77, 32, 100, 117, 114, 105, 110, 103, 32, 112, 114, 111, 103, 114, 97, 109, 109, 105, 110, 103, 32, 97, 110, 100, 32, 114, 101, 99, 97, 108, 108, 101, 100, 32, 108, 97, 116, 101, 114, 32, 100, 117, 114, 105, 110, 103, 32, 114, 117, 110, 116, 105, 109, 101, 46, 32, 84, 104, 101, 114, 101, 32, 105, 115, 32, 114, 111, 111, 109, 32, 102, 111, 114, 32, 50, 53, 53, 32, 98, 121, 116, 101, 115, 46, 32, 69, 97, 99, 104, 32, 100, 97, 116, 117, 109, 32, 109, 117, 115, 116, 32, 97, 112, 112, 101, 97, 114, 32, 111, 110, 32, 97, 32, 115, 101, 112, 97, 114, 97, 116, 101, 32, 108, 105, 110, 101, 32, 97, 110, 100, 32, 98, 101, 32, 110, 117, 109, 101, 114, 105, 99, 46, 0

 END
