;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
DELAYTEMP2	EQU	113
SysCalcTempA	EQU	117
SysCalcTempB	EQU	121
SysCalcTempX	EQU	112
SysSTATUS	EQU	127
SysW	EQU	126
SysWaitTempMS	EQU	114
SysWaitTempMS_H	EQU	115
FORWARD	EQU	32
I	EQU	33
PATTERN	EQU	34
SaveDelayTemp	EQU	35
SaveDelayTemp2	EQU	36
SavePCLATH	EQU	37
SaveSysTemp1	EQU	38
SaveSysTemp2	EQU	39
SaveSysWaitTempMS	EQU	40
SaveSysWaitTempMS_H	EQU	41
SysIntOffCount	EQU	42
SysTemp1	EQU	43
SysTemp2	EQU	44

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
Interrupt

;********************************************************************************

;Save Context
	movwf	SysW
	swapf	STATUS,W
	movwf	SysSTATUS
	incf	SysIntOffCount,F
	banksel	STATUS
;Store system variables
	movf	SysWaitTempMS,W
	movwf	SaveSysWaitTempMS
	movf	SysWaitTempMS_H,W
	movwf	SaveSysWaitTempMS_H
	movf	SysTemp2,W
	movwf	SaveSysTemp2
	movf	SysTemp1,W
	movwf	SaveSysTemp1
	movf	DelayTemp2,W
	movwf	SaveDelayTemp2
	movf	DelayTemp,W
	movwf	SaveDelayTemp
	movf	PCLATH,W
	movwf	SavePCLATH
	clrf	PCLATH
;On Interrupt handlers
	btfss	INTCON,INTE
	goto	NotINTF
	btfss	INTCON,INTF
	goto	NotINTF
	call	CHANGE
	bcf	INTCON,INTF
	goto	INTERRUPTDONE
NotINTF
;User Interrupt routine
INTERRUPTDONE
;Restore Context
;Restore system variables
	movf	SaveSysWaitTempMS,W
	movwf	SysWaitTempMS
	movf	SaveSysWaitTempMS_H,W
	movwf	SysWaitTempMS_H
	movf	SaveSysTemp2,W
	movwf	SysTemp2
	movf	SaveSysTemp1,W
	movwf	SysTemp1
	movf	SaveDelayTemp2,W
	movwf	DelayTemp2
	movf	SaveDelayTemp,W
	movwf	DelayTemp
	movf	SavePCLATH,W
	movwf	PCLATH
	clrf	SysIntOffCount
	swapf	SysSTATUS,W
	movwf	STATUS
	swapf	SysW,F
	swapf	SysW,W
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	53
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS
;Enable interrupts
	bsf	INTCON,GIE
	bsf	INTCON,PEIE
	clrf	SysIntOffCount

;Start of the main program
;This program demonstrates an external interrupt on
;pin GP2. Four LEDs will do a chaser effect. When
;pushbutton1 is pressed, an interrupt is generated
;which changes the direction of the chaser. A time
;lag is incorporated to prevent contact bounce from
;messing things up. Connect GP0, GP1, GP4 and GP5
;to LED1 through LED4, respectively. Connect GP2
;to pushbutton1.
;----- Setup
;----- Constants
;#define LEDs GPIO				;most pins are LEDs
;#define button GPIO.2		;button on pin 5
;----- Variables
;dim pattern, i as byte
;----- Program
;dir LEDs out	         		;make most pins outputs
	banksel	TRISIO
	clrf	TRISIO
;dir button in							;except the pushbutton
	bsf	TRISIO,2
;forward = false						;start out in forward gear
	banksel	FORWARD
	clrf	FORWARD
;on interrupt ExtInt0 call change	;set up interrupt
	bsf	INTCON,INTE
;set INTEDG off						;interrupt on falling edge
	banksel	OPTION_REG
	bcf	OPTION_REG,INTEDG
;do
SysDoLoop_S1
;if forward then
	banksel	FORWARD
	movf	FORWARD,F
	btfsc	STATUS,Z
	goto	ELSE1_1
;pattern = 1						;start with the first LED
	movlw	1
	movwf	PATTERN
;LEDs = pattern        ;turn it on
	movwf	GPIO
;wait 100 ms         	;pause a bit
	movlw	100
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;for i = 1 to 3      	;step across the next 3 LEDs
	clrf	I
SysForLoop1
	incf	I,F
;pattern = 2*pattern	;shift left to next bit
	movlw	2
	movwf	SysCalcTempA
	movf	PATTERN,W
	movwf	SysCalcTempB
	call	SysMultSub
	movf	SysCalcTempX,W
	movwf	PATTERN
;if pattern = 4 then	;skip GP2 and GP3
	movlw	4
	subwf	PATTERN,W
	btfss	STATUS, Z
	goto	ENDIF2
;pattern = 16
	movlw	16
	movwf	PATTERN
;end if
ENDIF2
;LEDs = pattern			;update the LEDs
	movf	PATTERN,W
	movwf	GPIO
;wait 100 ms       	;pause to enjoy
	movlw	100
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;next i
	movlw	3
	subwf	I,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
;else
	goto	ENDIF1
ELSE1_1
;pattern = 32					;start with the last LED
	movlw	32
	movwf	PATTERN
;LEDs = pattern        ;turn it on
	movwf	GPIO
;wait 100 ms         	;pause a bit
	movlw	100
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;for i = 1 to 3      	;step across the next 3 LEDs
	clrf	I
SysForLoop2
	incf	I,F
;pattern = pattern/2	;shift right to next bit
	bcf	STATUS,C
	rrf	PATTERN,F
;if pattern = 8 then	;skip GP2 and GP3
	movlw	8
	subwf	PATTERN,W
	btfss	STATUS, Z
	goto	ENDIF4
;pattern = 2
	movlw	2
	movwf	PATTERN
;end if
ENDIF4
;LEDs = pattern			;update the LEDs
	movf	PATTERN,W
	movwf	GPIO
;wait 100 ms       	;pause to enjoy
	movlw	100
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;next i		
	movlw	3
	subwf	I,W
	btfss	STATUS, C
	goto	SysForLoop2
SysForLoopEnd2
;end if
ENDIF1
;loop                  		;repeat in perpetuity
	goto	SysDoLoop_S1
SysDoLoop_E1
;----- Interrupt Subroutine
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

CHANGE
;intOff									;disable interrupt
	bcf	INTCON,GIE
	incf	SysIntOffCount,F
;forward = !forward			;toggle direction variable
	comf	FORWARD,F
;pause 100								;debounce a bit
;Wait Time ms
	movlw	100
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;do
SysDoLoop_S2
;loop while !button			;wait for a release
	clrf	SysTemp2
	btfsc	gpio,2
	incf	SysTemp2,F
	comf	SysTemp2,W
	movwf	SysTemp1
	btfsc	SysTemp1,0
	goto	SysDoLoop_S2
SysDoLoop_E2
;pause 50								;debounce some more
;Wait Time ms
	movlw	50
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;intOn										;re-enable interrupt
	movf	SysIntOffCount,F
	btfss	STATUS,Z
	decf	SysIntOffCount,F
	btfsc	STATUS,Z
	bsf	INTCON,GIE
	return

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	4
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	165
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

SYSMULTSUB
;dim SysCalcTempA as byte
;dim SysCalcTempB as byte
;dim SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
MUL8LOOP
;movf SysCalcTempA, W
	movf	SYSCALCTEMPA, W
;btfsc SysCalcTempB, 0
	btfsc	SYSCALCTEMPB, 0
;addwf SysCalcTempX, F
	addwf	SYSCALCTEMPX, F
;bcf STATUS, C
	bcf	STATUS, C
;rrf SysCalcTempB, F
	rrf	SYSCALCTEMPB, F
;bcf STATUS, C
	bcf	STATUS, C
;rlf SysCalcTempA, F
	rlf	SYSCALCTEMPA, F
;movf SysCalcTempB, F
	movf	SYSCALCTEMPB, F
;btfss STATUS, Z
	btfss	STATUS, Z
;goto MUL8LOOP
	goto	MUL8LOOP
	return

;********************************************************************************


 END
