;Program compiled by Great Cow BASIC (0.9 5/11/2012)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F683, r=DEC
#include <P12F683.inc>
 __CONFIG _INTOSCIO & _WDT_OFF & _MCLRE_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	112
DELAYTEMP2	EQU	113
SysCalcTempA	EQU	117
SysCalcTempB	EQU	121
SysCalcTempX	EQU	112
SysStringA	EQU	119
SysStringA_H	EQU	120
SysWaitTempMS	EQU	114
SysWaitTempMS_H	EQU	115
SysWaitTempUS	EQU	117
SysWaitTempUS_H	EQU	118
CHAR	EQU	32
I	EQU	33
INKEY	EQU	34
PS2BIT	EQU	35
PS2BYTE	EQU	36
PS2FLAGS	EQU	37
PS2PARITY	EQU	38
PS2READBYTE	EQU	39
PS2SCROLLLOCK	EQU	40
PS2VALUE	EQU	41
SCANCODE	EQU	42
StringPointer	EQU	43
SysTemp1	EQU	44
SysTemp2	EQU	45

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS
	call	INITPS2

;Start of the main program
;This experiment demonstrates how to connect a PS/2
;keyboard to the PIC. Pressing any of the number
;keys 1-9 will beep the buzzer that amount of times.
;A PS/2 keyboard uses a 6-pin mini-DIN connector.
;Pin 1 is the data line, pin 5 the clock line, pin 4
;is +5V and pin 3 ground. The other two pins are not
;used. Connect GP0 to the data line, GP1 to the clock
;line and GP2 to the buzzer.
;Don't forget the power supply lines to the keyboard.
;----- Settings
;----- Constants
;#define PS2Data		GPIO.0		;data line on pin 7
;#define PS2Clock	GPIO.1		;clock line on pin 6
;#define buzzer		GPIO.2		;buzzer on pin 5
;#define PS2_DELAY 10 ms
;----- Variables
;dim char, i as byte
;----- Program
;dir buzzer out
	banksel	TRISIO
	bcf	TRISIO,2
;pause 1000
;Wait Time ms
	movlw	232
	movwf	SysWaitTempMS
	movlw	3
	movwf	SysWaitTempMS_H
	banksel	STATUS
	call	Delay_MS
;do
SysDoLoop_S1
;char = INKEY							;fetch keystroke
	call	FN_INKEY
	movf	INKEY,W
	movwf	CHAR
;if char > 48 and char < 58 then	;accept 1-9 only
	movwf	SysCalcTempB
	movlw	48
	movwf	SysCalcTempA
	call	SysCompLessThan
	movf	SysCalcTempX,W
	movwf	SysTemp1
	movf	CHAR,W
	movwf	SysCalcTempA
	movlw	58
	movwf	SysCalcTempB
	call	SysCompLessThan
	movf	SysTemp1,W
	andwf	SysCalcTempX,W
	movwf	SysTemp2
	btfss	SysTemp2,0
	goto	ENDIF1
;char -= 48							;convert to its number
	movlw	48
	subwf	CHAR,F
;for i = 1 to char				;beep that number of times
	clrf	I
	movlw	1
	subwf	CHAR,W
	btfss	STATUS, C
	goto	SysForLoopEnd1
SysForLoop1
	incf	I,F
;set buzzer on
	bsf	GPIO,2
;pause 250
;Wait Time ms
	movlw	250
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;set buzzer off
	bcf	GPIO,2
;pause 250
;Wait Time ms
	movlw	250
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;next i
	movf	CHAR,W
	subwf	I,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
;end if	
ENDIF1
;loop                    		;repeat in perpetuity
	goto	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	4
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	165
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

INITPS2
;DIR PS2Clock Out
	banksel	TRISIO
	bcf	TRISIO,1
;DIR PS2Data IN
	bsf	TRISIO,0
;Set PS2Clock Off
	banksel	GPIO
	bcf	GPIO,1
	return

;********************************************************************************

INITSYS
;OSCCON = OSCCON OR b'01110000'
	movlw	112
	banksel	OSCCON
	iorwf	OSCCON,F
;SET ADCON0.ADON OFF
	banksel	ADCON0
	bcf	ADCON0,ADON
;SET ADFM OFF
	bcf	ADCON0,ADFM
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;CMCON0 = 7
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

FN_INKEY
;INKEY = 0
	clrf	INKEY
PS2GETANOTHERKEY
;ScanCode = PS2ReadByte
	call	FN_PS2READBYTE
	movf	PS2READBYTE,W
	movwf	SCANCODE
;if ScanCode = 0 then exit function
	movf	SCANCODE,F
	btfsc	STATUS, Z
	return
;PS2Extended = 0
	bcf	PS2FLAGS,6
;PS2Release = 0
	bcf	PS2FLAGS,7
;if ScanCode = 0xE0 then
	movlw	224
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF5
;PS2Extended = 1
	bsf	PS2FLAGS,6
;Do
SysDoLoop_S2
;ScanCode = PS2ReadByte
	call	FN_PS2READBYTE
	movf	PS2READBYTE,W
	movwf	SCANCODE
;Loop While ScanCode = 0
	movf	SCANCODE,F
	btfsc	STATUS, Z
	goto	SysDoLoop_S2
SysDoLoop_E2
;end if
ENDIF5
;If ScanCode = 0xF0 Then
	movlw	240
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF6
;PS2Release = 1
	bsf	PS2FLAGS,7
;Do
SysDoLoop_S3
;ScanCode = PS2ReadByte
	call	FN_PS2READBYTE
	movf	PS2READBYTE,W
	movwf	SCANCODE
;Loop While ScanCode = 0
	movf	SCANCODE,F
	btfsc	STATUS, Z
	goto	SysDoLoop_S3
SysDoLoop_E3
;End If
ENDIF6
;If PS2Extended Then
	btfss	PS2FLAGS,6
	goto	ELSE7_1
;Else
	goto	ENDIF7
ELSE7_1
;If ScanCode = 0x12 or ScanCode = 0x59 then
	movf	SCANCODE,W
	movwf	SysCalcTempA
	movlw	18
	movwf	SysCalcTempB
	call	SysCompEqual
	movf	SysCalcTempX,W
	movwf	SysTemp1
	movf	SCANCODE,W
	movwf	SysCalcTempA
	movlw	89
	movwf	SysCalcTempB
	call	SysCompEqual
	movf	SysTemp1,W
	iorwf	SysCalcTempX,W
	movwf	SysTemp2
	btfss	SysTemp2,0
	goto	ENDIF8
;If PS2Release Then
	btfss	PS2FLAGS,7
	goto	ELSE12_1
;PS2KeyShift = 0
	bcf	PS2FLAGS,0
;Else
	goto	ENDIF12
ELSE12_1
;PS2KeyShift = 1
	bsf	PS2FLAGS,0
;End If
ENDIF12
;Goto PS2GetAnotherKey
	goto	PS2GETANOTHERKEY
;End If
ENDIF8
;If ScanCode = 0x14 then
	movlw	20
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF9
;If PS2Release Then
	btfss	PS2FLAGS,7
	goto	ELSE13_1
;PS2KeyCtrl = 0
	bcf	PS2FLAGS,1
;Else
	goto	ENDIF13
ELSE13_1
;PS2KeyCtrl = 1
	bsf	PS2FLAGS,1
;End If
ENDIF13
;Goto PS2GetAnotherKey
	goto	PS2GETANOTHERKEY
;End If
ENDIF9
;If ScanCode = 0x11 then
	movlw	17
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF10
;If PS2Release Then
	btfss	PS2FLAGS,7
	goto	ELSE14_1
;PS2KeyAlt = 0
	bcf	PS2FLAGS,2
;Else
	goto	ENDIF14
ELSE14_1
;PS2KeyAlt = 1
	bsf	PS2FLAGS,2
;End If
ENDIF14
;Goto PS2GetAnotherKey
	goto	PS2GETANOTHERKEY
;End If
ENDIF10
;If PS2Release = 0 Then
	btfsc	PS2FLAGS,7
	goto	ENDIF11
;if ScanCode = 0x58 then
	movlw	88
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF15
;If PS2CapsLock Then
	btfss	PS2FLAGS,4
	goto	ELSE51_1
;PS2CapsLock = 0
	bcf	PS2FLAGS,4
;Else
	goto	ENDIF51
ELSE51_1
;PS2CapsLock = 1
	bsf	PS2FLAGS,4
;End If
ENDIF51
;PS2SyncKBLeds
	call	PS2SYNCKBLEDS
;Goto PS2GetAnotherKey
	goto	PS2GETANOTHERKEY
;end if
ENDIF15
;if ScanCode = 0x77 then
	movlw	119
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF16
;If PS2NumLock Then
	btfss	PS2FLAGS,3
	goto	ELSE52_1
;PS2NumLock = 0
	bcf	PS2FLAGS,3
;Else
	goto	ENDIF52
ELSE52_1
;PS2NumLock = 1
	bsf	PS2FLAGS,3
;End If
ENDIF52
;PS2SyncKBLeds
	call	PS2SYNCKBLEDS
;Goto PS2GetAnotherKey
	goto	PS2GETANOTHERKEY
;end if
ENDIF16
;if ScanCode = 0x7E then
	movlw	126
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF17
;If PS2ScrollLock Then
	movf	PS2SCROLLLOCK,F
	btfsc	STATUS,Z
	goto	ELSE53_1
;PS2ScrollLock = 0
	clrf	PS2SCROLLLOCK
;Else
	goto	ENDIF53
ELSE53_1
;PS2ScrollLock = 1
	movlw	1
	movwf	PS2SCROLLLOCK
;End If
ENDIF53
;PS2SyncKBLeds
	call	PS2SYNCKBLEDS
;Goto PS2GetAnotherKey
	goto	PS2GETANOTHERKEY
;end if
ENDIF17
;if ScanCode = 0x5A then INKEY = 13	'Enter
	movlw	90
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF18
	movlw	13
	movwf	INKEY
ENDIF18
;if ScanCode = 0x66 then INKEY = 8	'Backspace
	movlw	102
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF19
	movlw	8
	movwf	INKEY
ENDIF19
;if ScanCode = 0x76 then INKEY = 27	'Esc
	movlw	118
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF20
	movlw	27
	movwf	INKEY
ENDIF20
;if ScanCode = 0x29 then INKEY = 32	'Space
	movlw	41
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF21
	movlw	32
	movwf	INKEY
ENDIF21
;If PS2KeyShift Then
	btfss	PS2FLAGS,0
	goto	ELSE22_1
;if ScanCode = 0x16 then INKEY = "!"
	movlw	22
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF54
	movlw	33
	movwf	INKEY
ENDIF54
;if ScanCode = 0x1E then INKEY = "@"
	movlw	30
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF55
	movlw	64
	movwf	INKEY
ENDIF55
;if ScanCode = 0x26 then INKEY = "#"
	movlw	38
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF56
	movlw	35
	movwf	INKEY
ENDIF56
;if ScanCode = 0x25 then INKEY = "$"
	movlw	37
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF57
	movlw	36
	movwf	INKEY
ENDIF57
;if ScanCode = 0x2E then INKEY = "%"
	movlw	46
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF58
	movlw	37
	movwf	INKEY
ENDIF58
;if ScanCode = 0x36 then INKEY = "^"
	movlw	54
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF59
	movlw	94
	movwf	INKEY
ENDIF59
;if ScanCode = 0x3D then INKEY = "&"
	movlw	61
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF60
	movlw	38
	movwf	INKEY
ENDIF60
;if ScanCode = 0x3E then INKEY = "*"
	movlw	62
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF61
	movlw	42
	movwf	INKEY
ENDIF61
;if ScanCode = 0x46 then INKEY = "("
	movlw	70
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF62
	movlw	40
	movwf	INKEY
ENDIF62
;if ScanCode = 0x45 then INKEY = ")"
	movlw	69
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF63
	movlw	41
	movwf	INKEY
ENDIF63
;Else
	goto	ENDIF22
ELSE22_1
;if ScanCode = 0x16 then INKEY = 49
	movlw	22
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF64
	movlw	49
	movwf	INKEY
ENDIF64
;if ScanCode = 0x1E then INKEY = 50
	movlw	30
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF65
	movlw	50
	movwf	INKEY
ENDIF65
;if ScanCode = 0x26 then INKEY = 51
	movlw	38
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF66
	movlw	51
	movwf	INKEY
ENDIF66
;if ScanCode = 0x25 then INKEY = 52
	movlw	37
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF67
	movlw	52
	movwf	INKEY
ENDIF67
;if ScanCode = 0x2E then INKEY = 53
	movlw	46
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF68
	movlw	53
	movwf	INKEY
ENDIF68
;if ScanCode = 0x36 then INKEY = 54
	movlw	54
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF69
	movlw	54
	movwf	INKEY
ENDIF69
;if ScanCode = 0x3D then INKEY = 55
	movlw	61
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF70
	movlw	55
	movwf	INKEY
ENDIF70
;if ScanCode = 0x3E then INKEY = 56
	movlw	62
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF71
	movlw	56
	movwf	INKEY
ENDIF71
;if ScanCode = 0x46 then INKEY = 57
	movlw	70
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF72
	movlw	57
	movwf	INKEY
ENDIF72
;if ScanCode = 0x45 then INKEY = 48
	movlw	69
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF73
	movlw	48
	movwf	INKEY
ENDIF73
;End If
ENDIF22
;if ScanCode = 0x1C then INKEY = 65 'A
	movlw	28
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF23
	movlw	65
	movwf	INKEY
ENDIF23
;if ScanCode = 0x32 then INKEY = 66
	movlw	50
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF24
	movlw	66
	movwf	INKEY
ENDIF24
;if ScanCode = 0x21 then INKEY = 67 'C
	movlw	33
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF25
	movlw	67
	movwf	INKEY
ENDIF25
;if ScanCode = 0x23 then INKEY = 68
	movlw	35
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF26
	movlw	68
	movwf	INKEY
ENDIF26
;if ScanCode = 0x24 then INKEY = 69 'E
	movlw	36
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF27
	movlw	69
	movwf	INKEY
ENDIF27
;if ScanCode = 0x2B then INKEY = 70
	movlw	43
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF28
	movlw	70
	movwf	INKEY
ENDIF28
;if ScanCode = 0x34 then INKEY = 71 'G
	movlw	52
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF29
	movlw	71
	movwf	INKEY
ENDIF29
;if ScanCode = 0x33 then INKEY = 72
	movlw	51
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF30
	movlw	72
	movwf	INKEY
ENDIF30
;if ScanCode = 0x43 then INKEY = 73 'I
	movlw	67
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF31
	movlw	73
	movwf	INKEY
ENDIF31
;if ScanCode = 0x3B then INKEY = 74
	movlw	59
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF32
	movlw	74
	movwf	INKEY
ENDIF32
;if ScanCode = 0x42 then INKEY = 75 'K
	movlw	66
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF33
	movlw	75
	movwf	INKEY
ENDIF33
;if ScanCode = 0x4B then INKEY = 76
	movlw	75
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF34
	movlw	76
	movwf	INKEY
ENDIF34
;if ScanCode = 0x3A then INKEY = 77 'M
	movlw	58
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF35
	movlw	77
	movwf	INKEY
ENDIF35
;if ScanCode = 0x31 then INKEY = 78
	movlw	49
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF36
	movlw	78
	movwf	INKEY
ENDIF36
;if ScanCode = 0x44 then INKEY = 79 'O
	movlw	68
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF37
	movlw	79
	movwf	INKEY
ENDIF37
;if ScanCode = 0x4D then INKEY = 80
	movlw	77
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF38
	movlw	80
	movwf	INKEY
ENDIF38
;if ScanCode = 0x15 then INKEY = 81 'Q
	movlw	21
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF39
	movlw	81
	movwf	INKEY
ENDIF39
;if ScanCode = 0x2D then INKEY = 82
	movlw	45
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF40
	movlw	82
	movwf	INKEY
ENDIF40
;if ScanCode = 0x1B then INKEY = 83 'S
	movlw	27
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF41
	movlw	83
	movwf	INKEY
ENDIF41
;if ScanCode = 0x2C then INKEY = 84
	movlw	44
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF42
	movlw	84
	movwf	INKEY
ENDIF42
;if ScanCode = 0x3C then INKEY = 85 'U
	movlw	60
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF43
	movlw	85
	movwf	INKEY
ENDIF43
;if ScanCode = 0x2A then INKEY = 86
	movlw	42
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF44
	movlw	86
	movwf	INKEY
ENDIF44
;if ScanCode = 0x1D then INKEY = 87 'W
	movlw	29
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF45
	movlw	87
	movwf	INKEY
ENDIF45
;if ScanCode = 0x22 then INKEY = 88
	movlw	34
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF46
	movlw	88
	movwf	INKEY
ENDIF46
;if ScanCode = 0x35 then INKEY = 89 'Y
	movlw	53
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF47
	movlw	89
	movwf	INKEY
ENDIF47
;if ScanCode = 0x1A then INKEY = 90 'Z
	movlw	26
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF48
	movlw	90
	movwf	INKEY
ENDIF48
;If PS2KeyShift = PS2CapsLock Then
	clrw
	btfsc	PS2FLAGS,0
	xorlw	255
	btfsc	PS2FLAGS,4
	xorlw	255
	btfss	STATUS,Z
	goto	ENDIF49
;If INKEY >= 65 and INKEY <= 90 Then INKEY += 32
	movf	INKEY,W
	movwf	SysCalcTempA
	movlw	65
	movwf	SysCalcTempB
	call	SysCompLessThan
	comf	SysCalcTempX,F
	movf	SysCalcTempX,W
	movwf	SysTemp1
	movf	INKEY,W
	movwf	SysCalcTempB
	movlw	90
	movwf	SysCalcTempA
	call	SysCompLessThan
	comf	SysCalcTempX,F
	movf	SysTemp1,W
	andwf	SysCalcTempX,W
	movwf	SysTemp2
	btfss	SysTemp2,0
	goto	ENDIF74
	movlw	32
	addwf	INKEY,F
ENDIF74
;End If
ENDIF49
;If PS2KeyShift Then
	btfss	PS2FLAGS,0
	goto	ELSE50_1
;if ScanCode = 0x0E then INKEY = "~"
	movlw	14
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF75
	movlw	126
	movwf	INKEY
ENDIF75
;if ScanCode = 0x4E then INKEY = "_"
	movlw	78
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF76
	movlw	95
	movwf	INKEY
ENDIF76
;if ScanCode = 0x55 then INKEY = "+"
	movlw	85
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF77
	movlw	43
	movwf	INKEY
ENDIF77
;if ScanCode = 0x5D then INKEY = "|"
	movlw	93
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF78
	movlw	124
	movwf	INKEY
ENDIF78
;if ScanCode = 0x4c then INKEY = ":"
	movlw	76
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF79
	movlw	58
	movwf	INKEY
ENDIF79
;if ScanCode = 0x52 then INKEY = 34
	movlw	82
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF80
	movlw	34
	movwf	INKEY
ENDIF80
;if ScanCode = 0x41 then INKEY = "<"
	movlw	65
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF81
	movlw	60
	movwf	INKEY
ENDIF81
;if ScanCode = 0x49 then INKEY = ">"
	movlw	73
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF82
	movlw	62
	movwf	INKEY
ENDIF82
;if ScanCode = 0x4A then INKEY = "?"
	movlw	74
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF83
	movlw	63
	movwf	INKEY
ENDIF83
;if ScanCode = 0x54 then INKEY = "{"
	movlw	84
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF84
	movlw	123
	movwf	INKEY
ENDIF84
;if ScanCode = 0x5B then INKEY = "}"
	movlw	91
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF85
	movlw	125
	movwf	INKEY
ENDIF85
;Else
	goto	ENDIF50
ELSE50_1
;if ScanCode = 0x0E then INKEY = 96 '`
	movlw	14
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF86
	movlw	96
	movwf	INKEY
ENDIF86
;if ScanCode = 0x4E then INKEY = 45 '-
	movlw	78
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF87
	movlw	45
	movwf	INKEY
ENDIF87
;if ScanCode = 0x55 then INKEY = 61 '=
	movlw	85
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF88
	movlw	61
	movwf	INKEY
ENDIF88
;if ScanCode = 0x5D then INKEY = 92 '\
	movlw	93
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF89
	movlw	92
	movwf	INKEY
ENDIF89
;if ScanCode = 0x4c then INKEY = 59 ';
	movlw	76
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF90
	movlw	59
	movwf	INKEY
ENDIF90
;if ScanCode = 0x52 then INKEY = 39 ''
	movlw	82
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF91
	movlw	39
	movwf	INKEY
ENDIF91
;if ScanCode = 0x41 then INKEY = 44 ',
	movlw	65
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF92
	movlw	44
	movwf	INKEY
ENDIF92
;if ScanCode = 0x49 then INKEY = 46 '.
	movlw	73
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF93
	movlw	46
	movwf	INKEY
ENDIF93
;if ScanCode = 0x4A then INKEY = 47 '/
	movlw	74
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF94
	movlw	47
	movwf	INKEY
ENDIF94
;if ScanCode = 0x54 then INKEY = "["
	movlw	84
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF95
	movlw	91
	movwf	INKEY
ENDIF95
;if ScanCode = 0x5B then INKEY = "]"
	movlw	91
	subwf	SCANCODE,W
	btfss	STATUS, Z
	goto	ENDIF96
	movlw	93
	movwf	INKEY
ENDIF96
;End If
ENDIF50
;End If
ENDIF11
;End If
ENDIF7
	return

;********************************************************************************

FN_PS2READBYTE
;PS2ReadByte = 0
	clrf	PS2READBYTE
;Dir PS2Clock In
	banksel	TRISIO
	bsf	TRISIO,1
;Wait 25 us
	movlw	16
	movwf	DELAYTEMP
DelayUS1
	decfsz	DELAYTEMP,F
	goto	DelayUS1
	nop
;PS2Bit = 0
	banksel	PS2BIT
	clrf	PS2BIT
;Do While PS2Clock = On
SysDoLoop_S4
	btfss	GPIO,1
	goto	SysDoLoop_E4
;If PS2Bit > 200 Then
	movf	PS2BIT,W
	sublw	200
	btfss	STATUS, C
;Goto PS2ReadByteDone
	goto	PS2READBYTEDONE
;End If
;Wait 10 us
	movlw	6
	movwf	DELAYTEMP
DelayUS2
	decfsz	DELAYTEMP,F
	goto	DelayUS2
	nop
;PS2Bit += 10
	movlw	10
	addwf	PS2BIT,F
;Loop
	goto	SysDoLoop_S4
SysDoLoop_E4
;If PS2Data = ON Then Goto PS2ReadByteDone
	btfsc	GPIO,0
	goto	PS2READBYTEDONE
;Wait Until PS2Clock = ON
SysWaitLoop1
	btfss	GPIO,1
	goto	SysWaitLoop1
;For PS2Bit = 1 to 8
	clrf	PS2BIT
SysForLoop2
	incf	PS2BIT,F
;wait until PS2Clock = OFF
SysWaitLoop2
	btfsc	GPIO,1
	goto	SysWaitLoop2
;ROTATE PS2ReadByte RIGHT
	rrf	PS2READBYTE,F
;PS2ReadByte.7 = PS2Data
	bcf	PS2READBYTE,7
	btfsc	GPIO,0
	bsf	PS2READBYTE,7
;wait until PS2Clock = ON
SysWaitLoop3
	btfss	GPIO,1
	goto	SysWaitLoop3
;Next
	movlw	8
	subwf	PS2BIT,W
	btfss	STATUS, C
	goto	SysForLoop2
SysForLoopEnd2
;wait until PS2Clock = OFF
SysWaitLoop4
	btfsc	GPIO,1
	goto	SysWaitLoop4
;wait until PS2Clock = ON
SysWaitLoop5
	btfss	GPIO,1
	goto	SysWaitLoop5
;wait until PS2Clock = OFF
SysWaitLoop6
	btfsc	GPIO,1
	goto	SysWaitLoop6
;wait until PS2Clock = ON
SysWaitLoop7
	btfss	GPIO,1
	goto	SysWaitLoop7
PS2READBYTEDONE
;DIR PS2Clock Out
	banksel	TRISIO
	bcf	TRISIO,1
;Set PS2Clock Off
	banksel	GPIO
	bcf	GPIO,1
;Wait 100 us
	movlw	66
	movwf	DELAYTEMP
DelayUS3
	decfsz	DELAYTEMP,F
	goto	DelayUS3
	nop
;Wait PS2_DELAY
	movlw	10
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	goto	Delay_MS

;********************************************************************************

PS2SYNCKBLEDS
;PS2Value = 0
	clrf	PS2VALUE
;If PS2NumLock Then PS2Value.1 = On
	btfsc	PS2FLAGS,3
	bsf	PS2VALUE,1
;If PS2CapsLock Then PS2Value.2 = On
	btfsc	PS2FLAGS,4
	bsf	PS2VALUE,2
;If PS2ScrollLock Then PS2Value.0 = On
	movf	PS2SCROLLLOCK,F
	btfss	STATUS,Z
	bsf	PS2VALUE,0
;PS2WriteByte (0xED)
	movlw	237
	movwf	PS2BYTE
	call	PS2WRITEBYTE
;PS2Parity = PS2ReadByte
	call	FN_PS2READBYTE
	movf	PS2READBYTE,W
	movwf	PS2PARITY
;PS2WriteByte (PS2Value)
	movf	PS2VALUE,W
	movwf	PS2BYTE
	call	PS2WRITEBYTE
;PS2Parity = PS2ReadByte
	call	FN_PS2READBYTE
	movf	PS2READBYTE,W
	movwf	PS2PARITY
	return

;********************************************************************************

PS2WRITEBYTE
;Dir PS2Data Out
	banksel	TRISIO
	bcf	TRISIO,0
;Set PS2Data Off
	banksel	GPIO
	bcf	GPIO,0
;Wait 10 us
	movlw	6
	movwf	DELAYTEMP
DelayUS4
	decfsz	DELAYTEMP,F
	goto	DelayUS4
	nop
;Dir PS2Clock In
	banksel	TRISIO
	bsf	TRISIO,1
;PS2Bit = 0
	banksel	PS2BIT
	clrf	PS2BIT
;Do While PS2Clock = On
SysDoLoop_S5
	btfss	GPIO,1
	goto	SysDoLoop_E5
;For PS2Parity = 1 to 10
	clrf	PS2PARITY
SysForLoop3
	incf	PS2PARITY,F
;Wait 10 us
	movlw	6
	movwf	DELAYTEMP
DelayUS5
	decfsz	DELAYTEMP,F
	goto	DelayUS5
	nop
;If PS2Clock = Off Then Exit Do
	btfss	GPIO,1
	goto	SysDoLoop_E5
;Next
	movlw	10
	subwf	PS2PARITY,W
	btfss	STATUS, C
	goto	SysForLoop3
SysForLoopEnd3
;PS2Bit += 1
	incf	PS2BIT,F
;If PS2Bit > 200 Then Goto PS2WriteByteDone
	movf	PS2BIT,W
	sublw	200
	btfss	STATUS, C
	goto	PS2WRITEBYTEDONE
;Loop
	goto	SysDoLoop_S5
SysDoLoop_E5
;PS2Parity = 0
	clrf	PS2PARITY
;For PS2Bit = 1 to 8
	clrf	PS2BIT
SysForLoop4
	incf	PS2BIT,F
;If PS2Byte.0 = Off then
	btfsc	PS2BYTE,0
	goto	ELSE106_1
;Set PS2Data off
	bcf	GPIO,0
;Else
	goto	ENDIF106
ELSE106_1
;Set PS2Data on
	bsf	GPIO,0
;PS2Parity += 1
	incf	PS2PARITY,F
;End If
ENDIF106
;ROTATE PS2Byte RIGHT
	rrf	PS2BYTE,F
;Wait until PS2Clock = On
SysWaitLoop8
	btfss	GPIO,1
	goto	SysWaitLoop8
;wait until PS2Clock = Off
SysWaitLoop9
	btfsc	GPIO,1
	goto	SysWaitLoop9
;Next
	movlw	8
	subwf	PS2BIT,W
	btfss	STATUS, C
	goto	SysForLoop4
SysForLoopEnd4
;If PS2Parity.0 = off then Set PS2Data on
	btfss	PS2PARITY,0
	bsf	GPIO,0
;If PS2Parity.0 = on then Set PS2Data off
	btfsc	PS2PARITY,0
	bcf	GPIO,0
;wait until PS2Clock = On
SysWaitLoop10
	btfss	GPIO,1
	goto	SysWaitLoop10
;wait until PS2Clock = Off
SysWaitLoop11
	btfsc	GPIO,1
	goto	SysWaitLoop11
;Dir PS2Data In
	banksel	TRISIO
	bsf	TRISIO,0
;Wait Until PS2Data = Off
SysWaitLoop12
	banksel	GPIO
	btfsc	GPIO,0
	goto	SysWaitLoop12
;wait until PS2Clock = OFF
SysWaitLoop13
	btfsc	GPIO,1
	goto	SysWaitLoop13
;wait until PS2Clock = ON
SysWaitLoop14
	btfss	GPIO,1
	goto	SysWaitLoop14
PS2WRITEBYTEDONE
;Dir PS2Clock Out
	banksel	TRISIO
	bcf	TRISIO,1
;Set PS2Clock Off
	banksel	GPIO
	bcf	GPIO,1
;Wait 100 us
	movlw	66
	movwf	DELAYTEMP
DelayUS6
	decfsz	DELAYTEMP,F
	goto	DelayUS6
	nop
;Wait PS2_DELAY
	movlw	10
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	goto	Delay_MS

;********************************************************************************

SYSCOMPEQUAL
;Dim SysCalcTempA, SysCalcTempB, SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;movf SysCalcTempA, W
	movf	SYSCALCTEMPA, W
;subwf SysCalcTempB, W
	subwf	SYSCALCTEMPB, W
;btfsc STATUS, Z
	btfsc	STATUS, Z
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SYSCOMPLESSTHAN
;Dim SysCalcTempA, SysCalcTempB, SysCalcTempX as byte
;clrf SysCalcTempX
	clrf	SYSCALCTEMPX
;bsf STATUS, C
	bsf	STATUS, C
;movf SysCalcTempB, W
	movf	SYSCALCTEMPB, W
;subwf SysCalcTempA, W
	subwf	SYSCALCTEMPA, W
;btfss STATUS, C
	btfss	STATUS, C
;comf SysCalcTempX,F
	comf	SYSCALCTEMPX,F
	return

;********************************************************************************

SysStringTables
	movf	SysStringA_H,W
	movwf	PCLATH
	movf	SysStringA,W
	incf	SysStringA,F
	btfsc	STATUS,Z
	incf	SysStringA_H,F
	movwf	PCL

StringTable2
	retlw	1
	retlw	33	;!


StringTable3
	retlw	1
	retlw	64	;


StringTable4
	retlw	1
	retlw	35	;#


StringTable5
	retlw	1
	retlw	36	;$


StringTable6
	retlw	1
	retlw	37	;%


StringTable7
	retlw	1
	retlw	94	;^


StringTable8
	retlw	1
	retlw	38	;&


StringTable9
	retlw	1
	retlw	42	;*


StringTable10
	retlw	1
	retlw	40	;(


StringTable11
	retlw	1
	retlw	41	;)


StringTable12
	retlw	1
	retlw	126	;~


StringTable13
	retlw	1
	retlw	95	;_


StringTable14
	retlw	1
	retlw	43	;+


StringTable15
	retlw	1
	retlw	124	;|


StringTable16
	retlw	1
	retlw	58	;:


StringTable17
	retlw	1
	retlw	60	;<


StringTable18
	retlw	1
	retlw	62	;>


StringTable19
	retlw	1
	retlw	63	;?


StringTable20
	retlw	1
	retlw	123	;{


StringTable21
	retlw	1
	retlw	125	;}


StringTable22
	retlw	1
	retlw	91	;[


StringTable23
	retlw	1
	retlw	93	;]


;********************************************************************************


 END
